	.INCSRC "defs.asm"

	.asctable
cleartable
32		=	$02
"A".."Z"        =       $03
"a".."z"        =       $1E
	.end
	

GENERIC_GRAPHIC_DECOMPRESSOR	equ	$C3FFFA
TABLE_$C2FE6D			equ	$C2FE6D



	.base $7E5000
	;*************************************************************************************************************************
	;******* 						RUTINA $7E/5000							********
	;******* ESta rutina se ejecuta para mostrar la introduccin con el logo de FFVI, las nubes y los rayos.		********												********
	;*************************************************************************************************************************
RUTINA_$7E5000
	JMP.w	!SCENE_FFVI_MAINSCREEN



	;*************************************************************************************************************************
	;******* 						RUTINA $7E/5003							********
	;******* Esta rutina se llama cuando se ha de ejecutar el cdigo de la introduccin en la que los personajes se	********
	;******* dirigen a Narhse por la nieve tras la conversacin inicial.							********
	;*************************************************************************************************************************
RUTINA_$7E5003
	JMP.w	!SCENE_PATH_TO_NARSHE




	;*************************************************************************************************************************
	;******* 						RUTINA $7E/5006							********
	;******* Esta rutina se llama cuando se ha de ejecutar la escena en la que el continente se derrumba.		********
	;*************************************************************************************************************************
RUTINA_$7E5006
	JMP.w	!SCENE_WORLD_COLLAPSE




	;*************************************************************************************************************************
	;******* 						RUTINA $7E/5009							********
	;*************************************************************************************************************************
RUTINA_$7E5009
	JMP.w	!RUTINA_$7E6C7E







	;*************************************************************************************************************************
	;*************************************************************************************************************************
	;*************************************************************************************************************************
	;******* 						RUTINA $7E/500C							********
	;*************************************************************************************************************************
	;*************************************************************************************************************************
	;*************************************************************************************************************************
SCENE_FFVI_MAINSCREEN
	PHP
	REP	#$30
	PHA
	PHX
	PHY
	PHB
	PHD
	;******* inicializamos los registros DB, DP y los vectores NMI e IRQ
	JSR.w	!INITIALIZE_DB_DP_NMI_IRQ
	;******* inicializamos todos los registros de la PPU
	JSR.w	!INITIALIZE_ALL_PPU_REGISTERS
	TDC
	;******* reproducimos un sonido
	JSR.w	!RUTINA_$7E5090
	JSR.w	!INIT_RAM_BUFFER_N_VARIABLES
	JSR.w	!ERASE_FULL_VRAM
	JSR.w	!INIT_OAM_BUFFER_N_CALLBACK
	JSR.w	!INITIALIZE_VRAM_FFVI_MAINSCREEN
	JSR.w	!RUTINA_$7E50A5
	;******* reproducimos un sonido
	JSR.w	!RUTINA_$7E5040
	;******* forzamos el blanking y ponemos la pantalla al mximo de brillo; tambin paramos todos los DMAs y las
	;******* interrupciones
	JSR.w	!RUTINA_$7E504B
	REP	#$30
	PLD
	PLB
	PLY
	PLX
	PLA
	PLP
	RTL





	;*************************************************************************************************************************
	;******* 						RUTINA $7E/502C							********
	;******* Inicializamos los registros DB, DP y los vectores de interrupcin NMI ($7E:71BF) e IRQ ($7F:71F0).	********
	;*************************************************************************************************************************
INITIALIZE_DB_DP_NMI_IRQ
	SEP	#$20
	;******* ponemos el banco de datos a $7E
	LDA.b	#$7E
	PHA
	PLB
	;******* ponemos la pgina directa a 0
	LDX.w	#$0000
	PHX
	PLD
	;******* metemos un cero en la posicin cero de la memoria
	STX.b	$00
	;******* creamos los saltos para el NMI y el IRQ
	BRA	RUTINA_$7E505F





	;***********************************************************************************************************************
	;******* 						RUTINA $7E/5040						********
	;***********************************************************************************************************************
RUTINA_$7E5040
	LDA.b	#$F0
RUTINA_$7E5042
	STA.l	$001300
	JSR.l	$C50004
	RTS









	;*************************************************************************************************************************
	;******* 						RUTINA $7E/504B							********
	;*************************************************************************************************************************
RUTINA_$7E504B
	;******* forzamos el blanking aunque ponemos el brillo de la pantalla al mximo
	LDA.b	#$8F
	STA.l	$002100
	;******* deshabilitamos el NMI y el IRQ
	TDC
	STA.l	$004200
	;******* paramos las transferencias DMA
	STA.l	$00420B
	;******* paramos las transferencias HDMA
	STA.l	$00420C
	RTS









	;*************************************************************************************************************************
	;******* 						RUTINA $7E/505F							********
	;******* Esta rutina establece el vector de interrupcin apuntando $7E:71BF y el de IRQ a $7F:71F0.			********
	;*************************************************************************************************************************
RUTINA_$7E505F
	;******* metemos el valor hexadecimal de la instruccin JMP.l (JML)
	LDA.b	#$5C
	STA.w	$1500
	STA.w	$1504
	;******* el vector NMI apuntar a $7E:71BF
	LDX.w	#!RUTINA_NMI_INTRO_SCENE
	STX.w	$1501
	;******* el vector IRQ apuntar a $7E:71F0
	LDX.w	#!RUTINA_$7E71F0
	STX.w	$1505
	LDA.b	#^RUTINA_NMI_INTRO_SCENE
	STA.w	$1503
	STA.w	$1507
	RTS










	;*************************************************************************************************************************
	;******* 							RUTINA $7E/5090						********
	;*************************************************************************************************************************
RUTINA_$7E5090
	STA.l	$001302
	LDA.b	#$02
	STA.l	$001301
	LDA.b	#$10
	BRA	RUTINA_$7E5042






	;*************************************************************************************************************************
	;******* 						RUTINA $7E/50A5							********
	;*************************************************************************************************************************
RUTINA_$7E50A5
	TDC
	LDA.b	$19  
	BMI	Tag_$7E50C2
	ASL	A
	TAX
	JSR.w	(!ROUTINE_TABLE_$7E50DC,x)
	LDA.b	$06  
	BIT.b	#$80
	BNE	Tag_$7E50BD
	JSR.w	!EXECUTE_CALLBACK_EVENT_LIST
	JSR.w	!WAIT_NMI_AND_READ_CONTROLLER
	BRA	RUTINA_$7E50A5
Tag_$7E50BD
	LDA.b	#$FF
	STA.w	$0200
Tag_$7E50C2
	LDY.w	#$000F
	STY.b	$15  
	LDA.b	#$00
	LDY.w	#!RUTINA_$7E5554
	JSR.w	!INSERT_ROUTINE_IN_CALLBACK_LIST
Tag_$7E50CF
	LDY.b	$15  
	BEQ	Tag_$7E50DB
	JSR.w	!EXECUTE_CALLBACK_EVENT_LIST
	JSR.w	!WAIT_NMI_AND_READ_CONTROLLER
	BRA	Tag_$7E50CF
Tag_$7E50DB
	RTS




ROUTINE_TABLE_$7E50DC
	.dcw	!RUTINA_$7E50F4, !RUTINA_$7E51CF, !RUTINA_$7E51E6, !RUTINA_$7E51FD, !RUTINA_$7E5237, !RUTINA_$7E526A
	.dcw	!RUTINA_$7E529D, !RUTINA_$7E52D5, !RUTINA_$7E52E8, !RUTINA_$7E52FA, !RUTINA_$7E5313, !RUTINA_$7E531A






	;*************************************************************************************************************************
	;******* Esta rutina se usa para ahorrar espacio.										********
	;*************************************************************************************************************************
RUTINA_COPIA_COMUN
	LDX.w	#$3000
	LDY.w	#!TABLE_$7E73F1
	JSR.w	!COPY_32BYTES_FROM_REGY_TO_REGX
	LDX.w	#$3040
	LDY.w	#!TABLE_$7E73F1
	JSR.w	!COPY_32BYTES_FROM_REGY_TO_REGX
	LDX.w	#$3060
	LDY.w	#!TABLE_$7E73F1
	JSR.w	!COPY_32BYTES_FROM_REGY_TO_REGX
	LDX.w	#$30E0
	LDY.w	#!TABLE_$7E73F1
	JSR.w	!COPY_32BYTES_FROM_REGY_TO_REGX
	RTS


	

	;*************************************************************************************************************************
	;******* 							RUTINA $7E/50F4						********
	;*************************************************************************************************************************
RUTINA_$7E50F4
	;******* copiamos 32 bytes desde $7E:73D1 a $7E:31D0
	LDX.w	#$3100
	LDY.w	#!TABLE_$7E73D1
	JSR.w	!COPY_32BYTES_FROM_REGY_TO_REGX
	LDX.w	#$3120
	LDY.w	#!TABLE_$7E7B25
	JSR.w	!COPY_32BYTES_FROM_REGY_TO_REGX
	LDX.w	#$3140
	LDY.w	#!TABLE_$7E7B05
	JSR.w	!COPY_32BYTES_FROM_REGY_TO_REGX
;	LDX.w	#$3000
;	LDY.w	#!TABLE_$7E73F1
;	JSR.w	!COPY_32BYTES_FROM_REGY_TO_REGX
	LDX.w	#$3020
	LDY.w	#!TABLE_$7E7B85
	JSR.w	!COPY_32BYTES_FROM_REGY_TO_REGX
	LDX.w	#$30C0
	LDY.w	#!TABLE_$7E73F1
	JSR.w	!COPY_32BYTES_FROM_REGY_TO_REGX
;	LDX.w	#$3040
;	LDY.w	#!TABLE_$7E73F1
;	JSR.w	!COPY_32BYTES_FROM_REGY_TO_REGX
;	LDX.w	#$3060
;	LDY.w	#!TABLE_$7E73F1
;	JSR.w	!COPY_32BYTES_FROM_REGY_TO_REGX
;	LDX.w	#$30E0
;	LDY.w	#!TABLE_$7E73F1
;	JSR.w	!COPY_32BYTES_FROM_REGY_TO_REGX
	;******* rutina de copia comn con otras escenas
	JSR.w	!RUTINA_COPIA_COMUN
	LDX.w	#$30A0
	LDY.w	#!TABLE_$7E73F1
	JSR.w	!COPY_32BYTES_FROM_REGY_TO_REGX
	LDX.w	#$30C0
	LDY.w	#!TABLE_$7E7BC5
	LDA.b	#$04
	JSR.w	!RUTINA_$7E72C6
	LDX.w	#$3040
	LDY.w	#!TABLE_$7E7BE5
	LDA.b	#$04
	JSR.w	!RUTINA_$7E72C6
	LDX.w	#$3060
	LDY.w	#!TABLE_$7E7BE5
	LDA.b	#$04
	JSR.w	!RUTINA_$7E72C6
	LDX.w	#$30E0
	LDY.w	#!TABLE_$7E7C05
	LDA.b	#$04
	JSR.w	!RUTINA_$7E72C6
	LDX.w	#$30A0
	LDY.w	#!TABLE_$7E7BA5
	LDA.b	#$04
	JSR.w	!RUTINA_$7E72C6
	LDA.b	#$01
	LDY.w	#!RUTINA_$7E54EB
	JSR.w	!INSERT_ROUTINE_IN_CALLBACK_LIST
	;******* contador de 1 segundo
.IF PAL_VERSION = 1
	LDY.w	#50
.ELSE
	LDY.w	#60
.ENDIF
	STY.b	$15  
	INC.b	$19
	;******* pantalla al mximo nivel de brillo
	LDA.b	#$0F
	STA.b	$32  
	LDA.b	#$01
	LDY.w	#!RUTINA_$7E557C
	JSR.w	!INSERT_ROUTINE_IN_CALLBACK_LIST
	REP	#$20
	LDA.w	#$3040
	STA.w	$3701,x
	SEP	#$20
	LDA.b	#$01
	LDY.w	#!RUTINA_$7E557C
	JSR.w	!INSERT_ROUTINE_IN_CALLBACK_LIST
	REP	#$20
	LDA.w	#$3060
	STA.w	$3701,x
	SEP	#$20
	LDA.b	#$01
	LDY.w	#!RUTINA_$7E557C
	JSR.w	!INSERT_ROUTINE_IN_CALLBACK_LIST
	REP	#$20
	LDA.w	#$30C0
	STA.w	$3701,x
	SEP	#$20
	RTS






	;*************************************************************************************************************************
	;******* 						RUTINA $7E/51CF							********
	;*************************************************************************************************************************
RUTINA_$7E51CF
	LDY.b	$15  
	BNE	Tag_$7E51E5
	INC.b	$19
.IF PAL_VERSION = 1
	LDY.w	#$038E
.ELSE
	LDY.w	#$0443
.ENDIF
	STY.b	$15  
	LDA.b	#$FF
	STA.l	$001305
	LDA.b	#$FF
	JSR.w	!RUTINA_$7E5090
Tag_$7E51E5
	RTS






	;*************************************************************************************************************************
	;******* 						RUTINA $7E/51E6							********
	;*************************************************************************************************************************
RUTINA_$7E51E6
	LDY.b	$15  
	BNE	Tag_$7E51FC
	JSR.w	!SET_INDIR_HDMA_CHANNELS_2_3_4
	LDA.b	#$00
	LDY.w	#!RUTINA_$7E5323
	JSR.w	!INSERT_ROUTINE_IN_CALLBACK_LIST
	;******* temporizacin de medio segundo
.IF PAL_VERSION = 1
	LDY.w	#25
.ELSE
	LDY.w	#30
.ENDIF
	STY.b	$15  
	INC.b	$19  
Tag_$7E51FC
	RTS








	;*************************************************************************************************************************
	;******* 						RUTINA $7E/51FD							********
	;*************************************************************************************************************************
RUTINA_$7E51FD
	LDY.b	$15  
	BNE	Tag_$7E5236
	LDA.b	#$00
	LDY.w	#!RUTINA_$7E5379
	JSR.w	!INSERT_ROUTINE_IN_CALLBACK_LIST
	LDA.b	#$00
	LDY.w	#!RUTINA_$7E53E5
	JSR.w	!INSERT_ROUTINE_IN_CALLBACK_LIST
	LDA.b	#$00
	LDY.w	#!RUTINA_$7E5463
	JSR.w	!INSERT_ROUTINE_IN_CALLBACK_LIST
	LDX.w	#$3000
	LDY.w	#!TABLE_$7E7B45
	LDA.b	#$02
	JSR.w	!RUTINA_$7E72C6
	LDX.w	#$3020
	LDY.w	#!TABLE_$7E7B65
	LDA.b	#$01
	JSR.w	!RUTINA_$7E72C6
.IF PAL_VERSION = 1
	LDY.w	#$0113
.ELSE
	LDY.w	#$014A
.ENDIF
	STY.b	$15  
	INC.b	$19  
Tag_$7E5236
	RTS










	;*************************************************************************************************************************
	;******* 						RUTINA $7E/5237							********
	;*************************************************************************************************************************
RUTINA_$7E5237
	LDY.b	$15  
	BNE	Tag_$7E5269
	INC.b	$19
.IF PAL_VERSION = 1
	LDY.w	#$00C8
.ELSE
	LDY.w	#$00F0
.ENDIF
	STY.b	$15  
	LDA.b	#$00
	LDY.w	#!RUTINA_$7E7667
	JSR.w	!INSERT_ROUTINE_IN_CALLBACK_LIST
	REP	#$20
	LDA.w	#!TABLE_$7E79F6
	STA.w	$3500,x
	SEP	#$20
	LDA.b	#$38
	STA.w	$3301,x
	LDA.b	#$1F
	STA.w	$3401,x
	LDX.w	#$3100
	LDY.w	#!TABLE_$7E7AE5
	LDA.b	#$08
	JSR.w	!RUTINA_$7E72C6
Tag_$7E5269
	RTS








	;*************************************************************************************************************************
	;******* 							RUTINA $7E/526A						********
	;*************************************************************************************************************************
RUTINA_$7E526A
	LDY.b	$15  
	BNE	Tag_$7E529C
	INC.b	$19
.IF PAL_VERSION = 1
	LDY.w	#$0320
.ELSE
	LDY.w	#$03C0
.ENDIF
	STY.b	$15  
	LDA.b	#$00
	LDY.w	#!RUTINA_$7E7667
	JSR.w	!INSERT_ROUTINE_IN_CALLBACK_LIST
	REP	#$20
	LDA.w	#!TABLE_$7E79F9
	STA.w	$3500,x
	SEP	#$20
	LDA.b	#$48
	STA.w	$3301,x
	LDA.b	#$A8
	STA.w	$3401,x
	LDX.w	#$3120
	LDY.w	#!TABLE_$7E7B05
	LDA.b	#$04
	JSR.w	!RUTINA_$7E72C6
Tag_$7E529C
	RTS









	;*************************************************************************************************************************
	;******* 						RUTINA $7E/529D							********
	;*************************************************************************************************************************
RUTINA_$7E529D
	LDY.b	$15  
	BNE	Tag_$7E52D4
	INC.b	$19
.IF PAL_VERSION = 1
	LDY.w	#$00D6
.ELSE
	LDY.w	#$0100
.ENDIF
	STY.b	$15  
	LDX.w	#$3100
	LDY.w	#!TABLE_$7E7B25
	LDA.b	#$02
	JSR.w	!RUTINA_$7E72C6
	LDX.w	#$3120
	LDY.w	#!TABLE_$7E7B25
	LDA.b	#$04
	JSR.w	!RUTINA_$7E72C6
	LDX.w	#$3000
	LDY.w	#!TABLE_$7E7B25
	LDA.b	#$08
	JSR.w	!RUTINA_$7E72C6
	LDX.w	#$3020
	LDY.w	#!TABLE_$7E7B25
	LDA.b	#$08
	JSR.w	!RUTINA_$7E72C6
Tag_$7E52D4
	RTS







	;*************************************************************************************************************************
	;******* 						RUTINA $7E/52D5							********
	;*************************************************************************************************************************
RUTINA_$7E52D5
	LDY.b	$15  
	BNE	Tag_$7E52E7
	LDA.b	#$40
	TSB.b	$33  
	INC.b	$19  
	LDY.w	#$0001
	STY.b	$15  
	JSR.w	!RUTINA_$7E5C71
Tag_$7E52E7
	RTS







	;*************************************************************************************************************************
	;******* 						RUTINA $7E/52E8							********
	;*************************************************************************************************************************
RUTINA_$7E52E8
	LDY.b	$15
	BNE	Tag_$7E52F9
	INC.b	$19
	STZ.b	$31
	LDA.b	#$80
	STA.b	$33
.IF PAL_VERSION = 1
	LDY.w	#$0305
.ELSE
	LDY.w	#$03A0
.ENDIF
	STY.b	$15
Tag_$7E52F9
	RTS









	;*************************************************************************************************************************
	;******* 						RUTINA $7E/52FA							********
	;*************************************************************************************************************************
RUTINA_$7E52FA
	LDY.b	$15  
	BNE	Tag_$7E5306
.IF PAL_VERSION = 1
	LDY.w	#$0190
.ELSE
	LDY.w	#$01E0
.ENDIF
	STY.b	$15  
	INC.b	$19  
	RTS
Tag_$7E5306
	LDA.b	$18  
	AND.b	#$03
	BNE	Tag_$7E5312
	REP	#$20
	INC.b	$27  
	SEP	#$20
Tag_$7E5312
	RTS






	;*************************************************************************************************************************
	;******* 						RUTINA $7E/5313							********
	;*************************************************************************************************************************
RUTINA_$7E5313
	LDY.b	$15  
	BNE	Tag_$7E5319
	INC.b	$19
Tag_$7E5319
	RTS






	;*************************************************************************************************************************
	;******* 						RUTINA $7E/531A							********
	;******* Esta rutina termina la ejecucin de la rutina principal de eventos ("_EXEC") poniendo la variable a $FF	********
	;******* para indicar la finalizacin.											********
	;*************************************************************************************************************************
RUTINA_$7E531A
	LDA.b	#$FF
	STA.b	$19  
	TDC
	STA.w	$0200
	RTS






	;*************************************************************************************************************************
	;******* 						RUTINA $7E/5323							********
	;*************************************************************************************************************************
RUTINA_$7E5323
	TAX
	JMP.w	(!ROUTINE_TABLE_$7E5327,x)


ROUTINE_TABLE_$7E5327
	.dcw	!RUTINA_$7E532B, !RUTINA_$7E535D





	;*************************************************************************************************************************
	;******* 						RUTINA $7E/532B							********
	;*************************************************************************************************************************
RUTINA_$7E532B
	LDX.b	$1D  
	INC.w	$3A00,x
	REP	#$20
	TDC
	TAX
Tag_$7E5334
	LDA.l	$7F8CA0,x
	ADC.w	#$0780
	STA.w	$4780,x
	INX
	INX
	CPX.w	#$0040
	BNE	Tag_$7E5334
	LDX.b	$1D  
	LDA.w	#$0002
	STA.w	$3900,x
	SEP	#$20
	LDY.w	#$05A0
	STY.b	$10  
	LDA.b	#$7E
	STA.b	$14  
	LDY.w	#$4780
	STY.b	$12
RUTINA_$7E535D
	LDX.b	$1D 
	REP	#$20
	LDA.w	$3900,x
	CMP.w	#$0040
	BEQ	Tag_$7E5375
	STA.b	$0E  
	INC.w	$3900,x
	INC.w	$3900,x
	SEP	#$20
	SEC
	RTS
Tag_$7E5375
	SEP	#$20
	CLC
	RTS






	;*************************************************************************************************************************
	;******* 						RUTINA $7E/5379							********
	;*************************************************************************************************************************
RUTINA_$7E5379
	TAX
	JMP.w	(!ROUTINE_TABLE_$7E537D,x)



ROUTINE_TABLE_$7E537D
	.dcw	!RUTINA_$7E5381, !RUTINA_$7E5389



	


	;*************************************************************************************************************************
	;******* 						RUTINA $7E/5381							********
	;*************************************************************************************************************************
RUTINA_$7E5381
	LDX.b	$1D  
	INC.w	$3A00,x
	STZ.w	$3701,x
RUTINA_$7E5389
	LDA.b	$33  
	BMI	Tag_$7E53E3
	LDX.b	$1D  
	TDC
	TAY
	STZ.w	$3801,x
Tag_$7E5394
	LDX.b	$1D  
	LDA.w	$3701,x
	CLC
	ADC.w	$3801,x
	JSR.w	!RUTINA_$7E5459
	PHA
Tag_$7E53A1
	LDA.l	$004212
	AND.b	#$40
	BEQ	Tag_$7E53A1
	LDA.b	#$08
	STA.l	$00211B
	TDC
	STA.l	$00211B
	PLA
	STA.l	$00211C
	STA.l	$00211C
	LDX.b	$1D  
	REP	#$20
	LDA.l	$002135
	STA.w	$4180,y
	SEP	#$20
	LDX.b	$1D  
	LDA.w	$3801,x
	CLC
	ADC.b	#$04
	STA.w	$3801,x
	INY
	INY
	INY
	INY
	CPY.w	#$00C0
	BNE	Tag_$7E5394
	INC.w	$3701,x
	SEC
	RTS
Tag_$7E53E3
	CLC
	RTS






	;*************************************************************************************************************************
	;******* 						RUTINA $7E/53E5							********
	;*************************************************************************************************************************
RUTINA_$7E53E5
	TAX
	JMP.w	(!ROUTINE_TABLE_$7E53E9,x)



ROUTINE_TABLE_$7E53E9
	.dcw	!RUTINA_$7E53ED, !RUTINA_$7E53F5








	;*************************************************************************************************************************
	;******* 						RUTINA $7E/53ED							********
	;*************************************************************************************************************************
RUTINA_$7E53ED
	LDX.b	$1D  
	INC.w	$3A00,x
	STZ.w	$3900,x
RUTINA_$7E53F5
	LDA.b	$33  
	BMI	Tag_$7E5454
	LDX.b	$1D  
	TDC
	TAY
	LDA.b	#$10
	STA.w	$3801,x
Tag_$7E5402
	LDX.b	$1D  
	LDA.w	$3701,x
	CLC
	ADC.w	$3801,x
	JSR.w	!RUTINA_$7E5459
	PHA
Tag_$7E540F
	LDA.l	$004212
	AND.b	#$40
	BEQ	Tag_$7E540F
	LDA.b	#$0A
	STA.l	$00211B
	TDC
	STA.l	$00211B
	PLA
	STA.l	$00211C
	STA.l	$00211C
	LDX.b	$1D  
	REP	#$20
	LDA.l	$002135
	STA.w	$4500,y
	STA.w	$4502,y
	SEP	#$20
	LDX.b	$1D  
	LDA.w	$3801,x
	CLC
	ADC.b	#$04
	STA.w	$3801,x
	INY
	INY
	INY
	INY
	CPY.w	#$00C0
	BNE	Tag_$7E5402
	INC.w	$3701,x
	SEC
	RTS
Tag_$7E5454
	CLC
	RTS







	;***********************************************************************************************************************
	;******* 						RUTINA $7E/5456						********
	;***********************************************************************************************************************
RUTINA_$7E5456
	CLC
	ADC.b	#$40
RUTINA_$7E5459
	XBA
	LDA.b	$00  
	XBA
	TAX
	LDA.l	TABLE_$C2FE6D,x
	RTS






	;***********************************************************************************************************************
	;******* 						RUTINA $7E/5463						********
	;***********************************************************************************************************************
RUTINA_$7E5463
	TAX
	JMP.w	(!ROUTINE_TABLE_$7E5467,x)



ROUTINE_TABLE_$7E5467
	.dcw	!RUTINA_$7E546B, !RUTINA_$7E5475







	;*************************************************************************************************************************
	;******* 						RUTINA $7E/546B							********
	;*************************************************************************************************************************
RUTINA_$7E546B
	LDX.b	$1D  
	INC.w	$3A00,x
	LDA.b	#$01
	STA.w	$3900,x
RUTINA_$7E5475
	LDA.b	$18  
	AND.b	#$01
	BEQ	Tag_$7E548A
	LDX.b	$1D  
	LDA.w	$3900,x
	CMP.b	#$2A
	BEQ	Tag_$7E548C
	JSR.w	!RUTINA_$7E548E
	INC.w	$3900,x
Tag_$7E548A
	SEC
	RTS
Tag_$7E548C
	CLC
	RTS







	;*************************************************************************************************************************
	;******* 						RUTINA $7E/548E							********
	;*************************************************************************************************************************
RUTINA_$7E548E
	LDA.b	#$2A
	STA.l	$004205
	TDC
	STA.l	$004204
	LDA.w	$3900,x
	STA.l	$004206
;	NOP
;	NOP
;	NOP
;	NOP
	NOP
	STZ.b	$F2
	STZ.b	$E2
	STZ.b	$E9
	STZ.b	$EA
	LDY.w	#$00A0
	LDA.l	$004215
	STA.b	$E8
	LDA.l	$004214
	STA.b	$E7
Tag_$7E54BC
	LDA.w	$3900,x
	CMP.b	$E2  
	BCC	Tag_$7E54C5
	BRA	Tag_$7E54CC
Tag_$7E54C5
	REP	#$20
	LDA.w	#$0100
	BRA	Tag_$7E54D8
Tag_$7E54CC
	TDC
	LDA.b	$EA
	SEC
	SBC.b	$E2
	REP	#$20
	EOR.w	#$FFFF
	INC	A
Tag_$7E54D8
	STA.w	$3DFA,y
	LDA.b	$E7
	CLC
	ADC.b	$E9
	STA.b	$E9  
	SEP	#$20
	INC.b	$E2  
	DEY
	DEY
	DEY
	DEY
	BNE	Tag_$7E54BC
	RTS





	;*************************************************************************************************************************
	;******* 						RUTINA $7E/54EB							********
	;*************************************************************************************************************************
RUTINA_$7E54EB
	TAX
	JMP.w	(!ROUTINE_TABLE_$7E54F1,x)


ROUTINE_TABLE_$7E54F1
	.dcw	!RUTINA_$7E54F5, !RUTINA_$7E550D





	;*************************************************************************************************************************
	;******* 						RUTINA $7E/54F5							********
	;*************************************************************************************************************************
RUTINA_$7E54F5
	LDY.w	#$FFFF
	STY.b	$10  
	LDY.w	#$0040
	STY.b	$0E  
	LDA.b	#$7F
	STA.b	$14  
	LDY.w	#$0001
	STY.b	$27
	LDX.b	$1D
	;******* incrementamos la variable para que la siguiente ejecucin se ejecute la segunda rutina
	INC.w	$3A00,x
RUTINA_$7E550D
	LDA.b	$18
	AND.b	#$03
	BNE	Tag_$7E5549
	REP	#$20
	LDA.b	$27
	CMP.w	#$011F
	BEQ	Tag_$7E554B
	CMP.w	#$0100
	BCS	Tag_$7E5545
	AND.w	#$0007
	BNE	Tag_$7E5545
	LDA.b	$27
	SEC
	SBC.w	#$0008
	AND.w	#$FFF8
	ASL	A
	ASL	A
	ASL	A
	CLC
	ADC.w	#$23C0
	STA.b	$12
	LDA.b	$27
	SEC
	SBC.w	#$0008
	AND.w	#$FFF8
	ASL	A
	ASL	A
	STA.b	$10
Tag_$7E5545
	INC.b	$27
	SEP	#$20
Tag_$7E5549
	SEC
	RTS
Tag_$7E554B
	SEP	#$20
	LDY.w	#$FFFF
	STY.b	$10
	CLC
	RTS





	;*************************************************************************************************************************
	;******* 						RUTINA $7E/5554							********
	;******* Esta rutina realiza un fundido a negro durante 15 frames tocando el brillo del registro $2100.		********
	;******* Si entramos por la primera rutina de las dos, establecemos el brillo de la pantalla a 15 (mximo) y 	********
	;******* actualizamos los parmetros $3301 con el contador a 15 y el parmetro $3A00 con el valor 1 para que las 	********
	;******* siguientes veces se ejecute la segunda rutina, que ir decrementando poco a poco con cada llamada el	********
	;******* brillo de la pantalla hasta llevarla a 0.									********
	;*************************************************************************************************************************
RUTINA_$7E5554
	TAX
	JMP.w	(!ROUTINE_TABLE_$7E5558,x)


ROUTINE_TABLE_$7E5558
	.dcw	!RUTINA_$7E555C, !RUTINA_$7E5566






	;*************************************************************************************************************************
	;******* 						RUTINA $7E/555C							********
	;*************************************************************************************************************************
RUTINA_$7E555C
	LDX.b	$1D
	;******* incrementamos la variable para que la siguiente ejecucin se ejecute la segunda rutina
	INC.w	$3A00,x
	LDA.b	#$0F
	STA.w	$3301,x
RUTINA_$7E5566
	;******* comprobamos el contador de frames
	LDY.b	$15
	BEQ	Tag_$7E5576
	LDX.b	$1D
	;******* actualizamos el registro $32 con el brillo decreciente de la pantalla para ir a negro progresivamente
	LDA.w	$3301,x
	STA.b	$32
	DEC.w	$3301,x
	SEC
	RTS
	;******* SI EL CONTADOR DE FRAMES $15 HA LLEGADO A CERO, APAGAMOS LA PANTALLA CON EL BLANKING FORZADO Y SALIMOS CON
	;******* EL CARRY A '0'
Tag_$7E5576
	LDA.b	#$80
	STA.b	$32
	CLC
	RTS





	;*************************************************************************************************************************
	;******* 						RUTINA $7E/557C							********
	;*************************************************************************************************************************
RUTINA_$7E557C
	TAX
	JMP.w	(!ROUTINE_TABLE_$7E5580,x)



ROUTINE_TABLE_$7E5580
	.dcw	!RUTINA_$7E5586, !RUTINA_$7E559F, !RUTINA_$7E55D4






	;*************************************************************************************************************************
	;******* 						RUTINA $7E/5586							********
	;*************************************************************************************************************************
RUTINA_$7E5586
	LDX.b	$1D
	;******* incrementamos la variable para que la siguiente ejecucin se ejecute la segunda rutina
	INC.w	$3A00,x
	LDA.b	#$80
	STA.w	$3600,x
Tag_$7E5590
	REP	#$20
	LDA.w	#!TABLE_$7E55F2
	STA.w	$3500,x
	SEP	#$20
	JSR.w	!RUTINA_$7E74EB
	SEC
	RTS






	;*************************************************************************************************************************
	;******* 						RUTINA $7E/559F							********
	;*************************************************************************************************************************
RUTINA_$7E559F
	LDX.b	$1D
	LDA.w	$3600,x
	BEQ	Tag_$7E55BD
	CMP.b	#$01
	BEQ	Tag_$7E55B1
Tag_$7E55AA
	LDX.b	$1D
	DEC.w	$3600,x
	SEC
	RTS
Tag_$7E55B1
	LDA.b	#$02
	LDY.w	#!RUTINA_$7E56AD
	JSR.w	!INSERT_ROUTINE_IN_CALLBACK_LIST
	INC.b	$36
	BRA	Tag_$7E55AA
Tag_$7E55BD
	LDA.w	$3B01,x
	CMP.b	#$FE
	BNE	Tag_$7E55C7
	INC.w	$3A00,x
Tag_$7E55C7
	REP	#$20
	LDA.w	$3701,x
	TAX
	SEP	#$20
	JSR.w	!RUTINA_$7E7501
	SEC
	RTS





	;*************************************************************************************************************************
	;******* 						RUTINA $7E/55D4							********
	;*************************************************************************************************************************
RUTINA_$7E55D4
	JSR.w	!RUTINA_$7E55E4
	LDX.b	$1D
	STA.w	$3600,x
	LDA.b	#$01
	STA.w	$3A00,x
	JMP.w	!Tag_$7E5590






	;*************************************************************************************************************************
	;******* 						RUTINA $7E/55E4							********
	;*************************************************************************************************************************
RUTINA_$7E55E4
	TDC
	INC.b	$34
	LDA.b	$18
	CLC
	ADC.b	$34
	TAX
	LDA.l	$C0FD00,x
	RTS



TABLE_$7E55F2
	.dcw	!TABLE_$7E7BE5
	.dcb	$01
	.dcw	!TABLE_$7E560D
	.dcb	$02
	.dcw	!TABLE_$7E568D
	.dcb	$01
	.dcw	!TABLE_$7E560D
	.dcb	$02
	.dcw	!TABLE_$7E568D
	.dcb	$01
	.dcw	!TABLE_$7E562D
	.dcb	$02
	.dcw	!TABLE_$7E564D
	.dcb	$03
	.dcw	!TABLE_$7E566D
	.dcb	$04
	.dcw	!TABLE_$7E568D
	.dcb	$FE

	

TABLE_$7E560D
	.dcb	$63, $10, $DE, $66, $5B, $56, $B4, $45, $2E, $35, $08, $31, $E8, $2C, $C7, $28
	.dcb	$A6, $24, $A5, $1C, $84, $18, $64, $14, $63, $10, $BB, $21, $36, $11, $7F, $73


TABLE_$7E562D
	.dcb	$00, $00, $39, $52, $D7, $45, $51, $39, $EC, $2C, $E7, $2C, $C7, $28, $A6, $24
	.dcb	$85, $20, $84, $18, $84, $14, $64, $14, $63, $10, $BB, $21, $36, $11, $7B, $5A


TABLE_$7E564D
	.dcb	$00, $00, $94, $3D, $53, $35, $EE, $2C, $AA, $24, $A5, $24, $85, $20, $64, $1C
	.dcb	$64, $14, $63, $10, $63, $10, $63, $10, $63, $10, $BB, $21, $36, $11, $D6, $45


TABLE_$7E566D
	.dcb	$00, $00, $AA, $20, $A7, $20, $85, $1C, $43, $18, $63, $10, $63, $10, $63, $10
	.dcb	$63, $10, $63, $10, $63, $10, $63, $10, $63, $10, $BB, $21, $36, $11, $CC, $24


TABLE_$7E568D
	.dcb	$00, $00, $63, $10, $63, $10, $63, $10, $63, $10, $63, $10, $63, $10, $63, $10
	.dcb	$63, $10, $63, $10, $63, $10, $63, $10, $63, $10, $BB, $21, $36, $11, $63, $10







	;*************************************************************************************************************************
	;******* 						RUTINA $7E/56AD							********
	;*************************************************************************************************************************
RUTINA_$7E56AD
	TAX
	JMP.w	(!ROUTINE_TABLE_$7E56B1,x)


ROUTINE_TABLE_$7E56B1
	.dcw	!RUTINA_$7E56B5, !RUTINA_$7E56EA




	;*************************************************************************************************************************
	;******* 						RUTINA $7E/56B5							********
	;*************************************************************************************************************************
RUTINA_$7E56B5
	LDX.b	$1D
	INC.w	$3A00,x
	JSR.w	!RUTINA_$7E55E4
	AND.b	#$03
	BEQ	Tag_$7E56F8
	ASL	A
	TAX
	REP	#$20
	LDA.w	!TABLE_$7E56FA,x
	LDX.b	$1D
	STA.w	$3500,x
	SEP	#$20
	SEP	#$20
	PHX
	JSR.w	!RUTINA_$7E55E4
	PLX
	STA.w	$3301,x
	PHX
	JSR.w	!RUTINA_$7E55E4
	PLX
	AND.b	#$7F
	ADC.b	#$10
	STA.w	$3401,x
	LDX.b	$1D
	JSR.w	!RUTINA_$7E74EB
RUTINA_$7E56EA
	LDX.b	$1D
	LDA.w	$3B01,x
	CMP.b	#$FE
	BEQ	Tag_$7E56F8
	JSR.w	!RUTINA_$7E7519
	SEC
	RTS
Tag_$7E56F8
	CLC
	RTS


TABLE_$7E56FA
	.dcw	$0000, !TABLE_$7E5702, !TABLE_$7E571A, !TABLE_$7E5702

TABLE_$7E5702
	.dcw	!TABLE_$7E5733
	.dcb	$01
	.dcw	!TABLE_$7E5732
	.dcb	$01
	.dcw	!TABLE_$7E5738
	.dcb	$01
	.dcw	!TABLE_$7E5732
	.dcb	$01
	.dcw	!TABLE_$7E5745
	.dcb	$01
	.dcw	!TABLE_$7E5732
	.dcb	$01
	.dcw	!TABLE_$7E5752
	.dcb	$01
	.dcw	!TABLE_$7E5732
	.dcb	$FE

TABLE_$7E571A
	.dcw	!TABLE_$7E575F
	.dcb	$01	
	.dcw	!TABLE_$7E5732
	.dcb	$01
	.dcw	!TABLE_$7E5764
	.dcb	$01
	.dcw	!TABLE_$7E5732
	.dcb	$01	
	.dcw	!TABLE_$7E5771
	.dcb	$01
	.dcw	!TABLE_$7E5732
	.dcb	$01
	.dcw	!TABLE_$7E577E
	.dcb	$01
	.dcw	!TABLE_$7E5732
	.dcb	$FE


TABLE_$7E5732
	.dcb	$00
	

TABLE_$7E5733
	.dcb	$01, $08, $00, $4C, $35


TABLE_$7E5738
	.dcb	$03, $00, $00, $4E, $35, $10, $00, $60, $35, $08, $10, $62, $35


TABLE_$7E5745
	.dcb	$03, $08, $00, $64, $35, $08, $10, $66, $35, $08, $20, $68, $35


TABLE_$7E5752
	.dcb	$03, $08, $00, $6A, $35, $08, $10, $6C, $35, $08, $20, $6E, $35


TABLE_$7E575F
	.dcb	$01, $08, $00, $4C, $75


TABLE_$7E5764
	.dcb	$03, $10, $00, $4E, $75, $08, $00, $60, $75, $08, $10, $62, $75


TABLE_$7E5771
	.dcb	$03, $08, $00, $64, $75, $08, $10, $66, $75, $08, $20, $68, $75


TABLE_$7E577E
	.dcb	$03, $08, $00, $6A, $75, $08, $10, $6C, $75, $08, $20, $6E, $75



TABLE_$7E578B
	.dcb	$40, $A8, $40, $70, $B0, $48, $68, $A8, $70, $68, $60, $A8, $80, $D0
	.dcb	$88, $58, $90, $A8, $98, $88, $50, $58, $70, $60, $90, $60, $10, $78







	;*************************************************************************************************************************
	;*************************************************************************************************************************
	;*************************************************************************************************************************
	;******* 						RUTINA $7E/57A7							********
	;******* Esta rutina es la que se encarga de mostrar todos los grficos y los crditos iniciales cuando los 3	********
	;******* personajes se dirigen con las Armaduras Magitek a Narshe por la nieve.					********
	;*************************************************************************************************************************
	;*************************************************************************************************************************
	;*************************************************************************************************************************
SCENE_PATH_TO_NARSHE
	PHP
	REP #$30
	PHA
	PHX
	PHY
	PHB
	PHD
	;******* inicializamos los registros de datos y de pgina directa y ponemos los vectores de interrupcin NMI e IRQ
	JSR.w	!INITIALIZE_DB_DP_NMI_IRQ
	;******* inicializamos de forma genrica todos los registros de la PPU
	JSR.w	!INITIALIZE_ALL_PPU_REGISTERS
	;******* inicializamos de forma especfica los registros necesarios para el modo 7 para esta escena
	JSR.w	!INITIALIZE_PPU_PATH_TO_NARSHE
	;******* configuramos el audio
	LDA.b	#$FF
	STA.l	$001302
	LDA.b	#$04
	STA.l	$001301
	LDA.b	#$10
	STA.l	$001300
	JSR.l	$C50004
	;******* inicializamos diferentes partes de la memoria RAM
	JSR.w	!INIT_RAM_BUFFER_N_VARIABLES
	;******* borramos toda la VRAM
	JSR.w	!ERASE_FULL_VRAM
	;******* inicializamos la tabla OAM en RAM $7E:0300 y borramos la zona de memoria a partir de $7E:3200
	JSR.w	!INIT_OAM_BUFFER_N_CALLBACK
	;******* creamos los tilemaps en RAM $7F:B800 y $7F:A800 y los enviamos a VRAM $0000 y $2000
	JSR.w	!TILEMAP_BUFFERS_PATH_TO_NARSHE
	;******* esta rutina ejecuta todas las acciones para actualizar los grficos de las armaduras Magitek andando y 
	;******* para mostrar los crditos, y solo se sale de ella si se acaba la intro o se pulsa el botn "A"
	JSR.w	!SCENE_PATH_TO_NARSHE_EXEC
	;******* paramos el sonido
	JSR.w	!RUTINA_$7E5040
	;******* forzamos el blanking y ponemos la pantalla al mximo de brillo; tambin paramos todos los DMAs y las
	;******* interrupciones
	JSR.w	!RUTINA_$7E504B
	REP	#$30
	PLD
	PLB
	PLY
	PLX
	PLA
	PLP
	RTL








	;*************************************************************************************************************************
	;*************************************************************************************************************************
	;******* 						RUTINA $7E/57F0							********
	;******* Esta rutina establece el modo 7 de 1024x1024 pxeles de extensin cubierto por un nico tilemap que se	********
	;******* encuentra en 0x7800 (BG0); las tiles correspondientes al tilemap estn en $2000. Este modo se establece	********
	;******* para la escena de la intro en la que las Armaduras Magitek caminan por la nieve hacia Narshe, donde el	********
	;******* fondo completo es Modo 7 en BG0, las armaduras son sprites y las letras de los crditos estn en BG2.	********
	;*************************************************************************************************************************
	;*************************************************************************************************************************
INITIALIZE_PPU_PATH_TO_NARSHE
	PHB
	LDA.B	#$00
	PHA
	PLB
	;****** NAME_SELECT = 0 / NAME_BASE_SELECT = 0 / SPRITES 16x16 y 32x32
	LDA.b	#$03
	STA.w	$2101
	;****** OAM_ADDRESS = 0
	LDX.b	$00  
	STX.w	$2102
	;****** BG_MODE = 7 / TODOS LOS BACKGROUND CON TILES 8x8 / BG0 DE 256 COLORES
	LDA.b	#$07
	STA.w	$2105
	;****** BG0 -> TILEMAP_ADDRESS = 0x7800 / PANTALLA FORMADA POR UN NICO TILEMAP 32x32
	LDA.b	#$78
	STA.w	$2107
	;****** BG1 -> TILEMAP_ADDRESS = 0x7C00 / PANTALLA FORMADA POR UN NICO TILEMAP 32x32
	LDA.b	#$7C
	STA.w	$2108
	;****** BG2 -> TILEMAP_ADDRESS = 0x7400 / PANTALLA FORMADA POR UN NICO TILEMAP 32x32
	LDA.b	#$74
	STA.w	$2109
	;****** BG3 -> TILEMAP_ADDRESS = 0x7400 / PANTALLA FORMADA POR UN NICO TILEMAP 32x32
	STA.w	$210A
	;****** BG0 -> BASE_ADDRESS = 0x2000 / BG1 -> BASE_ADDRESS = 0x2000
	LDA.b	#$22
	STA.w	$210B
	;****** BG2 -> BASE_ADDRESS = 0x7000 / BG3 -> BASE_ADDRESS = 0x7000
	LDA.b	#$77
	STA.w	$210C
	;****** MODE 7 -> PLAYFIELD DE 1024x1024 COMPLETAMENTE CUBIERTO POR EL TILEMAP SIN MIRRORING
	;****** VERTICAL NI HORIZONTAL
	TDC
	STA.w	$211A
	PLB
	RTS






	;*************************************************************************************************************************
	;*************************************************************************************************************************
	;******* 							RUTINA $7E/5826						********
	;******* Esta rutina ejecuta toda la escena de la intro cuando los sprites de las armaduras Magitek se desplazan	********
	;******* por la nieve. Mientras no se pulsa el botn "A" para salir de la rutina, se va ejecutando una de las 4	********
	;******* rutinas en "ROUTINE_TABLE_$7E5861" para crear la animacin y mostrar los crditos en BG2.			********
	;*************************************************************************************************************************
	;*************************************************************************************************************************
SCENE_PATH_TO_NARSHE_EXEC
	TDC
	LDA.b	$19
	BMI	Tag_$7E5843
	ASL	A
	TAX
	JSR.w	(!ROUTINE_TABLE_$7E5861,x)
	;******* comprobamos la variable que indica si ha habido un cambio de pulsacin en el mando 1 entre los dos ltimos NMIs
	LDA.b	$06
	;******* comprobamos si se ha pulsado el botn "A"
	BIT.b	#$80
	BNE	Tag_$7E583E
	;*************************************************************************************************************************
	;******* SI NO SE HA PULSADO EL BOTN "A" EN EL MANDO 1
	;******* ejecutamos las funciones en la lista de eventos
	JSR.w	!EXECUTE_CALLBACK_EVENT_LIST
	;******* esperamos al NMI para actualizar el video y leemos el mando de control para actualizar la variable $06
	JSR.w	!WAIT_NMI_AND_READ_CONTROLLER
	BRA	SCENE_PATH_TO_NARSHE_EXEC
	;*************************************************************************************************************************
	;******* SI SE HA PULSADO EL BOTN "A" EN EL MANDO 1 -> PONEMOS LA PANTALLA A NEGRO Y SALIMOS DE LA RUTINA
Tag_$7E583E
	LDA.b	#$FF
	STA.w	$0200
Tag_$7E5843
	;******* contador de 15 frames para poner la pantalla en negro progresivamente
	LDY.w	#$000F
	STY.b	$15
	;******* metemos la RUTINA_$7E5554 en el primer hueco libre del bloque de callback 0
	LDA.b	#$00
	LDY.w	#!RUTINA_$7E5554
	JSR.w	!INSERT_ROUTINE_IN_CALLBACK_LIST
	;******* BUCLE PARA LLEVAR LA PANTALLA A NEGRO
Tag_$7E5850
	;******* comprobamos si el contador de frames ha llegado a 0
	LDY.b	$15
	BEQ	Tag_$7E585C
	;******* ejecutamos las funciones en la lista de eventos
	JSR.w	!EXECUTE_CALLBACK_EVENT_LIST
	;******* esperamos al NMI para actualizar el video y leemos el mando de control para actualizar la variable $06; tambin
	;******* se actualiza el contador de frames $15
	JSR.w	!WAIT_NMI_AND_READ_CONTROLLER
	BRA	Tag_$7E5850
Tag_$7E585C
	JSR.l	$EE000C
	RTS



ROUTINE_TABLE_$7E5861
	.dcw	!RUTINA_$7E5869, !RUTINA_$7E5A00, !RUTINA_$7E5A1A, !RUTINA_$7E531A








	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/5869							********
	;******* Esta rutina se ejecuta la primera vez que se entra en "SCENE_PATH_TO_NARSHE_EXEC" para inicializar las	********
	;******* transferencias HDMA y dems grficos para la escena.								********
	;*************************************************************************************************************************
RUTINA_$7E5869
	JSR.w	!RUTINA_$7E5C24
	;******* configuramos las transferencias HDMA para la matriz de modo 7, la aritmtica de color y establecemos las pantallas
	;******* Main y Sub
	JSR.w	!RUTINA_$7E5B11
	PHB
	LDA.b	#$00
	PHA
	PLB
	JSR.l	$EE0009
	JSR.l	$EE0003
	PLB
	JSR.w	!RUTINA_$7E5BF9
	JSR.w	!INIT_OAM_BUFFER_N_CALLBACK
	LDX.w	#$3100
	LDY.w	#!TABLE_$7E73F1
	JSR.w	!COPY_32BYTES_FROM_REGY_TO_REGX
	LDX.w	#$3120
	LDY.w	#!TABLE_$7E73F1
	JSR.w	!COPY_32BYTES_FROM_REGY_TO_REGX
	LDX.w	#$3160
	LDY.w	#!TABLE_$7E73F1
	JSR.w	!COPY_32BYTES_FROM_REGY_TO_REGX
	LDX.w	#$3180
	LDY.w	#!TABLE_$7E73F1
	JSR.w	!COPY_32BYTES_FROM_REGY_TO_REGX
	LDX.w	#$31A0
	LDY.w	#!TABLE_$7E73F1
	JSR.w	!COPY_32BYTES_FROM_REGY_TO_REGX
;	LDX.w	#$3000
;	LDY.w	#!TABLE_$7E73F1
;	JSR.w	!COPY_32BYTES_FROM_REGY_TO_REGX
	LDX.w	#$3020
	LDY.w	#!TABLE_$7E73F1
	JSR.w	!COPY_32BYTES_FROM_REGY_TO_REGX
;	LDX.w	#$3040
;	LDY.w	#!TABLE_$7E73F1
;	JSR.w	!COPY_32BYTES_FROM_REGY_TO_REGX
;	LDX.w	#$3060
;	LDY.w	#!TABLE_$7E73F1
;	JSR.w	!COPY_32BYTES_FROM_REGY_TO_REGX
;	LDX.w	#$30E0
;	LDY.w	#!TABLE_$7E73F1
;	JSR.w	!COPY_32BYTES_FROM_REGY_TO_REGX
	;******* rutina de copia comn con otras escenas
	JSR.w	!RUTINA_COPIA_COMUN
	LDA.b	#$68
	STA.b	$39
	LDA.b	#$48
	STA.b	$3A
	LDA.b	#$78
	STA.b	$3B
	LDA.b	#$C0
	STA.b	$3C
	LDA.b	#$80
	STA.b	$3D
	LDA.b	#$90
	STA.b	$3E
	STZ.b	$29
	STZ.b	$2A
	LDY.w	#$0038
	STY.b	$2B
	STZ.b	$37
	STZ.b	$38
	LDA.b	#$00
	LDY.w	#!RUTINA_$7E5F6B
	JSR.w	!INSERT_ROUTINE_IN_CALLBACK_LIST
	TDC
	JSR.w	!RUTINA_$7E5ABC
	LDA.b	#$01
	JSR.w	!RUTINA_$7E5ABC
	LDA.b	#$02
	JSR.w	!RUTINA_$7E5ABC
	LDX.w	#$3120
	LDY.w	#!TABLE_$7E643B
	LDA.b	#$01
	JSR.w	!RUTINA_$7E72C6
	LDX.w	#$3160
	LDY.w	#!TABLE_$7E643B
	LDA.b	#$02
	JSR.w	!RUTINA_$7E72C6
	LDX.w	#$3180
	LDY.w	#!TABLE_$7E643B
	LDA.b	#$04
	JSR.w	!RUTINA_$7E72C6
	LDX.w	#$31A0
	LDY.w	#!TABLE_$7E643B
	LDA.b	#$06
	JSR.w	!RUTINA_$7E72C6
	LDX.w	#$3100
	LDY.w	#!TABLE_$7E641B
	LDA.b	#$03
	JSR.w	!RUTINA_$7E72C6
	LDX.w	#$3020
	LDY.w	#!TABLE_$7E63BB
	LDA.b	#$02
	JSR.w	!RUTINA_$7E72C6
	LDX.w	#$3040
	LDY.w	#!TABLE_$7E63DB
	LDA.b	#$02
	JSR.w	!RUTINA_$7E72C6
	LDX.w	#$3060
	LDY.w	#!TABLE_$7E63FB
	LDA.b	#$02
	JSR.w	!RUTINA_$7E72C6
	LDX.w	#$30E0
	LDY.w	#!TABLE_$7E7C05
	LDA.b	#$04
	JSR.w	!RUTINA_$7E72C6
	LDA.b	#$00
	LDY.w	#!RUTINA_$7E5ED2
	JSR.w	!INSERT_ROUTINE_IN_CALLBACK_LIST
	LDA.b	#$00
	LDY.w	#!RUTINA_$7E5AA1
	JSR.w	!INSERT_ROUTINE_IN_CALLBACK_LIST
	LDA.b	#$00
	LDY.w	#!RUTINA_$7E5A46
	JSR.w	!INSERT_ROUTINE_IN_CALLBACK_LIST
	TDC
	STA.w	$3901,x
	LDA.b	#$01
	STA.w	$3600,x
	LDA.b	#$5A
	STA.w	$3900,x
	REP	#$20
	LDA.w	#$FFA0
	STA.w	$3800,x
	SEP	#$20
	LDA.b	#$00
	LDY.w	#!RUTINA_$7E5A46
	JSR.w	!INSERT_ROUTINE_IN_CALLBACK_LIST
	LDA.b	#$01
	STA.w	$3901,x
	LDA.b	#$0A
	STA.w	$3600,x
	LDA.b	#$28
	STA.w	$3900,x
	REP	#$20
	LDA.w	#$FF60
	STA.w	$3800,x
	SEP	#$20
	LDA.b	#$00
	LDY.w	#!RUTINA_$7E5A46
	JSR.w	!INSERT_ROUTINE_IN_CALLBACK_LIST
	LDA.b	#$02
	STA.w	$3901,x
	LDA.b	#$07
	STA.w	$3600,x
	LDA.b	#$2D
	STA.w	$3900,x
	REP	#$20
	LDA.w	#$FF80
	STA.w	$3800,x
	SEP	#$20
	INC.b	$19
	LDA.b	#$01
	STA.b	$32
	JSR.w	!WAIT_NMI_AND_READ_CONTROLLER
.IF PAL_VERSION = 1
	;****** ponemos el contador de frames a 50 (1 seg) que pasan desde que empieza la escena hasta que se cargan los crditos (PAL)
	LDY.w	#$0052
.ELSE
	;****** ponemos el contador de frames a 322 (5 seg) que pasan desde que empieza la escena hasta que se cargan los crditos (NTSC)
	LDY.w	#$0142
.ENDIF
	STY.b	$15
	;****** ponemos la pantalla al mximo de brillo
	LDA.b	#$0F
	STA.b	$32
	RTS






	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/5A00							********
	;*************************************************************************************************************************
RUTINA_$7E5A00
	LDY.b	$15
	BNE	Tag_$7E5A16
	INC.b	$19
.IF PAL_VERSION = 1
	;******* duracin en frames de la escena con los crditos en pantalla en PAL (55 seg)
	LDY.w	#$0AB0
.ELSE
	;******* duracin en frames de la escena con los crditos en pantalla en NTSC (51 seg)
	LDY.w	#$0BF4
.ENDIF
	STY.b	$15
	LDA.b	#$00
	LDY.w	#!RUTINA_$7E5C96
	JSR.w	!INSERT_ROUTINE_IN_CALLBACK_LIST
	JSR.w	!RUTINA_$7E5C71
Tag_$7E5A16
	JSR.w	!SET_MODE7_ROTATION_CENTER
	RTS






	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/5A1A							********
	;******* Esta rutina comprueba el contador $15 y si ha llegado a 0,iIncrementa el valor de $19 para que la 	********
	;******* accin a ejecutar sea terminar la intro.										********
	;*************************************************************************************************************************
RUTINA_$7E5A1A
	LDY.b	$15
	BNE	Tag_$7E5A20
	;******* ponemos la variable a $03, que apunta a la rutina que termina la ejecucin de la intro
	INC.b	$19
Tag_$7E5A20
	JSR.w	!SET_MODE7_ROTATION_CENTER
	RTS









	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/5A2D							********
	;******* Esta rutina establece el centro del giro en Modo 7.								********
	;*************************************************************************************************************************
SET_MODE7_ROTATION_CENTER
	LDA.b	$3F
	STA.l	$00211F
	LDA.b	$40
	STA.l	$00211F
	LDA.b	$41
	STA.l	$002120
	LDA.b	$42
	STA.l	$002120
	RTS







	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/5A46							********
	;*************************************************************************************************************************
RUTINA_$7E5A46
	TAX
	JMP.w	(!ROUTINE_TABLE_$7E5A4A,x)



ROUTINE_TABLE_$7E5A4A
	.dcw	!RUTINA_$7E5A50, !RUTINA_$7E5A63, !RUTINA_$7E5A7A






	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/5A50							********
	;*************************************************************************************************************************
RUTINA_$7E5A50
	LDX.b	$1D
	INC.w	$3A00,x
	TDC
	LDA.w	$3901,x
	TAY
	LDA.w	$003C,y
	STA.w	$3401,x
	STZ.w	$3400,x
RUTINA_$7E5A63
	LDX.b	$1D
	LDA.w	$3600,x
	BNE	Tag_$7E5A75
	INC.w	$3A00,x
	LDA.w	$3900,x
	STA.w	$3600,x
	SEC
	RTS
Tag_$7E5A75
	DEC.w	$3600,x
	SEC
	RTS
	
	
	
	
	

	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/5A7A							********
	;*************************************************************************************************************************
RUTINA_$7E5A7A
	LDX.b	$1D
	LDA.w	$3600,x
	BEQ	Tag_$7E5A9F
	REP	#$20
	LDA.w	$3400,x
	CLC
	ADC.w	$3800,x
	STA.w	$3400,x
	SEP	#$20
	TDC
	LDA.w	$3901,x
	TAY
	LDA.w	$3401,x
	STA.w	$003C,y
	DEC.w	$3600,x
	SEC
	RTS
Tag_$7E5A9F
	CLC
	RTS






	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/5AA1							********
	;*************************************************************************************************************************
RUTINA_$7E5AA1
	LDA.b	$18
	AND.b	#$03
	BNE	Tag_$7E5AAF
	REP	#$20
	DEC.b	$41
	DEC.b	$27
	SEP	#$20
Tag_$7E5AAF
	LDA.b	$18
	AND.b	#$3F
	BNE	Tag_$7E5ABA
	LDY.b	$2B
	INY
	STY.b	$2B
Tag_$7E5ABA
	SEC
	RTS





	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/5ABC							********
	;*************************************************************************************************************************
RUTINA_$7E5ABC
	STA.b	$F4
	ASL	A
	ASL	A
	ASL	A
	STA.b	$F3
	LDY.b	$00
Tag_$7E5AC5
	PHY
	LDA.b	#$02
	LDY.w	#!RUTINA_$7E5F29
	JSR.w	!INSERT_ROUTINE_IN_CALLBACK_LIST
	LDA.b	$F4
	STA.w	$3900,x
	LDA.b	$F3
	STA.w	$3901,x
	PLY
	REP	#$20
	LDA.w	!TABLE_$7E5AF9,y
	STA.w	$3500,x
	SEP	#$20
	INY
	INY
	LDA.w	!TABLE_$7E5AF9,y
	STA.w	$3701,x
	INY
	LDA.w	!TABLE_$7E5AF9,y
	STA.w	$3801,x
	INY
	CPY.w	#$0018
	BNE	Tag_$7E5AC5
	RTS



TABLE_$7E5AF9
	.dcw	!TABLE_$7E5FDC
	.dcb	$04, $F8
	.dcw	!TABLE_$7E5FFF
	.dcb	$00, $00
	.dcw	!TABLE_$7E60CC
	.dcb	$FD, $E0
	.dcw	!TABLE_$7E613B
	.dcb	$FB, $E0
	.dcw	!TABLE_$7E602A
	.dcb	$04, $08
	.dcw	!TABLE_$7E607B
	.dcb	$04, $08








	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/5B11							********
	;******* Esta rutina pone en marcha los HDMAs de los canales 2 al 7 para establecer los parmetros de color,	********
	;******* scroll horizontal de BG1 y la matriz de rotacin del Modo 7 (transferencia indirecta). Tambin configura ********
	;******* las pantallas Main (activa las capas BG0, BG1, BG2 y Sprites) y Sub (solo BG2).				********
	;*************************************************************************************************************************
RUTINA_$7E5B11
	PHB
	LDA.b	#$00
	PHA
	PLB
	;******* activamos las capas de sprites, BG0, BG1 y BG2 para formar la MainScreen
	LDA.b	#$17
	STA.w	$212C
	;******* activamos la capa BG1 para formar la SubScreen
	LDA.b	#$02
	STA.w	$212D
	;******* intensidad de color a 0 en los tres planos RGB
	LDA.b	#$E0
	STA.w	$2132
	;************************************************************************************************************************
	;******* HDMA directo por el canal 2 al registro $2132 de color desde $7E:5BD7
	STZ.w	$4320
	LDA.b	#$32
	STA.w	$4321
	LDY.w	#!HDMA_TABLE_$7E5BD7
	STY.w	$4322
	LDA.b	#^HDMA_TABLE_$7E5BD7
	STA.w	$4324
	STA.w	$4327
	;************************************************************************************************************************
	;******* HDMA directo por el canal 3 al registro $2105 de modo BG desde $7E:5BF4	
	STZ.w	$4330
	LDA.b	#$05
	STA.w	$4331
	LDY.w	#!HDMA_TABLE_$7E5BF4
	STY.w	$4332
	LDA.b	#^HDMA_TABLE_$7E5BF4
	STA.w	$4334
	STA.w	$4337
	;************************************************************************************************************************
	;******* HDMA directo por el canal 4 al registro $2130 (y $2131) de aritmtica de color desde $7E:5BC2
	LDA.b	#$01
	STA.w	$4340
	LDA.b	#$30
	STA.w	$4341
	LDY.w	#!HDMA_TABLE_$7E5BC2
	STY.w	$4342
	LDA.b	#^HDMA_TABLE_$7E5BC2
	STA.w	$4344
	STA.w	$4347
	;************************************************************************************************************************
	;******* HDMA directo por el canal 5 al registro $2111 (dos veces) de scroll horizontal BG2 desde $7E:5BB5
	STA.w	$4354
	STA.w	$4357
	LDA.b	#$02
	STA.w	$4350
	LDA.b	#$11
	STA.w	$4351
	LDY.w	#!HDMA_TABLE_$7E5BB5
	STY.w	$4352
	;************************************************************************************************************************
	;******* HDMA indirecto por el canal 6 al registro $211B (dos veces) Y $211C (dos veces) de matriz Modo 7 desde $7E:5BC9
	LDA.b	#$43
	STA.w	$4360
	LDA.b	#$1B
	STA.w	$4361
	LDY.w	#!HDMA_TABLE_$7E5BC9
	STY.w	$4362
	LDA.b	#^HDMA_TABLE_$7E5BC9
	STA.w	$4364
	STA.w	$4367
	;************************************************************************************************************************
	;******* HDMA indirecto por el canal 7 al registro $211D (dos veces) Y $211E (dos veces) de matriz Modo 7 desde $7E:5BD0	
	LDA.b	#$43
	STA.w	$4370
	LDA.b	#$1D
	STA.w	$4371
	LDY.w	#!HDMA_TABLE_$7E5BD0
	STY.w	$4372
	LDA.b	#^HDMA_TABLE_$7E5BD0
	STA.w	$4374
	STA.w	$4377
	;******* activamos los canales 7 al 2 en la variable
	LDA.b	#$FC
	TSB.b	$31
	PLB
	RTS



	;******* el contenido de esta tabla HDMA se modifica desde la rutina que crea los crditos para modificar el registro
	;******* de scroll horizontal y as centrar el texto en pantalla
HDMA_TABLE_$7E5BB5
	.dcb	39
	.dcw	$00FF
	.dcb	16
	.dcw	$00FF
	.dcb	16
	.dcw	$00FF
	.dcb	16
	.dcw	$00FF
	.dcb 	0

	
HDMA_TABLE_$7E5BC2
	.dcb	84, $82, $04
	.dcb	01, $80, $81
	.dcb 	0


HDMA_TABLE_$7E5BC9
	;******* durante las primeras 100 lneas escribimos en el registro $211B (16 bits) y $211C (16 bits) en CADA LNEA
	;******* la informacin contenida en $7E:3CA0
	.dcb	(128+100)
	.dcw	$3CA0
	;******* durante las ltimas 123 lneas escribimos en el registro $211B (16 bits) y $211C (16 bits) en CADA LNEA
	;******* la informacin contenida en $7E:3E30
	.dcb	(128+123)
	.dcw	$3E30
	.dcb	0


HDMA_TABLE_$7E5BD0
	;******* durante las primeras 100 lneas escribimos en el registro $211D (16 bits) y $211E (16 bits) en CADA LNEA
	;******* la informacin contenida en $7E:4020
	.dcb	(128+100)
	.dcw	$4020
	;******* durante las ltimas 123 lneas escribimos en el registro $211D (16 bits) y $211E (16 bits) en CADA LNEA
	;******* la informacin contenida en $7E:41B0
	.dcb	(128+123)
	.dcw	$41B0
	.dcb	0
	

HDMA_TABLE_$7E5BD7
	.dcb	84, $E0
	.dcb	01, $ED
	.dcb	01, $EB
	.dcb	01, $EA
	.dcb	02, $E9
	.dcb	03, $E8
	.dcb	04, $E7
	.dcb	05, $E6
	.dcb	06, $E5
	.dcb	07, $E4
	.dcb	08, $E3
	.dcb	12, $E2
	.dcb	15, $E1
	.dcb	30, $E0
	.dcb 	0


HDMA_TABLE_$7E5BF4
	.dcb	84, $09
	.dcb	01, $07
	.dcb	0
	
	

	


	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/5BF9							********
	;*************************************************************************************************************************
RUTINA_$7E5BF9	
	TDC
	TAX
	TAY
	REP	#$20
Tag_$7E5BFE
	LDA.w	$0300,x
	STA.w	$3D00,y
	LDA.w	$0680,x
	STA.w	$4080,y
	INY
	INY
	LDA.w	$04C0,x
	STA.w	$3D00,y
	LDA.w	$0840,x
	STA.w	$4080,y
	INY
	INY
	INX
	INX
	CPX.w	#$01C0
	BNE	Tag_$7E5BFE
	SEP	#$20
	RTS







	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/5C24							********
	;*************************************************************************************************************************
RUTINA_$7E5C24
	LDY.w	#$0100
	STY.b	$3F
	LDY.w	#$0080
	STY.b	$41
	STY.b	$25
	TDC
	TAY
	STY.b	$27
	STZ.b	$72
	STZ.b	$73
	STZ.b	$74
	LDY.w	#$00E0
	STY.b	$87
	LDY.w	#$4000
	STY.b	$8B
	LDY.w	#$0000
	STY.b	$8D
	LDY.w	#$FFFF
	STY.b	$8F
	;******* borramos la zona de memoria entre $7E:4400 a $7E:4680 que es el tilemap para BG2 donde salen los crditos
	JSR.w	!RUTINA_$7E5C65
	LDY.w	#$7440
	STY.b	$10
	LDY.w	#$4400
	STY.b	$12
	LDA.b	#$7E
	STA.b	$14
	LDY.w	#$0280
	STY.b	$0E
	RTS










	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/5C65							********
	;*************************************************************************************************************************
RUTINA_$7E5C65
	TDC
	TAX
Tag_$7E5C67
	STZ.w	$4400,x
	INX
	CPX.w	#$0280
	BNE	Tag_$7E5C67
	RTS




	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/5C71							********
	;*************************************************************************************************************************
RUTINA_$7E5C71
	LDA.b	#$00
	LDY.w	#!RUTINA_$7E5C7A
	JSR.w	!INSERT_ROUTINE_IN_CALLBACK_LIST
	RTS






	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/5C7A							********
	;*************************************************************************************************************************
RUTINA_$7E5C7A
	LDA.b	$18
	AND.b	#$01
	BNE	Tag_$7E5C8B
	LDX.w	#$30E0
	LDY.w	#!TABLE_$7E7C05
	JSR.w	!COPY_32BYTES_FROM_REGY_TO_REGX
	BRA	Tag_$7E5C94
Tag_$7E5C8B
	LDX.w	#$30E0
	LDY.w	#!TABLE_$7E6443
	JSR.w	!COPY_32BYTES_FROM_REGY_TO_REGX
Tag_$7E5C94
	SEC
	RTS






	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/5C96							********
	;*************************************************************************************************************************
RUTINA_$7E5C96
	TAX
	JMP (!ROUTINE_TABLE_$7E5C9A,x)


ROUTINE_TABLE_$7E5C9A
	.dcw	!RUTINA_$7E5C9E, !RUTINA_$7E5CB0




	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/5C9E							********
	;*************************************************************************************************************************
RUTINA_$7E5C9E
	;******* incrementamos la variable para que la siguiente vez que se ejecute la rutina $7E/5C96 no se ejecute esta parte
	;******* de inicializacin
	LDX	$1D
	INC	$3A00,x
	REP	#$20
	;******* metemos el puntero a la tabla de punteros a cada texto de los crditos
	LDA	#!FULL_CREDITS_POINTER_$7E5CFB
	STA	$3500,x
	SEP	#$20
	;******* inicializamos a 0 la variable $7E:3B00, leemos el byte que sigue al puntero y lo metemos como parmetro en
	;******* $7E:3B01 y creamos el puntero ($EB) para desplazarnos por la tabla usando $7E:3B00 como ndice
	JSR.w	!RUTINA_$7E74EB
RUTINA_$7E5CB0
	;******* leemos el byte contador, cuyo valor inicial es el del byte que acompaa al puntero en la tabla
	LDX.b	$1D
	LDA.w	$3B01,x
	CMP.b	#$01
	BNE	Tag_$7E5CC4
	;******* SI EL BYTE CONTADOR ES 1
	LDX.w	#$3000
	LDY.w	#!TABLE_$7E63AB
	LDA.b	#$01
	JSR.w	!RUTINA_$7E72C6
Tag_$7E5CC4
	LDX.b	$1D
	LDA.w	$3B01,x
	CMP.b	#$20
	BNE	Tag_$7E5CD8
	;******* SI EL BYTE CONTADOR ES 32
	LDX.w	#$3000
	LDY.w	#!TABLE_$7E73F1
	LDA.b	#$01
	JSR.w	!RUTINA_$7E72C6
Tag_$7E5CD8
	LDX.b	$1D
	LDA.w	$3B01,x
	CMP.b	#$FE
	BEQ	Tag_$7E5CF9
	;******* SI EL BYTE CONTADOR NO ES $FE
	;******* en esta rutina decrementamos el contador $7E:3B01 y actualizamos el ndice $7E:3B00 para apuntar al
	;******* siguiente puntero de la tabla si el contador llega a 0
	JSR.w	!RUTINA_$7E751F
	SEP	#$10
	;******* leemos el ndice con el que estamos leyendo de la tabla de punteros
	LDA.w	$3B00,x
	TAY
	REP	#$20
	;******* leemos la posicin de inicio del texto de crdito, apuntando a los 2 primeros bytes que son la posicin
	;******* dentro del mapa donde se coloca dicho texto
	LDA.b	($EB),y
	STA.b	$E7
	REP	#$10
	SEP	#$20
	;******* creamos el tilemap para el texto del crdito
	JSR.w	!CREATE_CREDITS_TILEMAP_PTN
	SEC
	RTS
Tag_$7E5CF9
	CLC
	RTS

	
.IF PAL_VERSION = 1
	FRAMES_PER_CREDIT_TEXT	equ	$6C
.ELSE
	FRAMES_PER_CREDIT_TEXT	equ	$8B
.ENDIF


FULL_CREDITS_POINTER_$7E5CFB
	;******* crditos "PRODUCTOR"
	.dcw	!TEXT_PRODUCER_$7E6543
	.dcb	$01
	.dcw	!TEXT_PRODUCER_$7E6550
	.dcb	FRAMES_PER_CREDIT_TEXT
	.dcw	!TEXT_EMPTY_$7E5DC4
	.dcb	$01
	;******* crditos "DIRECTOR"
	.dcw	!TEXT_DIRECTOR_$7E6567
	.dcb	$01
	.dcw	!TEXT_DIRECTOR_$7E6574
	.dcb	FRAMES_PER_CREDIT_TEXT
	.dcw	!TEXT_EMPTY_$7E5DC4
	.dcb	$01
	;******* crditos "MAIN PROGRAMMER"
	.dcw	!TEXT_MAIN_PROGRAMMER_$7E6598
	.dcb	$01
	.dcw	!TEXT_MAIN_PROGRAMMER_$7E65AC
	.dcb	FRAMES_PER_CREDIT_TEXT
	.dcw	!TEXT_EMPTY_$7E5DC4
	.dcb	$01
	;******* crditos "GRAPHIC DIRECTOR" (I)
	.dcw	!TEXT_GRAPHIC_DIRECTOR_$7E65CC
	.dcb	$01
	.dcw	!TEXT_GRAPHIC_DIRECTOR_TILDE
	.dcb	$01
	.dcw	!TEXT_GRAPHIC_DIRECTOR_$7E65E1
	.dcb	FRAMES_PER_CREDIT_TEXT
	.dcw	!TEXT_EMPTY_$7E5DC4
	.dcb	$01
	;******* crditos "GRAPHIC DIRECTOR" (II)
	.dcw	!TEXT_GRAPHIC_DIRECTOR_$7E65CC
	.dcb	$01
	.dcw	!TEXT_GRAPHIC_DIRECTOR_TILDE
	.dcb	$01
	.dcw	!TEXT_GRAPHIC_DIRECTOR_$7E6608
	.dcb	FRAMES_PER_CREDIT_TEXT
	.dcw	!TEXT_EMPTY_$7E5DC4
	.dcb	$01
	;******* crditos "MUSIC"
	.dcw	!TEXT_MUSIC_$7E6629
	.dcb	$01
	.dcw	!TEXT_MUSIC_TILDE
	.dcb	$01
	.dcw	!TEXT_MUSIC_$7E6633
	.dcb	FRAMES_PER_CREDIT_TEXT
	.dcw	!TEXT_EMPTY_$7E5DC4
	.dcb	$01
	;******* crditos "IMAGE DESIGNER"
	.dcw	!TEXT_IMAGE_DESIGNER_$7E6645
	.dcb	$01
	.dcw	!TEXT_IMAGE_DESIGNER_TILDE
	.dcb	$01
	.dcw	!TEXT_IMAGE_DESIGNER_$7E6658
	.dcb	FRAMES_PER_CREDIT_TEXT
	.dcw	!TEXT_EMPTY_$7E5DC4
	.dcb	$01
	;******* crditos "BATTLE PLANNER"
	.dcw	!TEXT_BATTLE_PLANNER_$7E666C
	.dcb	$01
	.dcw	!TEXT_BATTLE_PLANNER_TILDE
	.dcb	$01
	.dcw	!TEXT_BATTLE_PLANNER_$7E667F
	.dcb	FRAMES_PER_CREDIT_TEXT
	.dcw	!TEXT_EMPTY_$7E5DC4
	.dcb	$01
	;******* crditos "FIELD PLANNER" (I)
	.dcw	!TEXT_FIELD_PLANNER_$7E66A2
	.dcb	$01
	.dcw	!TEXT_FIELD_PLANNER_$7E66B4
	.dcb	FRAMES_PER_CREDIT_TEXT
	.dcw	!TEXT_EMPTY_$7E5DC4
	.dcb	$01
	;******* crditos "FIELD PLANNER" (II)
	.dcw	!TEXT_FIELD_PLANNER_$7E66A2
	.dcb	$01
	.dcw	!TEXT_FIELD_PLANNER_$7E66D9
	.dcb	FRAMES_PER_CREDIT_TEXT
	.dcw	!TEXT_EMPTY_$7E5DC4
	.dcb	$01
	;******* crditos "EVENT PLANNER"
	.dcw	!TEXT_EVENT_PLANNER_$7E66FF
	.dcb	$01
	.dcw	!TEXT_EVENT_PLANNER_$7E6711
	.dcb	FRAMES_PER_CREDIT_TEXT
	.dcw	!TEXT_EMPTY_$7E5DC4
	.dcb	$01
	;******* crditos "EFFECT PROGRAMMER"
	.dcw	!TEXT_EFFECT_PROGRAMMER_$7E6738
	.dcb	$01
	.dcw	!TEXT_EFFECT_PROGRAMMER_TILDE
	.dcb	$01
	.dcw	!TEXT_EFFECT_PROGRAMMER_$7E674E
	.dcb	FRAMES_PER_CREDIT_TEXT
	.dcw	!TEXT_EMPTY_$7E5DC4
	.dcb	$01
	;******* crditos "BATTLE PROGRAMMER"
	.dcw	!TEXT_BATTLE_PROGRAMMER_$7E676F
	.dcb	$01
	.dcw	!TEXT_BATTLE_PROGRAMMER_$7E6785
	.dcb	FRAMES_PER_CREDIT_TEXT
	.dcw	!TEXT_EMPTY_$7E5DC4
	.dcb	$01
	;******* crditos "SOUND PROGRAMMER"
	.dcw	!TEXT_SOUND_PROGRAMMER_$7E679B
	.dcb	$01
	.dcw	!TEXT_SOUND_PROGRAMMER_$7E67B0
	.dcb	FRAMES_PER_CREDIT_TEXT
	.dcw	!TEXT_EMPTY_$7E5DC4
	.dcb	$01
	;******* crditos "EFFECT GRAPHIC DESIGN"
	.dcw	!TEXT_EFFECT_GRAPH_DESGN_$7E67C0
	.dcb	$01
	.dcw	!TEXT_EFFECT_GRAPH_DESGN_TILDE
	.dcb	$01
	.dcw	!TEXT_EFFECT_GRAPH_DESGN_$7E67DC
	.dcb	FRAMES_PER_CREDIT_TEXT
	.dcw	!TEXT_EMPTY_$7E5DC4
	.dcb	$01
	;******* crditos "FIELD GRAPHIC DESIGN" (I)
	.dcw	!TEXT_FIELD_GRAPH_DESIGN_$7E67F1
	.dcb	$01
	.dcw	!TEXT_FIELD_GRAPH_DESIGN_TILDE
	.dcb	$01
	.dcw	!TEXT_FIELD_GRAPH_DESIGN_$7E680C
	.dcb	FRAMES_PER_CREDIT_TEXT
	.dcw	!TEXT_EMPTY_$7E5DC4
	.dcb	$01
	;******* crditos "FIELD GRAPHIC DESIGN" (II)
	.dcw	!TEXT_FIELD_GRAPH_DESIGN_$7E67F1
	.dcb	$01
	.dcw	!TEXT_FIELD_GRAPH_DESIGN_$7E683F
	.dcb	FRAMES_PER_CREDIT_TEXT
	.dcw	!TEXT_EMPTY_$7E5DC4
	.dcb	$01
	;******* crditos "FIELD GRAPHIC DESIGN" (III)
	.dcw	!TEXT_FIELD_GRAPH_DESIGN_$7E67F1
	.dcb	$01
	.dcw	!TEXT_FIELD_GRAPH_DESIGN_$7E6875
	.dcb	FRAMES_PER_CREDIT_TEXT
	.dcw	!TEXT_EMPTY_$7E5DC4
	.dcb	$01
	;******* crditos "MONSTER GRAPHIC DESIGN"
	.dcw	!TEXT_MONSTER_GRAPH_DES_$7E68A0
	.dcb	$01
	.dcw	!TEXT_MONSTER_GRAPH_DES_TILDE
	.dcb	$01
	.dcw	!TEXT_MONSTER_GRAPH_DES_$7E68BD
	.dcb	FRAMES_PER_CREDIT_TEXT
	.dcw	!TEXT_EMPTY_$7E5DC4
	.dcb	$01
	;******* crditos "OBJECT GRAPHIC DESIGN"
	.dcw	!TEXT_OBJECT_GRAPH_DESGN_$7E68D0
	.dcb	$01
	.dcw	!TEXT_OBJECT_GRAPH_DESGN_$7E68EC
	.dcb	FRAMES_PER_CREDIT_TEXT
	.dcw	!TEXT_EMPTY_$7E5DC4
	.dcb	$01
	;******* crditos "SOUND ENGINEER"
	.dcw	!TEXT_SOUND_ENGINEER_$7E6900
	.dcb	$01
	.dcw	!TEXT_SOUND_ENGINEER_TILDE
	.dcb	$01
	.dcw	!TEXT_SOUND_ENGINEER_$7E6913
	.dcb	FRAMES_PER_CREDIT_TEXT
	.dcw	!TEXT_EMPTY_$7E5DC4
	.dcb	$01
	;******* crditos "REMAKE PLANNER"
	.dcw	!TEXT_REMAKE_PLANNER_$7E6925
	.dcb	$01
	.dcw	!TEXT_REMAKE_PLANNER_TILDE
	.dcb	$01
	.dcw	!TEXT_REMAKE_PLANNER_$7E6938
	.dcb	FRAMES_PER_CREDIT_TEXT
	.dcw	!TEXT_EMPTY_$7E5DC4
	.dcb	$01
	;******* crditos "TRADUCTORES"
	.dcw	!TEXT_TRADUCTORES_$7E6956
	.dcb	$01
	.dcw	!TEXT_SOUND_ENGINEER_TILDE
	.dcb	$01
	.dcw	!TEXT_TRADUCTORES_$7E6966
	.dcb	FRAMES_PER_CREDIT_TEXT
	.dcw	!TEXT_EMPTY_$7E5DC4
	.dcb	$01
	;******* crditos "THANKS TO" (I)
	.dcw	!TEXT_THANKS_TO_$7E6987
	.dcb	$01
	.dcw	!TEXT_THANKS_TO_$7E699D
	.dcb	FRAMES_PER_CREDIT_TEXT
	.dcw	!TEXT_EMPTY_$7E5DC4
	.dcb	$01
	;******* crditos "THANKS TO" (II)
	.dcw	!TEXT_THANKS_TO_$7E6987
	.dcb	$01
	.dcw	!TEXT_THANKS_TO_$7E69CA
	.dcb	FRAMES_PER_CREDIT_TEXT
	.dcw	!TEXT_EMPTY_$7E5DC4
	.dcb	$FE




TEXT_EMPTY_$7E5DC4
	.dcw	$4448
	.asc	"                          "
	.dcb	$FE
	.asc	"                          "
	.dcb	$FE
	.asc	"                          "
	.dcb	$FE
	.asc	"                          "
	.dcb	$00







	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/5E36							********
	;******* Esta rutina es la que se encarga de crear el mapa del texto de los crditos en el buffer $7E:4400 que es	********
	;******* la copia en RAM del tilemap para BG2.										********
	;*************************************************************************************************************************
CREATE_CREDITS_TILEMAP_PTN
	LDX.b	$00
	TXY
	REP	#$20
	;******* leemos la posicin en el mapa del texto, que determina dnde aparece el texto en pantalla; con l formamos el
	;******* puntero ($EB) con el que leeremos el texto
	LDA.b	($E7)
	STA.b	$EB
	;******* incrementamos el puntero de lectura
	INC.b	$E7
	INC.b	$E7
	SEP	#$20
	;******* leemos el byte alto que acompaar a cada byte del tilemap
	LDA.b	($E7),y
	STA.b	$43
	INY
	TDC
	;******* leemos un byte que determina cmo se centra el texto en pantalla usando el HDMA
	LDA.b	($E7),y
	INY
	JSR.w	!RUTINA_$7E5E8A
	;******* BUCLE PARA CONVERTIR EL TEXTO EN MAPA DE VRAM
Tag_$7E5E51
	;******* leemos un byte de texto y si es $00, salimos de la rutina
	LDA.b	($E7),y
	BEQ	Tag_$7E5E6C
	CMP.b	#$FE
	BEQ	Tag_$7E5E6D
	CMP.b	#$FF
	BEQ	Tag_$7E5E76
	;******* SI EL BYTE LEDO ES UNA LETRA
	PHY
	;******* en el registro X tenemos el offset por donde vamos escribiendo el mapa
	TXY
	;******* escribimos el byte de la letra en el byte inferior del mapa
	STA.b	($EB),y
	INX
	TXY
	;******* escribimos el byte superior del mapa
	LDA.b	$43
	STA.b	($EB),y
	INX
	PLY
	;******* incrementamos el puntero de lectura de texto
	INY
	BRA	Tag_$7E5E51
Tag_$7E5E6C
	RTS
	;******* SI EL BYTE LEDO ES $FE -> SALTO DOBLE DE LNEA
Tag_$7E5E6D
	REP	#$21
	LDA.w	#$0080
	STA.b	$E0
	BRA	Tag_$7E5E7D
	;******* SI EL BYTE LEDO ES $FF -> SALTO SIMPLE LNEA
Tag_$7E5E76
	REP	#$21
	LDA.w	#$0040
	STA.b	$E0
Tag_$7E5E7D
	;******* incrementamos el puntero de escritura en el mapa para pasar a la lnea de abajo o las dos
	;******* lneas de abajo
	LDA.b	$EB
	ADC.b	$E0
	STA.b	$EB
	SEP	#$20
	TDC
	TAX
	INY
	BRA	Tag_$7E5E51





	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/5E8A							********
	;******* Esta rutina modifica la tabla HDMA para el scroll horizontal de BG2 con cada texto de crdito que se	********
	;******* muestra por pantalla. Segn el byte que precede al texto de los crditos, se cambia el scroll horizon-	********
	;******* tal para que el texto quede centrado en pantalla.								********
	;*************************************************************************************************************************
RUTINA_$7E5E8A
	PHX
	PHY
	ASL A
	ASL A
	TAX
	LDA.w	!TABLE_$7E5EB2,x
	EOR.b	#$FF
	STA.w	!(HDMA_TABLE_$7E5BB5+1)
	LDA.w	!TABLE_$7E5EB2+1,x
	EOR.b	#$FF
	STA.w	!(HDMA_TABLE_$7E5BB5+4)
	LDA.w	!TABLE_$7E5EB2+2,x
	EOR.b	#$FF
	STA.w	!(HDMA_TABLE_$7E5BB5+7)
	LDA.w	!TABLE_$7E5EB2+3,x
	EOR.b	#$FF
	STA.w	!(HDMA_TABLE_$7E5BB5+10)
	PLY
	PLX
	RTS





TABLE_$7E5EB2
	.dcb	$00, $00, $00, $00
	.dcb	$00, $00, $04, $00
	.dcb	$04, $00, $00, $00
	.dcb	$00, $04, $00, $00
	.dcb	$00, $04, $04, $00
	.dcb	$04, $04, $00, $00
	.dcb	$04, $00, $04, $00
	.dcb	$00, $04, $00, $04






	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/5ED2							********
	;*************************************************************************************************************************
RUTINA_$7E5ED2
	;******* comprobamos el nmero de eventos metidos en la lista y si supera 119, no metemos ningn evento nuevo
	LDA.b	$1F
	CMP.b	#$77
	BCS	Tag_$7E5F17
	LDA.b	#$40
	TRB.b	$33
	LDA.b	#$00
	LDY.w	#!RUTINA_$7E7667
	JSR.w	!INSERT_ROUTINE_IN_CALLBACK_LIST
	TDC
	LDA.b	$18
	AND.b	#$07
	ASL	A
	TAY
	REP	#$20
	LDA.w	!POINTER_TABLE_$7E73F1,y
	STA.w	$3500,x
	SEP	#$20
	PHX
	JSR.w	!RUTINA_$7E55E4
	PLX
	STA.w	$3301,x
	AND.b	#$0F
	INC	A
	STA.w	$3801,x
	PHX
	JSR.w	!RUTINA_$7E55E4
	PLX
	STA.w	$3401,x
	STA.w	$3800,x
	AND.b	#$03
	INC	A
	STA.w	$3701,x
	STA.w	$3700,x
Tag_$7E5F17
	SEC
	RTS





POINTER_TABLE_$7E73F1
	.dcw	!TABLE_$7E635F, !TABLE_$7E6362, !TABLE_$7E6365, !TABLE_$7E6368, !TABLE_$7E636B, !TABLE_$7E636E, !TABLE_$7E6371, !TABLE_$7E6365




	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/5F29							********
	;*************************************************************************************************************************
RUTINA_$7E5F29
	TAX
	JMP.w	(!ROUTINE_TABLE_$7E5F2D,x)

ROUTINE_TABLE_$7E5F2D
	.dcw	!RUTINA_$7E5F31, !RUTINA_$7E5F43
	
	




	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/5F31							********
	;*************************************************************************************************************************
RUTINA_$7E5F31
	LDX.b	$1D
	INC.w	$3A00,x
	JSR.w	!RUTINA_$7E74EB
	LDA.w	$3901,x
	CLC
	ADC.w	$3B01,x
	STA.w	$3B01,x
RUTINA_$7E5F43
	LDX.b	$1D
	TDC
	LDA.w	$3900,x
	TAY
	LDA.b	$37
	CLC
	ADC.w	$3701,x
	TYX
	ADC.b	$39,x
	LDX.b	$1D
	STA.w	$3301,x
	LDA.b	$38
	CLC
	ADC.w	$3801,x
	TYX
	ADC.b	$3C,x
	LDX.b	$1D
	STA.w	$3401,x
	JSR.w	!RUTINA_$7E7519
	SEC
	RTS







	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/5F6B							********
	;******* Esta rutina devuelve en $38 uno de los valores de la tabla $7E:5FD2.						********
	;*************************************************************************************************************************
RUTINA_$7E5F6B
	TAX
	JMP.w	(!ROUTINE_TABLE_$7E5F6F,x)

ROUTINE_TABLE_$7E5F6F
	.dcw	!RUTINA_$7E5F73, !RUTINA_$7E5F8A





	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/5F73							********
	;*************************************************************************************************************************
RUTINA_$7E5F73
	LDX.b	$1D
	INC.w	$3A00,x
	REP	#$20
	;******* puntero a la tabla
	LDA.w	#!TABLE_$7E5FD2
	STA.w	$3500,x
	SEP	#$20
	;******* inicializamos el contador
	LDA.b	#$08
	STA.w	$3B01,x
	STZ.w	$3B00,x
RUTINA_$7E5F8A
	;******* cargamos el ndice de la lista de eventos donde lemos el actual
	LDX.b	$1D
	;******* llamamos a la rutina que decrementa el contador $3B01 y actualiza en consecuencia en ndice $3B00
	JSR.w	!RUTINA_$7E5F9A
	TDC
	;******* leemos de la posicin actualizada de la tabla el nuevo valor del contador que se devuelve en $38
	LDA.w	$3B00,x
	TAY
	LDA.b 	($EB),y
	STA.b	$38
	SEC
	RTS









	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/5F9A							********
	;*************************************************************************************************************************
RUTINA_$7E5F9A
	REP	#$20
	;******* leemos el puntero a la tabla y formamos ($EB)
	LDA.w	$3500,x
	STA.b	$EB
	SEP	#$20
Tag_$7E5FA3
	;******* comprobamos si el contador $3B01 ha llegado a -1
	LDA.w	$3B01,x
	CMP.b	#$FF
	BNE	Tag_$7E5FB2
	STZ.w	$3B00,x
	JSR.w	!RUTINA_$7E5FC6
	BRA	Tag_$7E5FA3
Tag_$7E5FB2
	;******* comprobamos si el contador $3B01 ha llegado a 0
	CMP.b	#$00
	BNE	Tag_$7E5FC2
	;******* incrementamos el ndice $3B00 en 2 para pasar a la siguiente posicin de la tabla
	INC.w	$3B00,x
	INC.w	$3B00,x
	JSR.w	!RUTINA_$7E5FC6
	BRA	Tag_$7E5FA3
Tag_$7E5FC2
	;******* decrementamos el contador $3B01 y salimos
	DEC.w	$3B01,x
	RTS







	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/5FC6							********
	;******* Esta rutina usa el ndice $3B00 para leer de la tabla un nuevo contador $3B00.				********
	;*************************************************************************************************************************
RUTINA_$7E5FC6
	TDC
	LDA.w	$3B00,x
	TAY
	INY
	LDA.b	($EB),y
	STA.w	$3B01,x
	RTS




TABLE_$7E5FD2
	.dcb	$01, $04, $02, $08, $01, $04, $00, $04, $00, $FF



TABLE_$7E5FDC
	.dcw	!TABLE_$7E5FEB
	.dcb	$04
	.dcw	!TABLE_$7E5FF0
	.dcb	$10
	.dcw	!TABLE_$7E5FF5
	.dcb	$04
	.dcw	!TABLE_$7E5FFA
	.dcb	$10
	.dcw	!TABLE_$7E5FF5
	.dcb	$FF

TABLE_$7E5FEB
	.dcb	$01
	.dcb	$90, $27, $84, $30

TABLE_$7E5FF0
	.dcb	$01
	.dcb	$90, $26, $84, $30

TABLE_$7E5FF5
	.dcb	$01
	.dcb	$90, $27, $84, $70

TABLE_$7E5FFA
	.dcb	$01
	.dcb	$90, $26, $84, $70





TABLE_$7E5FFF
	.dcw	!TABLE_$7E6008
	.dcb	$14
	.dcw	!TABLE_$7E6019
	.dcb	$14
	.dcw	!TABLE_$7E6019
	.dcb	$FF

TABLE_$7E6008
	.dcb	$04
	.dcb	$90, $08, $6C, $30
	.dcb	$A0, $08, $6E, $30
	.dcb	$90, $18, $80, $30
	.dcb	$A0, $18, $82, $30

TABLE_$7E6019
	.dcb	$04
	.dcb	$98, $08, $6C, $70
	.dcb	$88, $08, $6E, $70
	.dcb	$98, $18, $80, $70
	.dcb	$88, $18, $82, $70






TABLE_$7E602A
	.dcw	!TABLE_$7E6045
	.dcb	$08
	.dcw	!TABLE_$7E604E
	.dcb	$04
	.dcw	!TABLE_$7E6057
	.dcb	$04
	.dcw	!TABLE_$7E6060
	.dcb	$04
	.dcw	!TABLE_$7E6069
	.dcb	$08
	.dcw	!TABLE_$7E6072
	.dcb	$04
	.dcw	!TABLE_$7E6057
	.dcb	$04
	.dcw	!TABLE_$7E6060
	.dcb	$04
	.dcw	!TABLE_$7E6060
	.dcb	$FF

TABLE_$7E6045
	.dcb	$02
	.dcb	$80, $08, $60, $30
	.dcb	$80, $18, $62, $30


TABLE_$7E604E
	.dcb	$02
	.dcb	$80, $09, $60, $30
	.dcb	$80, $19, $62, $30


TABLE_$7E6057
	.dcb	$02
	.dcb	$80, $09, $64, $30
	.dcb	$80, $19, $66, $30


TABLE_$7E6060
	.dcb	$02
	.dcb	$80, $08, $64, $30
	.dcb	$80, $18, $66, $30


TABLE_$7E6069
	.dcb	$02
	.dcb	$80, $08, $68, $30
	.dcb	$80, $18, $6A, $30


TABLE_$7E6072
	.dcb	$02
	.dcb	$80, $09, $68, $30
	.dcb	$80, $19, $6A, $30
	
	
	




TABLE_$7E607B
	.dcw	!TABLE_$7E60BA
	.dcb	$08
	.dcw	!TABLE_$7E60C3
	.dcb	$04
	.dcw	!TABLE_$7E60A8
	.dcb	$04
	.dcw	!TABLE_$7E60B1
	.dcb	$04
	.dcw	!TABLE_$7E6096
	.dcb	$08
	.dcw	!TABLE_$7E609F
	.dcb	$04
	.dcw	!TABLE_$7E60A8
	.dcb	$04
	.dcw	!TABLE_$7E60B1
	.dcb	$04
	.dcw	!TABLE_$7E60B1
	.dcb	$FF


TABLE_$7E6096
	.dcb	$02
	.dcb	$A0, $08, $60, $70
	.dcb	$A0, $18, $62, $70


TABLE_$7E609F
	.dcb	$02
	.dcb	$A0, $09, $60, $70
	.dcb	$A0, $19, $62, $70


TABLE_$7E60A8
	.dcb	$02
	.dcb	$A0, $09, $64, $70
	.dcb	$A0, $19, $66, $70


TABLE_$7E60B1
	.dcb	$02
	.dcb	$A0, $08, $64, $70
	.dcb	$A0, $18, $66, $70


TABLE_$7E60BA
	.dcb	$02
	.dcb	$A0, $08, $68, $70
	.dcb	$A0, $18, $6A, $70


TABLE_$7E60C3
	.dcb	$02
	.dcb	$A0, $09, $68, $70
	.dcb	$A0, $19, $6A, $70





TABLE_$7E60CC
	.dcw	!TABLE_$7E60EA
	.dcb	$04
	.dcw	!TABLE_$7E60F3
	.dcb	$04
	.dcw	!TABLE_$7E60FC
	.dcb	$04
	.dcw	!TABLE_$7E6105
	.dcb	$04
	.dcw	!TABLE_$7E610E
	.dcb	$04
	.dcw	!TABLE_$7E6117
	.dcb	$08
	.dcw	!TABLE_$7E6120
	.dcb	$04
	.dcw	!TABLE_$7E6129
	.dcb	$04
	.dcw	!TABLE_$7E6132
	.dcb	$04
	.dcw	!TABLE_$7E6132
	.dcb	$FF


TABLE_$7E60EA
	.dcb	$02
	.dcb	$90, $3F, $40, $30
	.dcb	$90, $4F, $42, $30

TABLE_$7E60F3
	.dcb	$02
	.dcb	$90, $3D, $40, $30
	.dcb	$90, $4D, $42, $30

TABLE_$7E60FC
	.dcb	$02
	.dcb	$90, $3F, $44, $30
	.dcb	$90, $4F, $46, $30

TABLE_$7E6105
	.dcb	$02
	.dcb	$90, $3E, $44, $30
	.dcb	$90, $4E, $46, $30

TABLE_$7E610E
	.dcb	$02
	.dcb	$90, $3D, $48, $30
	.dcb	$90, $4D, $4A, $30

TABLE_$7E6117
	.dcb	$02
	.dcb	$90, $3E, $48, $30
	.dcb	$90, $4E, $4A, $30

TABLE_$7E6120
	.dcb	$02
	.dcb	$90, $3D, $4C, $30
	.dcb	$90, $4D, $4E, $30

TABLE_$7E6129
	.dcb	$02
	.dcb	$90, $3F, $4C, $30
	.dcb	$90, $4F, $4E, $30

TABLE_$7E6132
	.dcb	$02
	.dcb	$90, $41, $4C, $30
	.dcb	$90, $51, $4E, $30

	
	



TABLE_$7E613B
	.dcw	!TABLE_$7E6159
	.dcb	$08
	.dcw	!TABLE_$7E6162
	.dcb	$04
	.dcw	!TABLE_$7E616B
	.dcb	$04
	.dcw	!TABLE_$7E6174
	.dcb	$04
	.dcw	!TABLE_$7E617D
	.dcb	$04
	.dcw	!TABLE_$7E6186
	.dcb	$04
	.dcw	!TABLE_$7E618F
	.dcb	$04
	.dcw	!TABLE_$7E6198
	.dcb	$04
	.dcw	!TABLE_$7E61A1
	.dcb	$04
	.dcw	!TABLE_$7E61A1
	.dcb	$FF


TABLE_$7E6159
	.dcb	$02
	.dcb	$A0, $3E, $48, $70
	.dcb	$A0, $4E, $4A, $70

TABLE_$7E6162
	.dcb	$02
	.dcb	$A0, $3D, $4C, $70
	.dcb	$A0, $4D, $4E, $70

TABLE_$7E616B
	.dcb	$02
	.dcb	$A0, $3F, $4C, $70
	.dcb	$A0, $4F, $4E, $70

TABLE_$7E6174
	.dcb	$02
	.dcb	$A0, $41, $4C, $70
	.dcb	$A0, $51, $4E, $70

TABLE_$7E617D
	.dcb	$02
	.dcb	$A0, $3F, $40, $70
	.dcb	$A0, $4F, $42, $70

TABLE_$7E6186
	.dcb	$02
	.dcb	$A0, $3D, $40, $70
	.dcb	$A0, $4D, $42, $70

TABLE_$7E618F
	.dcb	$02
	.dcb	$A0, $3F, $44, $70
	.dcb	$A0, $4F, $46, $70

TABLE_$7E6198
	.dcb	$02
	.dcb	$A0, $3E, $44, $70
	.dcb	$A0, $4E, $46, $70

TABLE_$7E61A1
	.dcb	$02
	.dcb	$A0, $3D, $48, $70
	.dcb	$A0, $4D, $4A, $70









	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/61AA							********
	;*************************************************************************************************************************
TILEMAP_BUFFERS_PATH_TO_NARSHE
	;******* copiamos en VRAM todos los tilemaps necesarios desde los datos descomprimidos del chunk $D8F000
	JSR.w	!INITIALIZE_VRAM_PATH_TO_NARSHE
	REP	#$21
	;*************************************************************************************************************************
	;******* COPIAMOS $800 BYTES DE DATOS A $7F:9800 DESDE EL PUNTERO ALMACENADO EN $DF:DA66
	;******* leemos el puntero a los datos a copiar de la tabla $DF:DA00
	LDA.l	$DFDA66
	ADC.w	#$DB00
	STA.b	$E7
	SEP	#$20
	LDA.l	$DFDA68
	ADC.b	#$DF
	STA.b	$E9
	;****** copiamos esos datos en $7F:9800
	LDY.w	#$9800
	STY.b	$EB
	LDA.b	#$7F
	STA.b	$ED
	;****** la cantidad de datos a copiar es $800
	LDY.w	#$0800
	STY.b	$EF
	;****** realizamos la copia
	JSR.w	!COPY_FROM_$E7_TO_$EB
	REP	#$21
	;*************************************************************************************************************************
	;******* COPIAMOS $800 BYTES DE DATOS A $7F:A000 DESDE EL PUNTERO ALMACENADO EN $DF:DA5D
	LDA.l	$DFDA5D
	ADC.w	#$E300
	STA.b	$E7
	SEP	#$20
	LDA.l	$DFDA5F
	ADC.b	#$DF
	STA.b	$E9
	LDY.w	#$A000
	STY.b	$EB
	LDA.b	#$7F
	STA.b	$ED
	LDY.w	#$0800
	STY.b	$EF
	JSR.w	!COPY_FROM_$E7_TO_$EB
	REP	#$21
	;*************************************************************************************************************************
	;******* COPIAMOS $800 BYTES DE DATOS A $7F:A800 DESDE EL PUNTERO ALMACENADO EN $DF:DA60
	LDA.l	$DFDA60
	ADC.w	#$DB00
	STA.b	$E7
	SEP 	#$20
	LDA.l	$DFDA62
	ADC.b	#$DF
	STA.b	$E9
	LDY.w	#$A800
	STY.b	$EB
	LDA.b	#$7F
	STA.b	$ED
	LDY.w	#$0800
	STY.b	$EF
	JSR.w	!COPY_FROM_$E7_TO_$EB
	;*************************************************************************************************************************
	;******* CREAMOS EL TILEMAP EN $7F:B800 Y LO COPIAMOS CON $4000 BYTES DE TAMAO DESDE $7F:B800 A VRAM $0000 CON UNA
	;******* MSCARA DE $0000
	;****** copiamos desde $7F:9800 datos a $7F:B800
	STZ.b	$E4
	STZ.b	$E5
	LDA.b	#$80
	STA.b	$ED
	LDX.w	#$9800
	LDA.b	#$7F
	JSR.w	!RUTINA_$7E62F3
	;****** copiamos bloques de datos desde $7F:0BC0 a $7F:B800
	JSR.w	!RUTINA_$7E6288
	LDY.w	#$B800
	STY.b	$E7
	LDA.b	#$7F
	STA.b	$E9
	STZ.b	$ED
	STZ.b	$EE
	LDY.w	#$4000
	STY.b	$EB
	LDY.w	#$0000
	JSR.w	!COPY_TILEMAP_FROM_$E7_TO_VRAM
	;*************************************************************************************************************************
	;******* CREAMOS EL TILEMAP EN $7F:A800 Y LO COPIAMOS CON $4000 BYTES DE TAMAO DESDE $7F:B800 A VRAM $2000 CON UNA
	;******* MSCARA DE $0000
	LDX.w	#$0080
	STX.b	$E4
	LDA.b	#$80
	STA.b	$ED
	LDX.w	#$A800
	LDA.b	#$7F
	JSR.w	!RUTINA_$7E62F3
	JSR.w	!RUTINA_$7E6288
	LDY.w	#$B800
	STY.b	$E7
	LDA.b	#$7F
	STA.b	$E9
	STZ.b	$ED
	STZ.b	$EE
	LDY.w	#$4000
	STY.b	$EB
	LDY.w	#$2000
	JSR.w	!COPY_TILEMAP_FROM_$E7_TO_VRAM
	RTS









	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/6277							********
	;******* Rutina que copia los $EF bytes apuntados por [$E7] a la direccin apuntada por [$EB].			********
	;*************************************************************************************************************************
COPY_FROM_$E7_TO_$EB
	REP	#$20
	LDY.b	$00
Tag_$7E627B
	LDA.b	[$E7],y
	STA.w	[$EB],y
	INY
	INY
	CPY.b	$EF
	BNE	Tag_$7E627B
	SEP	#$20
	RTS






	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/6288							********
	;*************************************************************************************************************************
RUTINA_$7E6288
	TDC
	TAX
Tag_$7E628A
	REP	#$20
	;******* el primer valor de la tabla es el offset respecto a $7F:0BC0 desde donde leemos
	LDA.w	!TABLE_$7E62A6,x
	TAY
	INX
	INX
	;******* el segundo valor de la tabla es el offset respecto a $7F:B800 a donde copiamos
	LDA.w	!TABLE_$7E62A6,x
	STA.b	$E7
	INX
	INX
	SEP	#$20
	PHX
	;******* copiamos 32 bloques de 64 bytes cada uno
	JSR.w	!RUTINA_$7E62C6
	PLX
	CPX.w	#$0020
	BNE	Tag_$7E628A
	RTS



TABLE_$7E62A6
	.dcw	$0000, $0000
	.dcw	$0400, $0040
	.dcw	$0000, $0080
	.dcw	$0400, $00C0
	.dcw	$0800, $2000
	.dcw	$0C00, $2040
	.dcw	$0800, $2080
	.dcw	$0C00, $20C0




	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/62C6							********
	;******* Esta rutina copia desde $7F:0BC0 a $7F:B800 en bloques de 64 bytes.						********
	;*************************************************************************************************************************
RUTINA_$7E62C6
	PHB 
	LDA.b	#$7F
	PHA
	PLB
	LDA.b	#$20
	STA.b	$E0
Tag_$7E62CF
	LDA.b	#$20
	STA.b	$E1
	LDX.b	$E7
Tag_$7E62D5
	LDA.w	$0BC0,y
	STA.w	$B800,x
	INY
	INX
	INX
	DEC.b	$E1
	BNE	Tag_$7E62D5
	REP	#$21
	LDA.b	$E7
	ADC.w	#$0100
	STA.b	$E7
	SEP	#$20
	DEC.b	$E0
	BNE	Tag_$7E62CF
	PLB
	RTS







	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/62F3							********
	;*************************************************************************************************************************
RUTINA_$7E62F3
	;******* con el registro X y el byte en el acumulador creamos el puntero [$E7] origen de los datos
	STA.b	$E9
	STX.b	$E7
	PHB
	;******* cambiamos al banco de datos $7F
	LDA.b	#$7F
	PHA
	PLB
	TDC
	TAX
Tag_$7E62FE
	LDA.b	#$08
	STA.b	$E6
Tag_$7E6302
	REP	#$20
	LDY.w	#$0010
	;******* leemos los dos primeros bytes
	LDA.b	[$E7]
	STA.b	$F1
	;******* leemos los dos bytes que estn 16 bytes ms adelante
	LDA.b	[$E7],y
	STA.b	$EF
	TDC
	SEP	#$20
	LDY.w	#$0008
Tag_$7E6315
	TDC
	ASL.b	$F0
	ROL	A
	ASL.b	$EF
	ROL	A
	ASL.b	$F2
	ROL	A
	ASL.b	$F1
	ROL	A
	AND.b	#$0F
	BEQ	Tag_$7E6338
	STA.b	$E0
	PHX
	LDX.b	$E4
	LDA.l	TABLE_$7E6463,x
	PLX
	ASL	A
	ASL	A
	ASL	A
	ASL	A
	AND.b	#$30
	ORA.b	$E0
Tag_$7E6338
	STA.w	$B801,x
	INX
	INX
	DEY
	BNE	Tag_$7E6315
	;******* incrementamos en 2 bytes el puntero de lectura
	LDY.b	$E7
	INY
	INY
	STY.b	$E7
	DEC.b	$E6
	BNE	Tag_$7E6302
	REP	#$20
	INC.b	$E4
	LDA.b	$E7
	CLC
	ADC.w	#$0010
	STA.b	$E7
	TDC
	SEP	#$20
	DEC.b	$ED
	BNE	Tag_$7E62FE
	PLB
	RTS



TABLE_$7E635F
	.dcw	!TABLE_$7E6374
	.dcb	$FE

TABLE_$7E6362
	.dcw	!TABLE_$7E6379
	.dcb	$FE

TABLE_$7E6365
	.dcw	!TABLE_$7E637E
	.dcb	$FE

TABLE_$7E6368
	.dcw	!TABLE_$7E6383
	.dcb	$FE

TABLE_$7E636B
	.dcw	!TABLE_$7E6388
	.dcb	$FE

TABLE_$7E636E
	.dcw	!TABLE_$7E6399
	.dcb	$FE

TABLE_$7E6371
	.dcw	!TABLE_$7E63A2
	.dcb	$FE



TABLE_$7E6374
	.dcb	$01
	.dcb	$00, $00, $86, $72

TABLE_$7E6379
	.dcb	$01
	.dcb	$00, $00, $87, $76

TABLE_$7E637E
	.dcb	$01
	.dcb	$00, $00, $88, $78

TABLE_$7E6383
	.dcb	$01
	.dcb	$00, $00, $89, $7A

TABLE_$7E6388
	.dcb	$04
	.dcb	$08, $08, $87, $72
	.dcb	$00, $00, $86, $36
	.dcb	$00, $10, $86, $78
	.dcb	$20, $00, $86, $32

TABLE_$7E6399
	.dcb	$02
	.dcb	$00, $00, $89, $76
	.dcb	$10, $08, $89, $76

TABLE_$7E63A2
	.dcb	$02
	.dcb	$00, $00, $86, $7A
	.dcb	$30, $08, $86, $38



TABLE_$7E63AB
	.dcw	$0000, $7FFF, $62F6, $20E6, $0000, $739C, $4E51, $1483

	
TABLE_$7E63BB
	.dcw	$0000, $460B, $3DCA, $2948, $2D69, $2949, $356A, $2008, $2008, $2008, $2008, $35CD, $31AB, $5670, $566F, $524E


TABLE_$7E63DB
	.dcw	$0000, $460B, $3DCA, $2527, $14C6, $4A0D, $1CE7, $5670, $566F, $524E, $39AC, $2D69, $2527, $5670, $566F, $524E


TABLE_$7E63FB
	.dcw	$0000, $358A, $316A, $2D69, $2948, $2949, $2D69, $4A0D, $2008, $2008, $2008, $2008, $2008, $2008, $566F, $566F


TABLE_$7E641B
	.dcw	$0000, $41EF, $318C, $2D28, $2507, $1CE7, $18C6, $418B, $3969, $2D06, $24C5, $3D8A, $3126, $2008, $2008, $2008	


TABLE_$7E643B
	.dcw	$0000, $62D2, $5A90, $524E

TABLE_$7E6443
	.dcw	$0000, $1576, $002E, $0C42, $0841, $45CD, $3D6A, $3528, $2528, $2CE7, $24E6, $20C5, $18C5, $18A3, $1483, $1063

TABLE_$7E6463
	.dcb	$00, $01, $02, $01, $01, $01, $01, $01, $01, $02, $02, $02, $02, $02, $02, $03
	.dcb	$02, $03, $03, $02, $02, $02, $02, $02, $02, $02, $02, $01, $01, $01, $01, $01
	.dcb	$02, $02, $02, $02, $02, $02, $02, $02, $02, $02, $02, $01, $01, $01, $01, $01
	.dcb	$02, $02, $02, $02, $02, $02, $02, $02, $02, $02, $02, $01, $01, $01, $01, $01
	.dcb	$02, $02, $02, $02, $02, $02, $02, $02, $02, $02, $02, $02, $02, $02, $02, $02
	.dcb	$02, $02, $02, $02, $02, $02, $02, $02, $02, $02, $02, $02, $02, $02, $02, $02
	.dcb	$02, $02, $02, $02, $02, $02, $02, $02, $02, $02, $02, $02, $02, $02, $02, $02
	.dcb	$02, $02, $02, $02, $02, $02, $02, $02, $05, $05, $05, $05, $05, $05, $05, $05
	.dcb	$03, $03, $03, $05, $05, $03, $03, $03, $03, $03, $03, $03, $03, $03, $03, $03
	.dcb	$02, $02, $05, $05, $05, $05, $03, $03, $03, $03, $03, $03, $03, $03, $03, $03
	.dcb	$02, $02, $03, $02, $02, $02, $03, $03, $03, $03, $03, $03, $03, $03, $03, $02
	.dcb	$02, $03, $02, $02, $02, $03, $03, $02, $03, $03, $03, $03, $03, $04, $02, $02
	.dcb	$02, $02, $02, $02, $02, $02, $02, $02, $02, $02, $02, $02, $02, $02, $02, $02
	.dcb	$02, $02, $02, $02, $02, $02, $02, $02, $02, $02, $02, $02, $00, $02, $02, $02



TEXT_PRODUCER_$7E6543
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$4456
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$24
	.dcb	$00
	;******* PRODUCER
	.asc	"productor"
	.dcb	$00

TEXT_PRODUCER_$7E6550
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$44CE
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$20
	.dcb	$00
	;******* HIRONOBU SAKAGUCHI
	.asc	"HIRONOBU SAKAGUCHI"
	.dcb	$00

	

TEXT_DIRECTOR_$7E6567
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$4456
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$24
	.dcb	$01
	;******* DIRECTOR
	.asc	"director"
	.dcb	$00

TEXT_DIRECTOR_$7E6574
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$44CE
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$20
	.dcb	$04
	;******* YOSHINORI KITASE
	.asc	"YOSHINORI KITASE"
	.dcb	$FE
	;******* HIROYUKI ITOU
	.asc	" HIROYUKI ITOU"
	.dcb	$00



TEXT_MAIN_PROGRAMMER_$7E6598
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$4452
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$24
	.dcb	$02
	;******* MAIN PROGRAMMER
	.asc	"programadores"
	.dcb	$00

TEXT_MAIN_PROGRAMMER_$7E65AC
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$44D2
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$20
	.dcb	$02
	;******* KEN NARITA
	.asc	"  KEN NARITA"
	.dcb	$FE
	;******* KIYOSHI YOSHII
	.asc	"KIYOSHI YOSHII"
	.dcb	$00


TEXT_GRAPHIC_DIRECTOR_TILDE
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$4426
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$24
	.dcb	$03
	;******* TILDE
	.dcb	$1D
	.dcb	$00
	

TEXT_GRAPHIC_DIRECTOR_$7E65CC
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$4450
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$24
	.dcb	$03
	;******* GRAPHIC DIRECTOR
	.asc	"director grafico"
	.dcb	$00

TEXT_GRAPHIC_DIRECTOR_$7E65E1
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$44CE
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$20
	.dcb	$03
	;******* TETSUYA TAKAHASHI
	.asc	"TETSUYA TAKAHASHI"
	.dcb	$FE
	;******* KIYOSHI YOSHII
	.asc	"  KAZUKO SHIBUYA"
	.dcb	$00

TEXT_GRAPHIC_DIRECTOR_$7E6608
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$44D2
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$20
	.dcb	$00
	;******* HIDEO MINABA
	.asc	" HIDEO MINABA"
	.dcb	$FE
	;******* TETSUYA NOMURA
	.asc	"TETSUYA NOMURA"
	.dcb	$00




TEXT_MUSIC_TILDE
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$441C
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$24
	.dcb	$03
	;******* TILDE
	.dcb	$1D
	.asc	"     "
	.dcb	$00
	
	
TEXT_MUSIC_$7E6629
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$445A
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$24
	.dcb	$00
	;******* MUSIC
	.asc	"musica"
	.dcb	$00

	
TEXT_MUSIC_$7E6633
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$44D2
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$20
	.dcb	$03
	;******* NOBUO UEMATSU
	.asc	"NOBUO UEMATSU"
	.dcb	$00



TEXT_IMAGE_DESIGNER_TILDE
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$441A
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$24
	.dcb	$03
	;******* TILDE
	.dcb	$01
	.asc	"    "
	.dcb	$1D
	.dcb	$00

	
TEXT_IMAGE_DESIGNER_$7E6645
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$4452
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$24
	.dcb	$03
	;******* IMAGE DESIGNER
	.asc	"diseno grafico"
	.dcb	$00

TEXT_IMAGE_DESIGNER_$7E6658
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$44D0
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$20
	.dcb	$03
	;******* YOSHITAKA AMANO
	.asc	"YOSHITAKA AMANO"
	.dcb	$00




TEXT_BATTLE_PLANNER_TILDE
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$441A
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$24
	.dcb	$03
	;******* TILDE
	.dcb	$01
	.asc	"     "
	.dcb	$00
	
	
TEXT_BATTLE_PLANNER_$7E666C
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$4452
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$24
	.dcb	$04
	;******* BATTLE PLANNER
	.asc	"diseno batallas"
	.dcb	$00

TEXT_BATTLE_PLANNER_$7E667F
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$44D0
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$20
	.dcb	$04
	;******* YASUYUKI HASEBE
	.asc	"YASUYUKI HASEBE"
	.dcb	$FE
	;******* AKIYOSHI OOTA
	.asc	" AKIYOSHI OOTA"
	.dcb	$00



TEXT_FIELD_PLANNER_$7E66A2
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$4452
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$24
	.dcb	$02
	;******* FIELD PLANNER
	.asc	"diseno mapas"
	.dcb	$00

TEXT_FIELD_PLANNER_$7E66B4
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$44CC
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$20
	.dcb	$04
	;******* YOSHIHIKO MAEKAWA
	.asc	"YOSHIHIKO MAEKAWA"
	.dcb	$FE
	;******* KEITA ETOH
	.asc	"   KEITA ETOH"
	.dcb	$00

TEXT_FIELD_PLANNER_$7E66D9
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$44CE
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$20
	.dcb	$04
	;******* SATORU TSUJI
	.asc	"  SATORU TSUJI"
	.dcb	$FE
	;******* HIDETOSHI KEZUKA
	.asc	"HIDETOSHI KEZUKA"
	.dcb	$00



TEXT_EVENT_PLANNER_$7E66FF
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$4452
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$24
	.dcb	$04
	;******* EVENT PLANNER
	.asc	"diseno eventos"
	.dcb	$00

TEXT_EVENT_PLANNER_$7E6711
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$44CE
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$20
	.dcb	$06
	;******* TSUKASA FUJITA
	.asc	"  TSUKASA FUJITA"
	.dcb	$FE
	;******* KEISUKE MATSUHARA
	.asc	"KEISUKE MATSUHARA"
	.dcb	$00




TEXT_EFFECT_PROGRAMMER_TILDE
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$441A
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$24
	.dcb	$06
	;******* TILDE
	.asc	"  "
	.dcb	$1D
	.dcb	$00
	
TEXT_EFFECT_PROGRAMMER_$7E6738
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$444A
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$24
	.dcb	$06
	;******* EFFECT PROGRAMMER
	.asc	"programacion efectos"
	.dcb	$00

TEXT_EFFECT_PROGRAMMER_$7E674E
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$44D0
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$20
	.dcb	$03
	;******* HIROSHI HARATA
	.asc	"HIROSHI HARATA"
	.dcb	$FE
	;******* SATOSHI OGATA
	.asc	"SATOSHI OGATA"
	.dcb	$00



TEXT_BATTLE_PROGRAMMER_$7E676F
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$444A
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$24
	.dcb	$05
	;******* BATTLE PROGRAMMER
	.asc	"programacion batallas"
	.dcb	$00

TEXT_BATTLE_PROGRAMMER_$7E6785
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$44CE
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$20
	.dcb	$05
	;******* AKIHIRO YAMAGUCHI
	.asc	"AKIHIRO YAMAGUCHI"
	.dcb	$00



TEXT_SOUND_PROGRAMMER_$7E679B
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$444A
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$24
	.dcb	$00
	;******* SOUND PROGRAMMER
	.asc	"programacion sonido"
	.dcb	$00

TEXT_SOUND_PROGRAMMER_$7E67B0
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$44D2
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$20
	.dcb	$05
	;******* MINORU AKAO
	.asc	"MINORU AKAO"
	.dcb	$00




TEXT_EFFECT_GRAPH_DESGN_TILDE
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$441A
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$24
	.dcb	$02
	;******* TILDE
	.dcb	$01
	.asc	"  "
	.dcb	$00
	
	
TEXT_EFFECT_GRAPH_DESGN_$7E67C0
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$4452
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$24
	.dcb	$02
	;******* EFFECT GRAPHIC DESIGNER
	.asc	"diseno efectos"
	.dcb	$00

TEXT_EFFECT_GRAPH_DESGN_$7E67DC
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$44D0
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$20
	.dcb	$05
	;******* HIROKATSU SASAKI
	.asc	"HIROKATSU SASAKI"
	.dcb	$00



TEXT_FIELD_GRAPH_DESIGN_TILDE
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$4414
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$24
	.dcb	$04
	;******* TILDE
	.dcb	$01
	.asc	"    "
	.dcb	$1D
	.dcb	$00
	
	
TEXT_FIELD_GRAPH_DESIGN_$7E67F1
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$444C
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$24
	.dcb	$04
	;******* FIELD GRAPHIC DESIGNER
	.asc	"diseno grafico mapas"
	.dcb	$00

TEXT_FIELD_GRAPH_DESIGN_$7E680C
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$44D0
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$20
	.dcb	$03
	;******* TAKAHARU MATSUO
	.asc	"TAKAHARU MATSUO"
	.dcb	$FE
	;******* YUSUKE NAORA
	.asc	"  YUSUKE NAORA"
	.dcb	$FE
	;******* NOBUYUKI IKEDA
	.asc	" NOBUYUKI IKEDA"
	.dcb	$00

TEXT_FIELD_GRAPH_DESIGN_$7E683F
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$44CE
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$20
	.dcb	$07
	;******* TOMOE INAZAWA
	.asc	"  TOMOE INAZAWA"
	.dcb	$FE
	;******* KAORI TANAKA
	.asc	"   KAORI TANAKA"
	.dcb	$FE
	;******* TAKAMICHI SHIBUYA
	.asc	"TAKAMICHI SHIBUYA"
	.dcb	$00

TEXT_FIELD_GRAPH_DESIGN_$7E6875
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$44CC
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$20
	.dcb	$01
	;******* SHINICHIROU HAMASAKA
	.asc	"SHINICHIROU HAMASAKA"
	.dcb	$FE
	;******* AKIYOSHI MASUDA
	.asc	"  AKIYOSHI MASUDA"
	.dcb	$00




TEXT_MONSTER_GRAPH_DES_TILDE
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$4410
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$24
	.dcb	$04
	;******* TILDE
	.dcb	$01
	.asc	"    "
	.dcb	$1D
	.asc	"  "
	.dcb	$00
	
TEXT_MONSTER_GRAPH_DES_$7E68A0
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$4448
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$24
	.dcb	$00
	;******* MONSTER GRAPHIC DESIGNER
	.asc	"diseno grafico monstruos"
	.dcb	$00

TEXT_MONSTER_GRAPH_DES_$7E68BD
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$44D2
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$20
	.dcb	$03
	;******* HITOSHI SASAKI
	.asc	"HITOSHI SASAKI"
	.dcb	$00



TEXT_OBJECT_GRAPH_DESGN_$7E68D0
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$4448
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$24
	.dcb	$05
	;******* OBJECT GRAPHIC DESIGNER
	.asc	"diseno grafico objetos"
	.dcb	$00

TEXT_OBJECT_GRAPH_DESGN_$7E68EC
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$44D0
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$20
	.dcb	$05
	;******* KAZUHIRO OHKAWA
	.asc	"KAZUHIRO OHKAWA"
	.dcb	$00



TEXT_SOUND_ENGINEER_TILDE
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$4410
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$24
	.dcb	$04
	;******* TILDE
	.asc	"         "
	.dcb	$00
	

TEXT_SOUND_ENGINEER_$7E6900
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$4450
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$24
	.dcb	$03
	;******* SOUND ENGINEER
	.asc	"ingeniero sonido"
	.dcb	$00

TEXT_SOUND_ENGINEER_$7E6913
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$44D2
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$20
	.dcb	$03
	;******* EIJI NAKAMURA
	.asc	"EIJI NAKAMURA"
	.dcb	$00


	
TEXT_REMAKE_PLANNER_TILDE
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$4420
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$24
	.dcb	$04
	;******* TILDE
	.dcb	$1D
	.dcb	$00
	
TEXT_REMAKE_PLANNER_$7E6925
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$4450
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$24
	.dcb	$03
	;******* REMAKE PLANNER
	.asc	"adaptacion remake"
	.dcb	$00

TEXT_REMAKE_PLANNER_$7E6938
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$44D6
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$20
	.dcb	$03
	;******* WEIMIN LI
	.asc	"WEIMIN LI"
	.dcb	$FE
	;******* AIKO ITO
	.asc	" AIKO ITO"
	.dcb	$00
	



TEXT_TRADUCTORES_$7E6956
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$4454
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$24
	.dcb	$03
	;******* TRADUCTORES
	.asc	"traductores"
	.dcb	$00

TEXT_TRADUCTORES_$7E6966
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$44D4
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$20
	.dcb	$06
	;******* TED WOOSLEY
	.asc	"TED WOOSLEY"
	.dcb	$FE
	;******* PABLITO
	.asc	"  PABLITO"
	.dcb	$FE
	;******* MAGNO
	.asc	"   MAGNO"
	.dcb	$00




TEXT_THANKS_TO_$7E6987
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$444E
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$24
	.dcb	$03
	;******* SPECIAL THANKS TO
	.asc	"special thanks to"
	.dcb	$00
	

TEXT_THANKS_TO_$7E699D
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$44D6
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$20
	.dcb	$00
	;******* ASSASSIN
	.asc	"ASSASSIN"
	.dcb	$FE
	;******* DRAKKHEN
	.asc	"DRAKKHEN"
	.dcb	$FE
	;******* LENOPHIS
	.asc	"LENOPHIS"
	.dcb	$00
	

TEXT_THANKS_TO_$7E69CA
	;******* direccin en el mapa de RAM $7E:4400 donde va el texto
	.dcw	$44D0
	;******* parte alta del mapa para cada entrada del tilemap de texto
	.dcb	$20
	.dcb	$00
	;******* DRAGONSBRETHREN
	.asc	"DRAGONSBRETHREN"
	.dcb	$FE
	;******* NOVALIA SPIRIT
	.asc	"NOVALIA SPIRIT"
	.dcb	$00



	
	
	
	
	
	
	;*************************************************************************************************************************
	;*************************************************************************************************************************
	;*************************************************************************************************************************
	;******* 						RUTINA $7E/6950							********
	;*************************************************************************************************************************
	;*************************************************************************************************************************
	;*************************************************************************************************************************
SCENE_WORLD_COLLAPSE
	PHP
	REP	#$30
	PHA
	PHX
	PHY
	PHB
	PHD
	;******* inicializamos los registros y la memoria
	JSR.w	!INITIALIZE_DB_DP_NMI_IRQ
	JSR.w	!INITIALIZE_ALL_PPU_REGISTERS
	JSR.w	!SCENE_WORLD_COLLAPSE_INIT
	JSR.w	!INIT_RAM_BUFFER_N_VARIABLES
	JSR.w	!ERASE_FULL_VRAM
	JSR.w	!INIT_OAM_BUFFER_N_CALLBACK
	JSR.w	!SCENE_WORLD_COLLAPSE_GRAPHICS
	;******* ejecutamos los comandos de la escena
	JSR.w	!SCENE_WORLD_COLLAPSE_EXEC
	JSR.w	!RUTINA_$7E504B
	REP	#$30
	PLD
	PLB
	PLY
	PLX
	PLA
	PLP
	RTL







	;*************************************************************************************************************************
	;*************************************************************************************************************************
	;******* 						RUTINA $7E/6980							********
	;*************************************************************************************************************************
	;*************************************************************************************************************************
SCENE_WORLD_COLLAPSE_INIT
	PHB
	LDA.b	#$00
	PHA
	PLB
	LDA.b	#$03
	STA.w	$2101
	LDX.b	$00
	STX.w	$2102
	LDA.b	#$07
	STA.w	$2105
	TDC
	LDA.b	#$80
	STA.w	$211A
	PLB
	RTS





	;*************************************************************************************************************************
	;******* 						RUTINA $7E/699C							********
	;*************************************************************************************************************************
SCENE_WORLD_COLLAPSE_EXEC
	TDC
	LDA.b	$19
	BMI	Tag_$7E69AE
	ASL	A
	TAX
	JSR.w	(!ROUTINE_TABLE_$7E69C8,x)
	JSR.w	!EXECUTE_CALLBACK_EVENT_LIST
	JSR.w	!WAIT_NMI_AND_READ_CONTROLLER
	BRA	SCENE_WORLD_COLLAPSE_EXEC
Tag_$7E69AE
.IF PAL_VERSION = 1
	LDY.w	#$000C
.ELSE
	LDY.w	#$000F
.ENDIF
	STY.b	$15
	LDA.b	#$00
	LDY.w	#!RUTINA_$7E5554
	JSR.w	!INSERT_ROUTINE_IN_CALLBACK_LIST
Tag_$7E69BB
	LDY.b	$15
	BEQ	Tag_$7E69C7
	JSR.w	!EXECUTE_CALLBACK_EVENT_LIST
	JSR.w	!WAIT_NMI_AND_READ_CONTROLLER
	BRA	Tag_$7E69BB
Tag_$7E69C7
	RTS

	
ROUTINE_TABLE_$7E69C8
	.dcw	!RUTINA_$7E69D4, !RUTINA_$7E6A13, !RUTINA_$7E6A2A, !RUTINA_$7E6A39, !RUTINA_$7E6A48, !RUTINA_$7E531A




	;*************************************************************************************************************************
	;******* 						RUTINA $7E/69D4							********
	;*************************************************************************************************************************
RUTINA_$7E69D4
	JSR.w	!RUTINA_$7E6B4F
	LDX.w	#$3100
	LDY.w	#!TABLE_$7E73F1
	JSR.w	!COPY_32BYTES_FROM_REGY_TO_REGX
	LDX.w	#$3000
	LDY.w	#!TABLE_$7E73F1
	JSR.w	!COPY_32BYTES_FROM_REGY_TO_REGX
	LDX.w	#$3100
	LDY.w	#!TABLE_$7E6C5E
	LDA.b	#$02
	JSR.w	!RUTINA_$7E72C6
	LDX.w	#$3000
	LDY.w	#!TABLE_$7E6C5E
	LDA.b	#$02
	JSR.w	!RUTINA_$7E72C6
	LDA.b	#$00
	LDY.w	#!RUTINA_$7E6B18
	JSR.w	!INSERT_ROUTINE_IN_CALLBACK_LIST
	INC.b	$19
	LDA.b	#$0F
	STA.b	$32
.IF PAL_VERSION = 1
	LDY.w	#$000D
.ELSE
	LDY.w	#$0010
.ENDIF
	STY.b	$15
	RTS






	;*************************************************************************************************************************
	;******* 						RUTINA $7E/6A13							********
	;*************************************************************************************************************************
RUTINA_$7E6A13
	LDY.b	$15
	BNE	Tag_$7E6A26
	INC.b	$19
	;******* temporizacin de 10 segundos
.IF PAL_VERSION = 1
	LDY.w	#500
.ELSE
	LDY.w	#600
.ENDIF
	STY.b	$15
	LDA.b	#$00
	LDY.w	#!RUTINA_$7E6AA4
	JSR.w	!INSERT_ROUTINE_IN_CALLBACK_LIST
Tag_$7E6A26
	JSR.w	!RUTINA_$7E6A5B
	RTS






	;*************************************************************************************************************************
	;******* 						RUTINA $7E/6A2A							********
	;*************************************************************************************************************************
RUTINA_$7E6A2A
	LDY.b	$15
	BNE	Tag_$7E6A35
	INC.b	$19
	;******* temporizacin de 1 segundo
.IF PAL_VERSION = 1
	LDY.w	#50
.ELSE
	LDY.w	#60
.ENDIF
	STY.b	$15
Tag_$7E6A35
	JSR.w	!RUTINA_$7E6A5B
	RTS






	;*************************************************************************************************************************
	;******* 						RUTINA $7E/6A39							********
	;*************************************************************************************************************************
RUTINA_$7E6A39
	LDY.b	$15
	BNE	Tag_$7E6A44
	INC.b	$19
	LDY.w	#$0001
	STY.b	$15
Tag_$7E6A44
	JSR.w	!RUTINA_$7E6A5B
	RTS





	;*************************************************************************************************************************
	;******* 						RUTINA $7E/6A48							********
	;*************************************************************************************************************************
RUTINA_$7E6A48
	LDY.b	$15
	BNE	Tag_$7E6A4E
	INC.b	$19
Tag_$7E6A4E
	JSR.w	!RUTINA_$7E6A5B
	RTS







	;*************************************************************************************************************************
	;******* 						RUTINA $7E/6A5B							********
	;*************************************************************************************************************************
RUTINA_$7E6A5B
	PHB
	LDA.b	#$00
	PHA
	PLB
	LDA.b	$3F
	STA.w	$211F
	LDA.b	$40
	STA.w	$211F
	LDA.b	$41
	STA.w	$2120
	LDA.b	$42
	STA.w	$2120
	LDA.b	$44
	STA.w	$211B
	LDA.b	$45
	STA.w	$211B
	LDA.b	$46
	STA.w	$211C
	LDA.b	$47
	STA.w	$211C
	LDA.b	$48
	STA.w	$211D
	LDA.b	$49
	STA.w	$211D
	LDA.b	$4A
	STA.w	$211E
	LDA.b	$4B
	STA.w	$211E
	PLB
	RTS





	;*************************************************************************************************************************
	;******* 						RUTINA $7E/6AA4							********
	;*************************************************************************************************************************
RUTINA_$7E6AA4
	TAX
	JMP.w	(!ROUTINE_TABLE_$7E6AA8,x)

ROUTINE_TABLE_$7E6AA8
	.dcw	!RUTINA_$7E6AAC, !RUTINA_$7E6ADD




	

	;*************************************************************************************************************************
	;******* 						RUTINA $7E/6AAC							********
	;*************************************************************************************************************************
RUTINA_$7E6AAC
	LDX.b	$1D
	INC.w	$3A00,x
	LDA.b	#$80
	STA.l	$002130
	LDA.b	#$57
	STA.l	$002131
	LDA.b	#$17
	STA.l	$00212C
	LDA.b	#$17
	STA.l	$00212D
	LDA.b	#$88
	STA.w	$3301,x
	LDA.b	#$20
	STA.w	$3302,x
	LDA.b	#$42
	STA.w	$3401,x
	LDA.b	#$20
	STA.w	$3600,x
RUTINA_$7E6ADD
	LDX.b	$1D
	LDA.w	$3600,x
	BNE	Tag_$7E6B13
	LDA.w	$3301,x
	CMP.b	#$97
	BCS	Tag_$7E6AF2
	STA.l	$002132
	INC.w	$3301,x
Tag_$7E6AF2
	LDA.w	$3302,x
	CMP.b	#$8F
	BCS	Tag_$7E6B00
	STA.l	$002132
	INC.w	$3302,x
Tag_$7E6B00
	LDA.w	$3401,x
	CMP.b	#$91
	BCS	Tag_$7E6B0E
	STA.l	$002132
	INC.w	$3401,x
Tag_$7E6B0E
	LDA.b	#$20
	STA.w	$3600,x
Tag_$7E6B13
	DEC.w	$3600,x
	SEC
	RTS







	;*************************************************************************************************************************
	;******* 						RUTINA $7E/6B18							********
	;*************************************************************************************************************************
RUTINA_$7E6B18
	JSR.w	!RUTINA_$7E6B29
	LDA.b	$18
	AND.b	#$07
	BNE	Tag_$7E6B27
	REP	#$20
	INC.b	$27
	SEP	#$20
Tag_$7E6B27
	SEC
	RTS







	;*************************************************************************************************************************
	;******* 						RUTINA $7E/6B29							********
	;*************************************************************************************************************************
RUTINA_$7E6B29
	LDA.b	$19
	CMP.b	#$03
	BEQ	Tag_$7E6B39
	CMP.b	#$04
	BEQ	Tag_$7E6B42
	LDA.b	$18
	AND.b	#$01
	BNE	Tag_$7E6B41
Tag_$7E6B39
	REP	#$20
	INC.b	$44
	INC.b	$4A
	SEP 	#$20
Tag_$7E6B41
	RTS
Tag_$7E6B42
	REP	#$20
	INC.b	$44
	INC.b	$44
	INC.b	$4A
	INC.b	$4A
	SEP	#$20
	RTS








	;*************************************************************************************************************************
	;******* 						RUTINA $7E/6B4F							********
	;*************************************************************************************************************************
RUTINA_$7E6B4F
	LDY.w	#$0040
	STY.b	$3F
	LDY.w	#$0020
	STY.b	$41
	LDY.w	#$FFA0
	STY.b	$25
	LDY.w	#$FFC0
	STY.b	$27
	TDC
	TAY
	STY.b	$46
	STY.b	$48
	LDY.w	#$0001
	STY.b	$44
	STY.b	$4A
	RTS








	;*************************************************************************************************************************
	;******* 						RUTINA $7E/6B71							********
	;*************************************************************************************************************************
SCENE_WORLD_COLLAPSE_GRAPHICS
	;******* direccin de los datos comprimidos $D9:4E96
	LDY.w	#$4E96
	STY.b	$F3
	LDA.b	#$D9
	STA.b	$F5
	;******* direccin donde se decomprimen los datos $7F:0000
	JSR.w	!DECOMPRESS_DATA_TO_$7F0000
	;******* puntero [$E7] a los datos descomprimidos
	LDY.w	#$0000
	STY.b	$E7
	LDA.b	#$7F
	STA.b	$E9
	;******* puntero [$EB] donde se copiarn parte de los datos descomprimidos
	LDY.w	#$9800
	STY.b	$EB
	LDA.b	#$7F
	STA.b	$ED
	LDY.w	#$07C0
	STY.b	$EF
	JSR.w	!COPY_FROM_$E7_TO_$EB
	LDA.b	#$40
	STA.b	$ED
	LDX.w	#$9800
	LDA.b	#$7F
	JSR.w	!RUTINA_$7E6C06
	JSR.w	!RUTINA_$7E6BC9
	LDY.w	#$B800
	STY.b	$E7
	LDA.b	#$7F
	STA.b	$E9
	STZ.b	$ED
	STZ.b	$EE
	LDY.w	#$2000
	STY.b	$EB
	LDY.w	#$0000
	JSR.w	!COPY_TILEMAP_FROM_$E7_TO_VRAM
	RTS





	;*************************************************************************************************************************
	;******* 						RUTINA $7E/6BC9							********
	;*************************************************************************************************************************
RUTINA_$7E6BC9
	PHB
	LDA.b	#$7F
	PHA
	PLB
	TDC
	TAX
Tag_$7E6BD0
	STA.w	$B800,x
	INX
	INX
	CPX.w	#$2000
	BNE	Tag_$7E6BD0
	TDC
	TAY
	STY.b	$E7
	LDA.b	#$0A
	STA.b	$E0
Tag_$7E6BE2
	LDA.b	#$20
	STA.b	$E1
	LDX.b	$E7
Tag_$7E6BE8
	LDA.w	$07C0,y
	STA.w	$B800,x
	INY
	INX
	INX
	DEC.b	$E1
	BNE	Tag_$7E6BE8
	REP	#$21
	LDA.b	$E7
	ADC.w	#$0100
	STA.b	$E7
	SEP	#$20
	DEC.b	$E0
	BNE	Tag_$7E6BE2
	PLB
	RTS









	;*************************************************************************************************************************
	;******* 						RUTINA $7E/6C06							********
	;*************************************************************************************************************************
RUTINA_$7E6C06
	STA.b	$E9
	STX.b	$E7
	PHB
	LDA.b	#$7F
	PHA
	PLB
	TDC
	TAX
Tag_$7E6C11
	LDA.b	#$08
	STA.b	$E6
Tag_$7E6C15
	REP	#$20
	LDY.w	#$0010
	LDA.b	[$E7]
	STA.b	$F1
	LDA.b	[$E7],y
	STA.b	$EF
	TDC
	SEP	#$20
	LDY.w	#$0008
Tag_$7E6C28
	TDC
	ASL.b	$F0
	ROL	A
	ASL.b	$EF
	ROL	A
	ASL.b	$F2
	ROL	A
	ASL.b	$F1
	ROL	A
	AND.b	#$0F
	BEQ	Tag_$7E6C39
Tag_$7E6C39
	STA.w	$B801,x
	INX
	INX
	DEY
	BNE	Tag_$7E6C28
	LDY.b	$E7
	INY
	INY
	STY.b	$E7
	DEC.b	$E6
	BNE	Tag_$7E6C15
	REP	#$20
	LDA.b	$E7
	CLC
	ADC.w	#$0010
	STA.b	$E7
	TDC
	SEP	#$20
	DEC.b	$ED
	BNE	Tag_$7E6C11
	PLB
	RTS






TABLE_$7E6C5E
	.dcw	$5E2F, $3E76, $298E, $210A, $1CC8, $1486, $1464, $1043, $0C23, $0422, $0000, $0000, $0000, $0000, $0000, $18A4
	







	;*************************************************************************************************************************
	;*************************************************************************************************************************
	;*************************************************************************************************************************
	;******* 						RUTINA $7E/6C7E							********
	;*************************************************************************************************************************
	;*************************************************************************************************************************
	;*************************************************************************************************************************
RUTINA_$7E6C7E
	PHP
	REP	#$30
	PHA
	PHX
	PHY
	PHB
	PHD
	;******* inicializamos los registros y la memoria
	JSR.w	!INITIALIZE_DB_DP_NMI_IRQ
	JSR.w	!INITIALIZE_ALL_PPU_REGISTERS
	JSR.w	!RUTINA_$7E6CAE
	JSR.w	!INIT_RAM_BUFFER_N_VARIABLES
	JSR.w	!ERASE_FULL_VRAM
	JSR.w	!INIT_OAM_BUFFER_N_CALLBACK
	JSR.w	!RUTINA_$7E6F87
	;******* ejecutamos los comandos de la escena
	JSR.w	!RUTINA_$7E6CD3
	JSR.w	!RUTINA_$7E504B
	REP	#$30
	PLD
	PLB
	PLY
	PLX
	PLA
	PLP
	RTL







	;*************************************************************************************************************************
	;******* 						RUTINA $7E/6CAE							********
	;*************************************************************************************************************************
RUTINA_$7E6CAE
	PHB
	LDA.b	#$00
	PHA
	PLB
	LDA.b	#$03
	STA.w	$2101
	LDA.b	#$82
	STA.w	$2130
	LDA.b	#$50
	STA.w	$2131
	LDA.b	#$17
	STA.w	$212C
	LDA.b	#$01
	STA.w	$212D
	LDA.b	#$E0
	STA.w	$2132
	PLB
	RTS








	;*************************************************************************************************************************
	;******* 						RUTINA $7E/6CD3							********
	;*************************************************************************************************************************
RUTINA_$7E6CD3
	TDC
	LDA.b	$19
	BMI	Tag_$7E6CE5
	ASL	A
	TAX
	JSR.w	(!ROUTINE_TABLE_$7E6CFF,x)
	JSR.w	!EXECUTE_CALLBACK_EVENT_LIST
	JSR.w	!WAIT_NMI_AND_READ_CONTROLLER
	BRA	RUTINA_$7E6CD3
Tag_$7E6CE5
	LDY.w	#$000F
	STY.b	$15
	LDA.b	#$00
	LDY.w	#!RUTINA_$7E5554
	JSR.w	!INSERT_ROUTINE_IN_CALLBACK_LIST
Tag_$7E6CF2
	LDY.b	$15
	BEQ	Tag_$7E6CFE
	JSR.w	!EXECUTE_CALLBACK_EVENT_LIST
	JSR.w	!WAIT_NMI_AND_READ_CONTROLLER
	BRA	Tag_$7E6CF2
Tag_$7E6CFE
	RTS


ROUTINE_TABLE_$7E6CFF
	.dcw	!RUTINA_$7E6D09, !RUTINA_$7E6DB3, !RUTINA_$7E6DCD, !RUTINA_$7E6E00, !RUTINA_$7E531A 




	;*************************************************************************************************************************
	;******* 						RUTINA $7E/6D09							********
	;*************************************************************************************************************************
RUTINA_$7E6D09
	STZ.b	$34
	LDA.b	#$80
	STA.b	$35
	LDX.w	#$3000
	LDY.w	#!TABLE_$7E73F1
	JSR.w	!COPY_32BYTES_FROM_REGY_TO_REGX
	LDX.w	#$3180
	LDY.w	#!TABLE_$7E73F1
	JSR.w	!COPY_32BYTES_FROM_REGY_TO_REGX
	LDX.w	#$31A0
	LDY.w	#!TABLE_$7E73F1
	JSR.w	!COPY_32BYTES_FROM_REGY_TO_REGX
	LDX.w	#$3000
	LDY.w	#!TABLE_$7E7109
	LDA.b	#$04
	JSR.w	!RUTINA_$7E72C6
	LDX.w	#$3180
	LDY.w	#!TABLE_$7E7149
	LDA.b	#$04
	JSR.w	!RUTINA_$7E72C6
	LDX.w	#$31A0
	LDY.w	#!TABLE_$7E7169
	LDA.b	#$04
	JSR.w	!RUTINA_$7E72C6
	LDA.b	#$02
	LDY.w	#!RUTINA_$7E6E89
	JSR.w	!INSERT_ROUTINE_IN_CALLBACK_LIST
	REP	#$20
	LDA.w	#!TABLE_$7E7006
	STA.w	$3500,x
	LDA.w	#$FFFC
	STA.w	$3800,x
	LDA.w	#$0004
	STA.w	$3700,x
	LDA.w	#$0168
	STA.w	$3600,x
	SEP	#$20
	LDA.b	#$72
	STA.w	$3301,x
	LDA.b	#$80
	STA.w	$3401,x
	LDA.b	#$02
	LDY.w	#!RUTINA_$7E6E89
	JSR.w	!INSERT_ROUTINE_IN_CALLBACK_LIST
	REP	#$20
	LDA.w	#!TABLE_$7E7032
	STA.w	$3500,x
	LDA.w	#$0004
	STA.w	$3800,x
	LDA.w	#$FFFE
	STA.w	$3700,x
	LDA.w	#$0168
	STA.w	$3600,x
	SEP	#$20
	LDA.b	#$50
	STA.w	$3301,x
	LDA.b	#$A0
	STA.w	$3401,x
	INC.b	$19
	LDA.b	#$0F
	STA.b	$32
	;******* temporizacin de 3 segundos
.IF PAL_VERSION = 1
	LDY.w	#150
.ELSE
	LDY.w	#180
.ENDIF
	STY.b	$15
	RTS









	;*************************************************************************************************************************
	;******* 						RUTINA $7E/6DB3							********
	;*************************************************************************************************************************
RUTINA_$7E6DB3
	LDY.b	$15
	BNE	Tag_$7E6DF9
	INC.b	$19
	;******* temporizacind e 18 segundos
.IF PAL_VERSION = 1
	LDY.w	#$0384
.ELSE
	LDY.w	#$0438
.ENDIF
	STY.b	$15
	LDA.b	#$00
	LDY.w	#!RUTINA_$7E6E16
	JSR.w	!INSERT_ROUTINE_IN_CALLBACK_LIST
	BRA	Tag_$7E6DF9








	;*************************************************************************************************************************
	;******* 						RUTINA $7E/6DCD							********
	;*************************************************************************************************************************
RUTINA_$7E6DCD
	LDY.b	$15
	BNE	Tag_$7E6DF9
	INC.b	$19
	;******* temporizacin de 3 segundos
.IF PAL_VERSION = 1
	LDY.w	#150
.ELSE
	LDY.w	#180
.ENDIF
	STY.b	$15
	LDX.w	#$3000
	LDY.w	#!TABLE_$7E73F1
	LDA.b	#$08
	JSR.w	!RUTINA_$7E72C6
	LDX.w	#$3180
	LDY.w	#!TABLE_$7E73F1
	LDA.b	#$08
	JSR.w	!RUTINA_$7E72C6
	LDX.w	#$31A0
	LDY.w	#!TABLE_$7E73F1
	LDA.b	#$08
	JSR.w	!RUTINA_$7E72C6
Tag_$7E6DF9
	JSR.w	!RUTINA_$7E6F23
	JSR.w	!RUTINA_$7E6ED8
	RTS




	;*************************************************************************************************************************
	;******* 						RUTINA $7E/6E00							********
	;*************************************************************************************************************************
RUTINA_$7E6E00
	LDY.b	$15
	BNE	Tag_$7E6DF9
	INC.b	$19
	BRA	Tag_$7E6DF9











	;*************************************************************************************************************************
	;******* 						RUTINA $7E/6E16							********
	;*************************************************************************************************************************
RUTINA_$7E6E16
	TAX
	JMP.w	(!ROUTINE_TABLE_$7E6E1A,x)

ROUTINE_TABLE_$7E6E1A
	.dcw	!RUTINA_$7E6E1E, !RUTINA_$7E6E23



RUTINA_$7E6E1E
	LDX.b	$1D
	INC.w	$3A00,x
RUTINA_$7E6E23
	LDX.b	$1D
	LDA.w	$3600,x
	BNE	Tag_$7E6E63
	LDY.w	$3900,x
	PHY
	LDA.b	#$00
	LDY.w	#!RUTINA_$7E7667
	JSR.w	!INSERT_ROUTINE_IN_CALLBACK_LIST
	PLY
	REP	#$20
	LDA.w	#!TABLE_$7E70A5
	STA.w	$3500,x
	SEP	#$20
	LDA.w	!TABLE_$7E6E75,y
	STA.w	$3301,x
	INY
	LDA.w	!TABLE_$7E6E75,y
	STA.w	$3401,x
	INY
	CPY.w	#$0014
	BEQ	Tag_$7E6E6A
	LDX.b	$1D
	REP	#$20
	TYA
	STA.w	$3900,x
	SEP	#$20
	LDA.b	#$10
	STA.w	$3600,x
Tag_$7E6E63
	LDX.b	$1D
	DEC.w	$3600,x
	SEC
	RTS
Tag_$7E6E6A
	LDX.w	#$3180
	LDY.w	#!TABLE_$7E7129
	JSR.w	!COPY_32BYTES_FROM_REGY_TO_REGX
	CLC
	RTS


TABLE_$7E6E75
	.dcb	$70, $9D, $74, $A0, $78, $9E, $7C, $9D, $80, $9C, $84, $9F, $88, $A0, $8C, $9F, $90, $A4, $94, $A5





	;*************************************************************************************************************************
	;******* 						RUTINA $7E/6E89							********
	;*************************************************************************************************************************
RUTINA_$7E6E89
	TAX
	JMP.w	(!ROUTINE_TABLE_$7E6E8D,x)

ROUTINE_TABLE_$7E6E8D
	.dcw	!RUTINA_$7E6E91, !RUTINA_$7E6EA1






	;*************************************************************************************************************************
	;******* 						RUTINA $7E/6E91							********
	;*************************************************************************************************************************
RUTINA_$7E6E91
	LDX.b	$1D
	INC.w	$3A00,x
	JSR.w	!RUTINA_$7E74EB
	REP	#$20
	LDA.w	#$0294
	STA.w	$3900,x
RUTINA_$7E6EA1
	LDX.b	$1D
	LDY.w	$3900,x
	BEQ	Tag_$7E6ED3
	LDY.w	$3600,x
	BNE	Tag_$7E6EC4
	REP	#$21
	LDA.w	$3300,x
	ADC.w	$3700,x
	STA.w	$3300,x
	LDA.w	$3400,x
	CLC
	ADC.w	$3800,x
	STA.w	$3400,x
	SEP	#$20
Tag_$7E6EC4
	REP	#$20
	DEC.w	$3900,x
	LDA.w	$3600,x
	BEQ	Tag_$7E6ED1
	DEC.w	$3600,x
Tag_$7E6ED1
	SEP	#$20
Tag_$7E6ED3
	JSR.w	!RUTINA_$7E7519
	SEC
	RTS






	;*************************************************************************************************************************
	;******* 						RUTINA $7E/6ED8							********
	;*************************************************************************************************************************
RUTINA_$7E6ED8
	JSR.w	!RUTINA_$7E6F0F
	AND.b	#$1F
	BNE	Tag_$7E6F06
	LDA.b	#$00
	LDY.w	#!RUTINA_$7E6FE6
	JSR.w	!INSERT_ROUTINE_IN_CALLBACK_LIST
	REP	#$20
	LDA.w	#!TABLE_$7E7082
	STA.w	$3500,x
	SEP	#$20
	PHX
	JSR.w	!RUTINA_$7E6F0F
	AND.b	#$03
	ASL	A
	TAY
	PLX
	LDA.w	!TABLE_$7E6F07,y
	STA.w	$3301,x
	LDA.w	!TABLE_$7E6F07+1,y
	STA.w	$3401,x
Tag_$7E6F06
	RTS



TABLE_$7E6F07
	.dcb	$72, $9A, $7A, $92, $62, $AA, $52, $BA







	;*************************************************************************************************************************
	;******* 						RUTINA $7E/6F0F							********
	;*************************************************************************************************************************
RUTINA_$7E6F0F
	TDC
	INC.b	$34
	LDA.b	$34
	TAX
	LDA.l	$C0FD00,x
	STA.b	$35
	TAX
	LDA.l	$C0FD00,x
	ADC.b	$35
	RTS








	;*************************************************************************************************************************
	;******* 						RUTINA $7E/6F23							********
	;*************************************************************************************************************************
RUTINA_$7E6F23
	JSR.w	!RUTINA_$7E6F0F
	AND.b	#$07
	BNE	Tag_$7E6F54
	LDA.b	#$00
	LDY.w	#!RUTINA_$7E6FE6
	JSR.w	!INSERT_ROUTINE_IN_CALLBACK_LIST
	REP	#$20
	LDA.w	#!TABLE_$7E7066
	STA.w	$3500,x
	SEP	#$20
	PHX
	JSR.w	!RUTINA_$7E6F0F
	PLX
	AND.b	#$3F
	ADC.b	#$68
	STA.w	$3301,x
	PHX
	JSR.w	!RUTINA_$7E6F0F
	PLX
	AND.b	#$3F
	ADC.b	#$98
	STA.w	$3401,x
Tag_$7E6F54
	RTS










	;*************************************************************************************************************************
	;******* 						RUTINA $7E/6F55							********
	;*************************************************************************************************************************
RUTINA_$7E6F55
	JSR.w	!RUTINA_$7E6F0F
	AND.b	#$0F
	BNE	Tag_$7E6F86
	LDA.b	#$00
	LDY.w	#!RUTINA_$7E6FE6
	JSR.w	!INSERT_ROUTINE_IN_CALLBACK_LIST
	REP	#$20
	LDA.w	#!TABLE_$7E70CE
	STA.w	$3500,x
	SEP	#$20
	PHX
	JSR.w	!RUTINA_$7E6F0F
	PLX
	AND.b	#$1F
	ADC.b	#$68
	STA.w	$3301,x
	PHX
	JSR.w	!RUTINA_$7E6F0F
	PLX
	AND.b	#$1F
	ADC.b	#$98
	STA.w	$3401,x
Tag_$7E6F86
	RTS






	;*************************************************************************************************************************
	;******* 						RUTINA $7E/6F87							********
	;*************************************************************************************************************************
RUTINA_$7E6F87
	;******* los datos comprimidos empiezan en $EC:E900
	LDY.w	#$E900
	STY.b	$F3
	LDA.b	#$EC
	STA.b	$F5
	;******* decomprimimos los grficos a $7F:0000
	JSR.w	!DECOMPRESS_DATA_TO_$7F0000
	;******* puntero [$E7] a los datos descomprimidos
	LDY.w	#$0000
	STY.b	$E7
	LDA.b	#$7F
	STA.b	$E9
	STZ.b	$ED
	STZ.b	$EE
	LDY.w	#$0FE0
	STY.b	$EB
	LDY.w	#$3000
	JSR.w	!COPY_TILEMAP_FROM_$E7_TO_VRAM
	LDY.w	#$0FE0
	STY.b	$E7
	LDA.b	#$7F
	STA.b	$E9
	STZ.b	$ED
	STZ.b	$EE
	LDY.w	#$0700
	STY.b	$EB
	LDY.w	#$0000
	JSR.w	!COPY_TILEMAP_FROM_$E7_TO_VRAM
	LDY.w	#$16E0
	STY.b	$E7
	LDA.b	#$7F
	STA.b	$E9
	STZ.b	$ED
	STZ.b	$EE
	LDY.w	#$0DE0
	STY.b	$EB
	LDY.w	#$6000
	JSR.w	!COPY_TILEMAP_FROM_$E7_TO_VRAM
	RTS







	;*************************************************************************************************************************
	;******* 						RUTINA $7E/6FE6							********
	;*************************************************************************************************************************
RUTINA_$7E6FE6
	TAX
	JMP.w	(!ROUTINE_TABLE_$7E6FEA,x)

ROUTINE_TABLE_$7E6FEA
	.dcw	!RUTINA_$7E6FEE, !RUTINA_$7E6FF6





	;*************************************************************************************************************************
	;******* 						RUTINA $7E/6FEE							********
	;*************************************************************************************************************************
RUTINA_$7E6FEE
	LDX.b	$1D
	INC.w	$3A00,x
	JSR.w	!RUTINA_$7E74EB
RUTINA_$7E6FF6
	LDX.b	$1D
	LDA.w	$3B01,x
	CMP.b	#$FE
	BEQ	Tag_$7E7004
	JSR.w	!RUTINA_$7E7519
	SEC
	RTS
Tag_$7E7004
	CLC
	RTS




TABLE_$7E7006
	.dcw	!TABLE_$7E7009
	.dcb	$FE

TABLE_$7E7009
	.dcb	$0A
	.dcb	$90, $00, $12, $38
	.dcb	$A0, $00, $14, $38
	.dcb	$B0, $00, $16, $38
	.dcb	$80, $10, $30, $38
	.dcb	$90, $10, $32, $38
	.dcb	$A0, $10, $34, $38
	.dcb	$B0, $10, $36, $38
	.dcb	$80, $20, $50, $38
	.dcb	$90, $20, $52, $38
	.dcb	$A0, $20, $54, $38

	




TABLE_$7E7032
	.dcw	!TABLE_$7E7035
	.dcb	$FE

TABLE_$7E7035
	.dcb	$0C
	.dcb	$80, $18, $10, $38
	.dcb	$90, $00, $18, $38
	.dcb	$A0, $00, $1A, $38
	.dcb	$B0, $00, $1C, $38
	.dcb	$C0, $00, $1E, $38
	.dcb	$90, $10, $38, $38
	.dcb	$A0, $10, $3A, $38
	.dcb	$B0, $10, $3C, $38
	.dcb	$C0, $10, $3E, $38
	.dcb	$A0, $20, $5A, $38
	.dcb	$B0, $20, $5C, $38
	.dcb	$C0, $20, $5E, $38
	



TABLE_$7E7066
	.dcw	!TABLE_$7E7073
	.dcb	$08
	.dcw	!TABLE_$7E7078
	.dcb	$08
	.dcw	!TABLE_$7E707D
	.dcb	$08
	.dcw	!TABLE_$7E7072
	.dcb	$FE

TABLE_$7E7072
	.dcb	$00
	
TABLE_$7E7073
	.dcb	$01
	.dcb	$00, $00, $00, $3A
	
TABLE_$7E7078
	.dcb	$01
	.dcb	$00, $00, $01, $3A
	
TABLE_$7E707D
	.dcb	$01
	.dcb	$00, $00, $02, $3A





TABLE_$7E7082
	.dcw	!TABLE_$7E708E
	.dcb	$08
	.dcw	!TABLE_$7E7093
	.dcb	$08
	.dcw	!TABLE_$7E7098
	.dcb	$08
	.dcw	!TABLE_$7E7098
	.dcb	$FE

TABLE_$7E708E
	.dcb	$01
	.dcb	$04, $04, $03, $3A
	
TABLE_$7E7093
	.dcb	$01
	.dcb	$02, $02, $04, $3A
	
TABLE_$7E7098
	.dcb	$03
	.dcb	$00, $00, $05, $3A
	.dcb	$08, $00, $06, $3A
	.dcb	$00, $08, $07, $3A
	





TABLE_$7E70A5
	.dcw	!TABLE_$7E70BA
	.dcb	$08
	.dcw	!TABLE_$7E70BF
	.dcb	$08
	.dcw	!TABLE_$7E70C4
	.dcb	$08
	.dcw	!TABLE_$7E70C9
	.dcb	$08
	.dcw	!TABLE_$7E70C4
	.dcb	$08
	.dcw	!TABLE_$7E70BF
	.dcb	$08
	.dcw	!TABLE_$7E70BA
	.dcb	$FF

TABLE_$7E70BA
	.dcb	$01
	.dcb	$00, $00, $08, $3A

TABLE_$7E70BF
	.dcb	$01
	.dcb	$00, $00, $09, $3A

TABLE_$7E70C4
	.dcb	$01
	.dcb	$00, $00, $0A, $3A

TABLE_$7E70C9
	.dcb	$01
	.dcb	$00, $00, $0b, $3A







TABLE_$7E70CE
	.dcw	!TABLE_$7E70DD
	.dcb	$08
	.dcw	!TABLE_$7E70E2
	.dcb	$08
	.dcw	!TABLE_$7E70EB
	.dcb	$08
	.dcw	!TABLE_$7E70F8
	.dcb	$08
	.dcw	!TABLE_$7E70F8
	.dcb	$FE

TABLE_$7E70DD
	.dcb	$01
	.dcb	$00, $00, $0C, $3A

TABLE_$7E70E2
	.dcb	$02
	.dcb	$00, $00, $0C, $3A
	.dcb	$08, $00, $0D, $3A

TABLE_$7E70EB
	.dcb	$03
	.dcb	$00, $00, $0C, $3A
	.dcb	$08, $00, $0D, $3A
	.dcb	$10, $00, $0E, $3A

TABLE_$7E70F8
	.dcb	$03
	.dcb	$00, $00, $0C, $3A
	.dcb	$08, $00, $0D, $3A
	.dcb	$10, $00, $0E, $3A


TABLE_$7E7105
	.dcb	$18, $00, $0F, $3A



TABLE_$7E7109
	.dcw	$1CE7, $7BBD, $777A, $7758, $7317, $6ED4, $668F, $624D, $59E8, $4D86, $3D25, $30E3, $24A3, $1C82, $1862, $1042


TABLE_$7E7129
	.dcw	$0000, $26BF, $01FF, $4295, $3632, $3211, $2DF0, $29CF, $21AE, $1D8D, $194B, $1509, $10C8, $0CA6, $0159, $00B2


TABLE_$7E7149
	.dcw	$0000, $29CF, $21AE, $4295, $3632, $3211, $2DF0, $29CF, $21AE, $1D8D, $194B, $1509, $10C8, $0CA6, $29CF, $21AE


TABLE_$7E7169
	.dcw	$0000, $477F, $26BF, $01FF, $0159, $00B2, $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000







	;*************************************************************************************************************************
	;******* 						RUTINA $7E/7189							********
	;******* Esta rutina activa la interrupcin NMI, espera a que ocurra, actualiza el estado de la pantalla y		********
	;******* ejecuta las transferencias HDMA programadas. Por ltimo, obtienela pulsacin del joypad 1 que se 		********
	;******* devuelve en las siguientes variables:										********
	;*******	* $04 -> 16 bits con la pulsacin del actual NMI en el registro $4218					********
	;*******	* $06 -> un $0000 si en los dos NMIs anteriores al actual se mantuvo la misma pulsacinM; cualquier	********
	;*******		  otro bit activo indica que esa botn ha sido pulsado entre los 2 NMIs anteiores		********
	;*******	* $08 -> 16 bits con la pulsacin del anterior NMI en el registro $4218				********
	;*************************************************************************************************************************
WAIT_NMI_AND_READ_CONTROLLER
	;******* activamos la interrupcin NMI y la auto-lectura del joypad
	LDA.b	#$81
	STA.l	$004200
	;******* guardamos el flag a un valor no nulo
	STA.b	$17
	CLI
	;******* esperamos al NMI
Tag_$7E7192
	LDA.b	$17
	BNE	Tag_$7E7192
	SEI
	;******* actualizamos el registro con el brillo de la pantalla y con el blanking forzado
	LDA.b	$32
	STA.l	$002100
	;******* ejecutamos las transferencias HDMA de los canales programados
	LDA.b	$31
	STA.l	$00420C
	;******* leemos del mando de control 1
	JSR.w	!RUTINA_$7E71A7
	RTS






	;*************************************************************************************************************************
	;******* 						RUTINA $7E/71A7							********
	;******* Esta rutina lee el joypad del mando 1 y devuelve los siguientes valores.					********
	;*******	* $04 -> 16 bits con la pulsacin del actual NMI en el registro $4218					********
	;*******	* $06 -> un $0000 si en los dos NMIs anteriores al actual se mantuvo la misma pulsacinM; cualquier	********
	;*******		  otro bit activo indica que esa botn ha sido pulsado entre los 2 NMIs anteiores		********
	;*******	* $08 -> 16 bits con la pulsacin del anterior NMI en el registro $4218				********
	;*************************************************************************************************************************
RUTINA_$7E71A7
	REP 	#$20
	;******* combinamos la pulsacin anterior del NMI con la que hace 2 NMIs y si el resultado es $0000, es que se mantiene
	;******* la misma pulsacin (o ninguna) en ambos NMIs consecutivos
	LDA.b	$08
	EOR.w	#$FFFF
	AND.b	$04
	STA.b	$06
	;******* guardamos la pulsacin del joypad 1 en el anterior NMI
	LDY.b	$04
	STY.b	$08
	;******* leemos las pulsaciones del joypad 1 y las devolvemos en $04
	LDA.l	$004218
	STA.b	$04
	SEP	#$20
	RTS










	;*************************************************************************************************************************
	;*************************************************************************************************************************
	;*************************************************************************************************************************
	;******* 						RUTINA $7E/71BF							********
	;******* Rutina NMI que realiza una actualizacin de VRAM, OAM, CGRAM y de los registros de offset para BG0, BG1	********
	;******* y BG2 siempre que alguien haya modificado la variable flag $17. Cuando se sale de esta rutina NMI, dicha	********
	;******* variable siempre vale 0, pero si tambin vale 0 al entrar, no se hace nada en el NMI. Si se ejcuta 	********
	;******* alguna accin en el NMI, se decrementa tambin la variable $15 que es un contador de animacin.		********
	;*************************************************************************************************************************
	;*************************************************************************************************************************
	;*************************************************************************************************************************
RUTINA_NMI_INTRO_SCENE
	PHP
	REP	#$30
	PHA
	PHX
	PHY
	PHB
	PHD
	SEP	#$20
	;******* leemos el flag de NMI
	LDA.w	$4210
	;******* cambiamos el banco de datos a $7E
	LDA.b	#$00
	PHA
	PLB
	;******* cambiamos la pgina directa a $0000
	LDX.w	#$0000
	PHX
	PLD
	;******* leemos el flag que determinar si alguien ha programado alguna accin entre dos NMIs; si no, seguir a cero
	;******* desde la ltima vez que se sali de esta rutina NMI
	LDA.b	$17
	BEQ	Tag_$7E71E5
	;******* enviamos a VRAM la transferencia que hubiera programada, a OAM los datos de los sprites y a CGRAM, la paleta
	;******* tambin actualizamos los registros de offset para BG0, BG1 y BG2
	JSR.w	!RUTINA_$7E71F1
	;******* decrementamos el contador de frames
	LDY.b	$15
	BEQ	Tag_$7E71E3
	DEY
	STY.b	$15
Tag_$7E71E3
	INC.b	$18
Tag_$7E71E5
	;******* ponemos siempre el flag a 0 para sealizar que se ha terminado una rutina NMI
	STZ.b	$17
	REP	#$30
	PLD
	PLB
	PLY
	PLX
	PLA
	PLP
	;******* la rutina IRQ no hace nada
RUTINA_$7E71F0
	RTI








	;*************************************************************************************************************************
	;******* 						RUTINA $7E/71F1							********
	;*************************************************************************************************************************
RUTINA_$7E71F1
	;******* paramos el DMA y HDMA que haya corriendo actualmente
	STZ.w	$420C
	STZ.w	$420B
	;******* offset horizontal del BG0
	LDA.b	$25
	STA.w	$210D
	LDA.b	$26
	STA.w	$210D
	;******* offset vertical del BG0
	LDA.b	$27
	STA.w	$210E
	LDA.b	$28
	STA.w	$210E
	;******* offset horizontal del BG1
	LDA.b	$29
	STA.w	$210F
	LDA.b	$2A
	STA.w	$210F
	;******* offset vertical del BG1
	LDA.b	$2B
	STA.w	$2110
	LDA.b	$2C
	STA.w	$2110
	;******* offset horizontal del BG2
	LDA.b	$2D
	STA.w	$2111
	LDA.b	$2E
	STA.w	$2111
	;******* offset vertical del BG2
	LDA.b	$2F
	STA.w	$2112
	LDA.b	$30
	STA.w	$2112
	;******* enviamos los datos de los sprites
	JSR.w	!DMA0_SPRITE_DATA_TO_OAM
	;******* enviamos los datos de la paleta
	JSR.w	!DMA0_PALETTE_DATA_TO_CGRAM
	;******* enviamos a VRAM datos si los hubiera
	JMP.w	!DMA0_GENERIC_DATA_TO_VRAM








	;*************************************************************************************************************************
	;******* 						RUTINA $7E/723C							********
	;******* Esta rutina enva toda la tabla OAM a la memoria de video desde $7E:0300 por el canal 0 DMA.		********
	;*************************************************************************************************************************
DMA0_SPRITE_DATA_TO_OAM
	;******* direccin de OAM $0000
	LDX.b	$00
	STX.w	$2102
	TXA
	;******* banco origen de la transferencia $00 ($7E)
	STA.w	$4304
	LDA.b	#$02
	STA.w	$4300
	;******* registro a escribir $2104, es decir, la memoria OAM
	LDA.b	#$04
	STA.w	$4301
	;******* direccin origen de la transferencia $7E:0300
	LDY.w	#$0300
	STY.w	$4302
	;******* tamao de la transferencia
	LDY.w	#$0220
	STY.w	$4305
	;******* hacemos la transferencia DMA
	LDA.b	#$01
	STA.w	$420B
	RTS




	;*************************************************************************************************************************
	;******* 						RUTINA $7E/7261							********
	;******* Esta rutina enva a VRAM por DMA[0] los datos indicados en las siguientes variables:			********
	;*******	* $10/$11 	-> direccin de VRAM destino.								********
	;*******	* $12/$13/$14 -> direccin de origen de la transferencia.						********
	;*******	* $0E/$0F 	-> tamao de la transferencia en bytes.							********
	;*************************************************************************************************************************
DMA0_GENERIC_DATA_TO_VRAM
	;******* comprobamos la direccin de VRAM, si es $FFFF es que no hay transferencia que hacer
	LDY.b	$10
	CPY.w	#$FFFF
	BEQ	Tag_$7E7289
	;******* si hay una transferencia, ponemos la direccin de VRAM
	STY.w	$2116
	LDA.b	#$01
	STA.w	$4300
	;******* la transferencia es al registro $2118
	LDA.b	#$18
	STA.w	$4301
	;******* direccin origen de la transferencia
	LDY.b	$12
	STY.w	$4302
	LDA.b	$14
	STA.w	$4304
	;****** tamao de la transferencia
	LDY.b	$0E
	STY.w	$4305
	LDA.b	#$01
	STA.w	$420B
Tag_$7E7289
	RTS







	;*************************************************************************************************************************
	;******* 						RUTINA $7E/728A							********
	;******* Esta rutina enva toda la paleta de color a la memoria CG-RAM desde $7E:3000 por el canal 0 DMA.		********
	;*************************************************************************************************************************
DMA0_PALETTE_DATA_TO_CGRAM
	;******* direccin CGRAM a $0000
	LDA.b	$00
	STA.w	$2121
	LDA.b	#$02
	STA.w	$4300
	LDA.b	#$22
	STA.w	$4301
	LDY.w	#$3000
	STY.w	$4302
	LDA.b	#$7E
	STA.w	$4304
	LDY.w	#$0200
	STY.w	$4305
	LDA.b	#$01
	STA.w	$420B
	RTS







	;*************************************************************************************************************************
	;******* 						RUTINA $7E/72B0							********
	;******* Esta rutina copia 32 bytes desde el offset apuntado por el registro X al offset apuntado por el registro	********
	;******* Y, ambos en el banco $7E de RAM.											********
	;*************************************************************************************************************************
COPY_32BYTES_FROM_REGY_TO_REGX
	;******* puntero de escritura
	STX.b	$E7
	;******* puntero de lectura
	STY.b	$EB
	LDY.b	$00
	REP	#$20
	;******* bucle de copia de 32 bytes
Tag_$7E72B8
	LDA.b	($EB),y
	STA.b	($E7),y
	INY
	INY
	CPY.w	#$0020
	BNE	Tag_$7E72B8
	SEP	#$20
	RTS






	;*************************************************************************************************************************
	;******* 						RUTINA $7E/72C6							********
	;*************************************************************************************************************************
RUTINA_$7E72C6
	PHA
	STX.b	$E7
	STY.b	$EB
	LDA.b	#$00
	LDY.w	#!RUTINA_$7E72E6
	JSR.w	!INSERT_ROUTINE_IN_CALLBACK_LIST
	PLA
	STA.w	$3901,x
	REP	#$20
	;******* guardamos el offset origen de la copia de datos, que se pasa en el registro X
	LDA.b	$E7
	STA.w	$3300,x
	;******* guardamos el offset destino de la copia de datos, que se pasa en el registro Y
	LDA.b	$EB
	STA.w	$3400,x
	SEP	#$20
	RTS






	;*************************************************************************************************************************
	;******* 						RUTINA $7E/72E6							********
	;*************************************************************************************************************************
RUTINA_$7E72E6
	TAX
	JMP.w	(!ROUTINE_TABLE_$7E72EA,x)


ROUTINE_TABLE_$7E72EA
	.dcw	!RUTINA_$7E72EE, !RUTINA_$7E72FD





	;*************************************************************************************************************************
	;******* 						RUTINA $7E/72EE							********
	;*************************************************************************************************************************
RUTINA_$7E72EE	
	LDX.b	$1D
	;******* inicializamos a 31 este contador
	LDA.b	#$1F
	STA.w	$3600,x
	;******* inicializamos a 0 este contador
	STZ.w	$3601,x
	;******* incrementamos la variable para que la prxima ejecucin de $7E:72E6 sea de la segunda rutina
	INC.w	$3A00,x
	SEC
	RTS





	;*************************************************************************************************************************
	;******* 						RUTINA $7E/72FD							********
	;*************************************************************************************************************************
RUTINA_$7E72FD
	;******* leemos la posicin en el array de eventos que ocupa la rutina
	LDX.b	$1D
	;******* leemos el contador y si es cero, ejecutamos el resto de la funcin
	LDA.w	$3900,x
	BNE	Tag_$7E732F
	;******* recargamos el contador
	LDA.w	$3901,x
	STA.w	$3900,x
	REP	#$20
	;******* leemos el offset de lectura y creamos el puntero ($E0)
	LDA.w	$3300,x
	STA.b	$E0
	;******* leemos el offset de escritura y creamos el puntero ($E3)
	LDA.w	$3400,x
	STA.b	$E3
	LDA.w	$3600,x
	STA.b	$F1
	JSR.w	!RUTINA_$7E7334
	SEP	#$20
	;******* leemos el contador con valor 31 que se recarga al ejecutar la primera rutina
	LDX.w	$001D
	LDA.w	$3600,x
	BEQ	Tag_$7E732D
	;******* si el contador no ha llegado a cero, lo decrementamos y salimos con el CARRY a '1' para que no se quite la
	;******* rutina de la lista de eventos
	DEC.w	$3600,x
	BNE	Tag_$7E732F
Tag_$7E732D
	CLC
	RTS
Tag_$7E732F
	;******* si el contador no es cero, lo decrementamos y salimos de la rutina con el CARRY activo para que no se quite
	;******* esta rutina de la lista de eventos
	DEC.w	$3900,x
	SEC
	RTS










	;*************************************************************************************************************************
	;******* 						RUTINA $7E/7334							********
	;*************************************************************************************************************************
RUTINA_$7E7334
	LDX.w	#$0010
	LDY.b	$00
Tag_$7E7339
	;******* leemos los primeros 16 bits que vienen de la RAM usable
	LDA.b	($E0),y
	STA.b	$E7
	;******* leemos los siguientes 16 bits que vienen de la tabla constante de RAM
	LDA.b	($E3),y
	STA.b	$E9
	;*******
	JSR.w	!RUTINA_$7E734E
	;******* guardamos el valor con los 3 contadores de 5 bits actualizados
	LDA.b	$E7
	STA.w	($E0),y
	INY
	INY
	DEX
	BNE	Tag_$7E7339
	RTS





	;*************************************************************************************************************************
	;******* 						RUTINA $7E/734E							********
	;*************************************************************************************************************************
RUTINA_$7E734E
	;******* nos quedamos con los 5 bits ms bajos de RAM (puntero $E0 -> $7E:3300)
	LDA.b	$E7
	AND.w	#$001F
	STA.b	$EB
	;******* nos quedamos con los 5 bits ms bajos de la tabla (puntero $E3 -> $7E:3400)
	LDA.b	$E9
	AND.w	#$001F
	;******* restamos ambos valores
	SEC
	SBC.b	$EB
	;******* si los contadores coinciden no hacemos nada
	BEQ	Tag_$7E736B
	BCC	Tag_$7E7369
	;******* si el contador de RAM ha superado el valor fijo de la tabla, comparamos por cunto lo ha superado
	CMP.b	$F1
	BCC	Tag_$7E736B
	INC.b	$EB
	BRA	Tag_$7E736B
Tag_$7E7369
	DEC.b	$EB
Tag_$7E736B
	;******* nos quedamos con los 5 bits siguientes del primer dato ledo (puntero $E0 -> $7E:3300)
	LDA.b	$E7
	AND.w	#$03E0
	STA.b	$ED
	;******* nos quedamos con los 5 bits siguientes del segundo dato ledo (puntero $E3 -> $7E:3400)
	LDA.b	$E9
	AND.w	#$03E0
	SEC
	SBC.b	$ED
	BEQ	Tag_$7E7398
	BCC	Tag_$7E7390
	;******* ponemos esos 5 bits en la parte baja del acumulador
	ASL	A
	ASL	A
	ASL	A
	XBA
	CMP.b	$F1
	BCC	Tag_$7E7398
	CLC
	;******* incrementamos en 1 unidad esos 5 bits
	LDA.b	$ED
	ADC.w	#$0020
	STA.b	$ED
	BRA	Tag_$7E7398
Tag_$7E7390
	;******* decrementamos en 1 unidad esos 5 bits
	LDA.b	$ED
	SEC
	SBC.w	#$0020
	STA.b	$ED
Tag_$7E7398
	;******* nos quedamos con los 5 bits ltimos del primer dato ledo (puntero $E0 -> $7E:3300)
	LDA.b	$E7
	AND.w	#$7C00
	STA.b	$EF
	;******* nos quedamos con los 5 bits ltimos del segundo dato ledo (puntero $E3 -> $7E:3400)
	LDA.b	$E9
	AND.w	#$7C00
	SEC
	SBC.b	$EF
	BEQ	Tag_$7E73C8
	BCC	Tag_$7E73C0
	SEP	#$20
	;******* ponemos esos 5 bits en la parte baja del acumulador
	XBA
	LSR	A
	LSR	A
	REP	#$20
	CMP.b	$F1
	BCC	Tag_$7E73C8
	CLC
	;******* incrementamos en 1 unidad esos 5 bits
	LDA.b	$EF
	ADC.w	#$0400
	STA.b	$EF
	BRA	Tag_$7E73C8
Tag_$7E73C0
	;******* decrementamos en 1 unidad esos 5 bits
	LDA.b	$EF
	SEC
	SBC.w	#$0400
	STA.b	$EF
Tag_$7E73C8
	;******* agrupamos de nuevo los 3 contadores de 5 bits ya actualizados y los devolvemos en $E7
	LDA.b	$EB
	ORA.b	$ED
	ORA.b	$EF
	STA.b	$E7
	RTS





TABLE_$7E73D1
	.dcw	$0000, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF



TABLE_$7E73F1
	.dcw	$0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000





	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/7411							********
	;*************************************************************************************************************************
INIT_OAM_BUFFER_N_CALLBACK
	;******* inicializamos a 0 la posicin de la ltima funcin de callback leda y el nmero de funciones de callback en la
	;******* lista $7E:3200
	LDX.b	$00
	STX.b	$1D
	STX.b	$1F
	REP	#$20
	;****** inicializamos el buffer de RAM con la tabla OAM en $7E:0300
	JSR.w	!INITIALIZE_OAM_RAM_BUFFER
	SEP	#$10
	TDC
	TAX
	;******* con este bucle rellena con ceros el array de funciones de callback $7E:3200, el de parmetros para esas funciones
	;******* en $7E:3300, el de saltos a las tablas de funciones $7E:3A00, y los arrays de 256 posiciones $7E:3400, $7E:3500,
	;******* $7E:3700, $7E:3800, $7E:3900 y $7E:3C00
Tag_$7E7420
	STZ.w	$3200,x
	STZ.w	$3A00,x
	STZ.w	$3C00,x
	STZ.w	$3300,x
	STZ.w	$3400,x
	STZ.w	$3700,x
	STZ.w	$3800,x
	STZ.w	$3900,x
	INX
	INX
	CPX.b	#$00
	BNE	Tag_$7E7420
	SEP	#$20
	REP	#$10
	RTS







	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/7443							********
	;******* Esta rutina inicializa toda la tabla OAM en RAM con valores que evita que ningn sprite se vea.		********
	;*************************************************************************************************************************
INITIALIZE_OAM_RAM_BUFFER
	TDC
	TAX
Tag_$7E7445
	LDA.w	#$E001
	STA.w	$0300,x
	INX
	INX
	LDA.w	#$0001
	STA.w	$0300,x
	INX
	INX
	CPX.w	#$0200
	BNE	Tag_$7E7445
	LDY.b	$00  
	TYA
Tag_$7E745D
	STA.w	$0500,y
	INY
	INY
	CPY.w	#$0020
	BNE	Tag_$7E745D
	RTS










	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/7468							********
	;******* Esta rutina mete la funcin pasada en Y en la lista de funciones de callback en el bloque indicado por	********
	;******* el byte en el acumulador. Adems mete la variable $1D en $7E:3C01 (mismo slot que la lista de callback)	********
	;******* e incrementa $1F.													********
	;*************************************************************************************************************************
INSERT_ROUTINE_IN_CALLBACK_LIST
	;******* metemos la rutina pasada en Y en la lista de funciones de callback
	JSR.w	!RUTINA_$7E7475
	SEP	#$20
	;******* leemos la posicin en la que ejecut la ltima rutina en el array $7E:3200 y la metemos en $7E:3C01
	LDA.b	$1D  
	STA.w	$3C01,x
	;******* incrementamos la cantidad de rutinas en la lista de callback
	INC.b	$1F  
	RTS






	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/7475							********
	;******* Esta rutina mete el puntero a funcin pasado en el registro Y en el array de eventos $7E:3200 en el	********
	;******* bloque indicado por el valor del acumulador. Este array se divide en 4 bloques de 32 slots cada uno	********
	;******* y en cada slot hay un puntero a funcin. En caso de no encontrar ningn hueco libre en el array, metemos	********
	;******* el puntero a funcin en el ltimo sloty nos quedamos en un bucle infinito.					********
	;*************************************************************************************************************************
RUTINA_$7E7475
	;******* multiplicamos por 32 el valor pasado en el acumulador
	XBA
	LDA.b	#$00
	XBA
	ASL	A
	ASL	A
	ASL	A
	ASL 	A
	ASL	A
	REP	#$20
	TAX
Tag_$7E7481
	;******* si este slot tiene un valor diferente de 0, saltamos a mirar el siguiente slot
	LDA.w	$3200,x
	BNE	Tag_$7E748B
	TYA
	STA.w	$3200,x
	RTS
Tag_$7E748B
	;******* pasamos al siguiente slot
	INX
	INX
	;******* hay 128 slots para funciones de acciones/eventos
	CPX.w	#$0100
	BNE	Tag_$7E7481
	;******* si no hemos encontrado ningn hueco libre, metemos la rutina en la ltima posicin del array y nos quedamos
	;******* en un bucle infinito esperando
	DEX
	DEX
	TYA
	STA.w	$3200,x
Tag_$7E7498
	BRA	Tag_$7E7498
	RTS








	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/749B							********
	;******* Esta rutina recorre los 4 bloques de 32 funciones en el array $7E:3200 y va ejecutando las rutinas que	********
	;******* se encuentran en esa lista. Si una de las entradas del array es $0000, es que no hay ninguna rutina y	********
	;******* se pasa al siguiente slot.	Las variables implicadas son:							********
	;*******	* $7E:3200 -> lista con los 128 punteros a rutina en el banco $7E					********
	;*******	* $7E:3300 -> lista con los 128 parmetros de 16 bits para cada una de las rutinas indexadas en	********
	;*******			$7E:3200											********
	;*******	* $7E:3A00 -> lista con los 128 ndices a las tablas de rutinas que se ejecutan en la rutina 	********
	;*******			llamada											********
	;*******	* $1D	    ->	variable con el ndice X a la lista de rutinas $7E:3200 que ocupa la rutina actual	********
	;*******			llamada para que ella pueda acceder a sus parmetros					********
	;*************************************************************************************************************************
EXECUTE_CALLBACK_EVENT_LIST
	LDX.w	#$0300
	STX.b	$0A  
	LDX.w	#$0500
	STX.b	$0C  
	LDA.b	#$03
	STA.b	$23  
	STZ.b	$24
	;****** este valor a '0' indica que hay que quitar de pantalla todos los sprites
	LDX.w	#$0080
	STX.b	$21  
	LDX.b	$00  
	REP	#$20
Tag_$7E74B4
	;******* leemos el slot de la lista de funciones de callback
	LDA.w	$3200,x
	BEQ	Tag_$7E74DB
	;******* si hay algo en ese slot, metemos la posicin que ocupa en la lista en la variable $1D para que la rutina llamada
	;******* pueda acceder a sus parmetros
	STX.b	$1D  
	PHX
	;******* guardamos el puntero a la funcin en la variable desde donde se ejecutar el salto a ella
	STA.b	$1B  
	SEP	#$20
	;******* pasamos el parmetro en el acumulador a esa funcin, que es el ndice de la rutina que se
	;******* ejecutar segn la tabla que corresponda a esa funcin
	TDC
	LDA.w	$3A00,x
	ASL	A
	;******* ejecutamos la funcin de callback
	JSR.w	!RUTINA_$7E74E8
	REP	#$20
	PLX
	BCS	Tag_$7E74DB
	;******* si la rutina devolvi un '0' en el CARRY, la borramos de la lista de callback
	STZ.w	$3200,x
	;******* borramos sus parmetros tambin
	STZ.w	$3A00,x
	STZ.w	$3C00,x
	STZ.w	$3900,x
	;******* decrementamos la cantidad de funciones de callback en la lista
	DEC.b	$1F
Tag_$7E74DB
	;******* pasamos al siguiente slot de la lista
	INX
	INX
	CPX.w	#$0100
	BNE	Tag_$7E74B4
	;******* cuando ya no quedan ms rutinas por ejecutar, comprobamos si hay que quitar de pantalla todos
	;******* los sprites chequeando la variable $21
	JSR.w	!RUTINA_$7E761B
	SEP	#$20
	RTS





	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/74E8							********
	;*************************************************************************************************************************
RUTINA_$7E74E8
	JMP.w	($001B)








	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/74EB							********
	;******* Esta rutina inicializa la variable $7E:3B00 que se usa como ndice junto con ($3B) para moverse por la	********
	;******* tabla de punteros; la variable $7E:3B01 se actualiza con el byte que sigue al puntero en la tabla.	********
	;*************************************************************************************************************************
RUTINA_$7E74EB
	;******* ponemos un 0 en la variable ndice para leer de la tabla de punteros
	TDC
	STA.w	$3B00,x
	REP	#$20
	;******* leemos la direccin donde est la tabla de punteros
	LDA.w	$3500,x
	STA.b	$EB  
	SEP	#$20
	;******* leemos el byte que sigue al puntero y lo guardamos en $7E:3B01
	LDY.w	#$0002
	LDA.b	($EB),y
	STA.w	$3B01,x
	RTS




	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/7501							********
	;*************************************************************************************************************************
RUTINA_$7E7501
	PHX
	JSR.w	!RUTINA_$7E751F
	SEP	#$10
	LDA.w	$3B00,x
	TAY
	REP	#$20
	LDA.b	($EB),y
	REP	#$10
	TAY
	SEP	#$20
	PLX
	JSR.w	!COPY_32BYTES_FROM_REGY_TO_REGX
	RTS






	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/751F							********
	;*************************************************************************************************************************
RUTINA_$7E751F
	LDX.b	$1D
	LDY.b	$00
	REP	#$20
	;******* con la direccin a la tabla de punteros formamos ($EB)
	LDA.w	$3500,x
	STA.b	$EB
	SEP	#$20
Tag_$7E752C
	;******* leemos el byte que sigue al puntero, que se usa como contador, y si es $FE salimos de la rutina
	LDA.w	$3B01,x
	CMP.b	#$FE
	BEQ	Tag_$7E7555
	;******* si el byte contador es $FF (-1), nos quedamos en un bucle de espera
	CMP.b	#$FF
	BNE	Tag_$7E753F
	;******* si el byte que sigue al puntero es $FF, reiniciamos a 0 la variable ndice para movernos por la tabla de punteros
	STZ.w	$3B00,x
	JSR.w	!RUTINA_$7E7556
	BRA	Tag_$7E752C
Tag_$7E753F
	;******* leemos el byte que sigue al puntero (usado como contador)
	LDA.w	$3B01,x
	BNE	Tag_$7E7552
	;******* SI EL CONTADOR HA LLEGADO A 0
	;******* incrementamos $7E:3B00 para que apunte al siguiente puntero de la tabla
	LDA.w	$3B00,x
	CLC
	ADC.b	#$03
	STA.w	$3B00,x
	;******* leemos el byte que sigue al siguiente puntero de la tabla
	JSR.w	!RUTINA_$7E7556
	BRA	Tag_$7E752C
Tag_$7E7552
	;******* si no ha llegado a 0, decrementamos el contador
	DEC.w	$3B01,x
Tag_$7E7555
	RTS






	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/7556							********
	;*************************************************************************************************************************
RUTINA_$7E7556
	SEP	#$10
	LDA.w	$3B00,x
	TAY
	INY
	INY
	LDA.b	($EB),y
	STA.w	$3B01,x
	REP	#$10
	RTS






	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/7519							********
	;*************************************************************************************************************************
RUTINA_$7E7519
	JSR.w	!RUTINA_$7E751F
	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/7566							********
	;*************************************************************************************************************************
RUTINA_$7E7566
	SEP	#$10
	LDA.w	$3B00,x
	TAY
	REP	#$20
	LDA.b	($EB),y
	STA.b	$E7  
	INY
	INY
	SEP	#$20
	REP	#$10
	LDY.b	$00  
	LDA.b	$21  
	BEQ	Tag_$7E75E8
	LDA.b	($E7),y
	STA.b	$E6  
	BEQ	Tag_$7E75E8
	INY
Tag_$7E7585
	LDA.b	($E7),y
	STA.b	$E0  
	BPL	Tag_$7E759D
	TDC
	LDA.b	$23  
	TAX
	LDA.w	!TABLE_$7E7617,x
	CLC
	ADC.b	$24  
	STA.b	$24  
	STA.b	($0C)
	LDX.b	$1D  
	BRA	Tag_$7E75A1
Tag_$7E759D
	LDA.b	$24  
	STA.b	($0C)
Tag_$7E75A1
	LDA.b	$E0  
	AND.b	#$7F
	STA.b	$E0  
	LDA.w	$3A01,x
	BIT.b	#$01
	BEQ	Tag_$7E75BB
	STZ.b	$E1  
	REP	#$20
	LDA.b	$E0  
	SEC
	SBC.b	$25  
	STA.b	$E0  
	SEP	#$20
Tag_$7E75BB
	JSR.w	!RUTINA_$7E75E9
	DEC.b	$23  
	BPL	Tag_$7E75CC
	LDA.b	#$03
	STA.b	$23  
	STZ.b	$24  
	REP	#$20
	INC.b	$0C 
Tag_$7E75CC 
	REP	#$20
	LDA.b	$E0  
	STA.b	($0A)
	INC.b	$0A  
	INC.b	$0A  
	LDA.b	$E2  
	STA.b	($0A)
	INC.b	$0A  
	INC.b	$0A  
	SEP	#$20
	DEC.b	$21  
	BEQ	Tag_$7E75E8
	DEC.b	$E6  
	BNE	Tag_$7E7585
Tag_$7E75E8
	RTS






	;*************************************************************************************************************************
	;******* 						    RUTINA $7E/75E9							********
	;*************************************************************************************************************************
RUTINA_$7E75E9
	LDA.b	$E0  
	CLC
	ADC.w	$3301,x
	STA.b	$E0  
	INY
	LDA.b	($E7),y
	CLC
	ADC.w	$3401,x
	STA.b	$E1  
	INY
	LDA.b	($E7),y
	STA.b	$E2  
	INY
	LDA.w	$3A01,x
	BIT.b	#$02
	BEQ	Tag_$7E760D
	LDA.b	($E7),y
	ORA.b	#$40
	BRA	Tag_$7E760F
Tag_$7E760D
	LDA.b	($E7),y
Tag_$7E760F
	CLC
	ADC.w	$3C00,x
	STA.b	$E3  
	INY
	RTS




TABLE_$7E7617
	.dcb	$80, $20, $08, $02








	;*************************************************************************************************************************
	;******* 						RUTINA $7E/761B							********
	;*************************************************************************************************************************
RUTINA_$7E761B
	;******* comprobamos esta variable, y si es diferente a 0, anulamos todos los sprites de la tabla OAM por completo
	LDY.b	$21  
	BEQ	Tag_$7E762F
	LDX.w	#$01FC
	LDA.w	#$E001
Tag_$7E7625
	STA.w	$0300,x
	DEX
	DEX
	DEX
	DEX
	DEY
	BNE	Tag_$7E7625
Tag_$7E762F
	RTS








	;*************************************************************************************************************************
	;******* 						RUTINA $7E/7630							********
	;*************************************************************************************************************************
RUTINA_$7E7630
	LDX.b	$1D  
	LDY.b	$00  
	REP	#$20
	LDA.w	$3500,x
	STA.b	$EB  
	SEP	#$20
Tag_$7E763D
	LDA.w	$3B01,x
	CMP.b	#$FE
	BEQ	Tag_$7E7666
	CMP.b	#$FF
	BNE	Tag_$7E7650
	STZ.w	$3B00,x
	JSR.w	!RUTINA_$7E7556
	BRA	Tag_$7E763D
Tag_$7E7650
	LDA.w	$3B01,x
	BNE	Tag_$7E7663
	LDA.w	$3B00,x
	CLC
	ADC.b	#$03
	STA.w	$3B00,x
	JSR.w	!RUTINA_$7E7556
	BRA	Tag_$7E763D
Tag_$7E7663
	DEC.w	$3B01,x
Tag_$7E7666
	RTS







	;*************************************************************************************************************************
	;******* 						RUTINA $7E/7667							********
	;*************************************************************************************************************************
RUTINA_$7E7667
	TAX
	JMP.w	(!ROUTINE_TABLE_$7E766B,x)




ROUTINE_TABLE_$7E766B
	.dcw	!RUTINA_$7E766F, !RUTINA_$7E7677






	;*************************************************************************************************************************
	;******* 						RUTINA $7E/766F							********
	;*************************************************************************************************************************
RUTINA_$7E766F
	LDX.b	$1D  
	INC.w	$3A00,x
	JSR.w	!RUTINA_$7E74EB
RUTINA_$7E7677
	LDA.b	$33  
	BIT.b	#$40
	BNE	Tag_$7E769B
	LDX.b	$1D  
	REP	#$21
	LDA.w	$3300,x
	ADC.w	$3700,x
	STA.w	$3300,x
	LDA.w	$3400,x
	CLC
	ADC.w	$3800,x
	STA.w	$3400,x
	SEP	#$20
	JSR.w	!RUTINA_$7E7519
	SEC
	RTS
Tag_$7E769B
	CLC
	RTS






	;*************************************************************************************************************************
	;******* 						RUTINA $7E/769D							********
	;*************************************************************************************************************************
INITIALIZE_ALL_PPU_REGISTERS
	PHB
	LDA.b	#$00
	PHA
	PLB
	;******* ponemos un 0 en el acumulador (8 bits)
	TDC
	;******* ponemos un 0 en el registro Y (16 bits)
	TAY
	;******* inicializamos a 0 los registros de la PPU
	STY.w	$2181
	STY.w	$2102
	STA.w	$2104
	STA.w	$2104
	STA.w	$2106
	STA.w	$420C
	STA.w	$420B
	STA.w	$210D
	STA.w	$210D
	STA.w	$210E
	STA.w	$210E
	STA.w	$210F
	STA.w	$210F
	STA.w	$2110
	STA.w	$2110
	STA.w	$2111
	STA.w	$2111
	STA.w	$2112
	STA.w	$2112
	STA.w	$2113
	STA.w	$2113
	STA.w	$2114
	STA.w	$2114
	STY.w	$2116
	STY.w	$2118
	STA.w	$211A
	STA.w	$2121
	STA.w	$2122
	STA.w	$2122
	STA.w	$2123
	STA.w	$2124
	STA.w	$2125
	STA.w	$2126
	STA.w	$2128
	STA.w	$2127
	STA.w	$2129
	STA.w	$212A
	STA.w	$212B
	STA.w	$212E
	STA.w	$212F
	STA.w	$2133
	STA.w	$4200
	STA.w	$4202
	STA.w	$4203
	STA.w	$4204
	STA.w	$4204
	STA.w	$4205
	STA.w	$4206
	STA.w	$4207
	STA.w	$4207
	STA.w	$4208
	STA.w	$4209
	STA.w	$4209
	STA.w	$420A
	STA.w	$420B
	STA.w	$420C
	;****** NAME_SELECT = 0 / NAME_BASE_SELECT = 3 / SPRITES 16x16 y 32x32
	LDA.b	#$63
	STA.w	$2101
	;****** OAM_ADDRESS = 0
	LDX.b	$00
	STX.w	$2102
	;****** BG_MODE = 1 / TODOS LOS BACKGROUND CON TILES 8x8 / BG0 y BG1 DE 16 COLORES / BG2 DE 4 COLORES
	LDA.b	#$01
	STA.w	$2105
	;****** BG0 -> TILEMAP_ADDRESS = 0 / PANTALLA FORMADA POR 4 TILEMAPs de 32x32
	;****** esta configuracin implica que hay un tilemap A de $800 bytes en VRAM con las tpicas entradas de 2
	;****** bytes que indican qu tile de 8x8 poner en esa posicin. Adems, hay otro tilemap B del mismo tamao
	;****** a continuacin del anterior en VRAM que est a la derecha del anterior. Lo mismo para los tilemaps
	;****** C y D que estn debajo de los otros dos A y B.
	LDA.b	#$03
	STA.w	$2107
	;****** BG1 -> TILEMAP_ADDRESS = 4 / PANTALLA FORMADA POR 2 TILEMAPS HORIZONTALES DE 32x32
	LDA.b	#$11
	STA.w	$2108
	;****** BG2 -> TILEMAP_ADDRESS = 6 / PANTALLA FORMADA POR 2 TILEMAPS HORIZONTALES DE 32x32
	LDA.b	#$19
	STA.w	$2109
	;****** BG3 -> TILEMAP_ADDRESS = 6 / PANTALLA FORMADA POR 2 TILEMAPS HORIZONTALES DE 32x32
	STA.w	$210A
	;****** BG0 -> BASE_ADDRESS = 0x3000 / BG1 -> BASE_ADDRESS = 0x2000
	LDA.b	#$23
	STA.w	$210B
	;****** BG2 -> BASE_ADDRESS = 0x2000 / BG3 -> BASE_ADDRESS = 0x2000
	LDA.b	#$22
	STA.w	$210C
	LDA.b	#$80
	STA.w	$2115
	LDA.b	#$FF
	STA.w	$4201
	LDA.b	#$7E
	STA.w	$2183
	LDA.b	#$1F
	STA.w	$212C
	LDA.b	#$04
	STA.w	$212D
	LDA.b	#$02
	STA.w	$2130
	LDA.b	#$42
	STA.w	$2131
	LDA.b	#$E0
	STA.w	$2132
	PLB
	RTS





	;*************************************************************************************************************************
	;******* 						RUTINA $7E/77A1							********
	;*************************************************************************************************************************
INIT_RAM_BUFFER_N_VARIABLES
	TDC
	TAY
	;******* ponemos a 0 la zona de memoria entre $7E:0025 y $7E:0030
	STY.b	$25
	STY.b	$27
	STY.b	$29
	STY.b	$2B
	STY.b	$2D
	STY.b	$2F
	;****** ponemos a 0 el contador de frames
	STY.b	$15
	;****** ponemos a 0 las variables de control de pulsaciones en el joypad
	STY.b	$04
	STY.b	$06
	STY.b	$08
	STA.b	$33
	STA.b	$18
	STA.b	$19
	STA.b	$1A
	STA.b	$17
	STA.b	$31
	STA.b	$32
	STA.b	$36
	STY.b	$12
	STY.b	$0E
	LDA.b	#$7E
	STA.b	$14
	LDY.w	#$FFFF
	STY.b	$10
	;****** con estas dos rutinas inicializamos la zona de memoria RAM entre $7E:3D00 a $7E:4780.
	JSR.w	!RUTINA_$7E77F0
	JSR.w	!RUTINA_$7E77FC
	RTS







	;*************************************************************************************************************************
	;******* 						RUTINA $7E/77DB							********
	;******* Esta rutina borra por completo la VRAM.										********
	;*************************************************************************************************************************
ERASE_FULL_VRAM
	REP	#$20
	;******* ponemos la direccin de VRAM a $0000
	TDC
	STA.l	$002116
	;******* borramos el acumulador y el registro Y
	TAY
Tag_$7E77E3
	STA.l	$002118
	INY
	CPY.w	#$8000
	BNE	Tag_$7E77E3
	SEP #$20
	RTS







	;*************************************************************************************************************************
	;******* 						RUTINA $7E/77F0							********
	;******* Esta rutina inicializa a 0 la zona de memoria RAM $7E:3D00 a $7E:4780.					********
	;*************************************************************************************************************************
RUTINA_$7E77F0
	;******* borramos el acumulador y el registro X
	TDC
	TAX
	;******* este bucle borra toda la memoria entre $7E:3D00 y $7E:4780
Tag_$7E77F2
	STZ.w	$3D00,x
	INX
	CPX.w	#$0A80
	BNE	Tag_$7E77F2
	RTS






	;*************************************************************************************************************************
	;******* 						RUTINA $7E/77FC							********
	;******* Esta rutina inicializa a 0 la zona de memoria RAM $7E:3D00 a $7E:4780.					********
	;*************************************************************************************************************************
RUTINA_$7E77FC
	REP	#$20
	TDC
	TAX
	LDA.w	#$011F
	;****** rellenamos con $00 / $00 / $01 / $1F la zona de memoria entre $7E:3D00 a $7E:4080
Tag_$7E7803
	STA.w	$3D02,x
	INX
	INX
	INX
	INX
	CPX.w	#$0380
	BNE	Tag_$7E7803
	TDC
	TAX
	;****** rellenamos con $00 / $00 / $00 / $00 la zona de memoria entre $7E:3EA0 a $7E:3EC0
Tag_$7E7811
	STA.w	$3EA2,x
	INX
	INX
	INX
	INX
	CPX.w	#$0020
	BNE	Tag_$7E7811
	TDC
	TAX
	LDA.w	#$0100
	;****** rellenamos con $00 / $00 / $01 / $1F la zona de memoria entre $7E:3DFA a $7E:3EBE
Tag_$7E7822
	STA.w	$3DFC,x
	INX
	INX
	INX
	INX
	CPX.w	#$00C4
	BNE	Tag_$7E7822
	SEP	#$20
	RTS





	;*************************************************************************************************************************
	;******* 						RUTINA $7E/7831							********
	;******* Esta rutina inicializa las transferencias DMA por los canales 2 (BG0), 3 (BG1) y 4 (BG2).			********
	;*************************************************************************************************************************
SET_INDIR_HDMA_CHANNELS_2_3_4
	PHB
	LDA.b	#$00
	PHA
	PLB
	;******* la transferencia H-DMA de los tres canales es indirecta y escribe 2 bytes en el registro P y 2 en el P+1
	LDA.b	#$43
	STA.w	$4320
	STA.w	$4330
	STA.w	$4340
	;******* banco para la direccin indirecta
	LDA.b	#$7E
	STA.w	$4324
	STA.w	$4334
	STA.w	$4344
	STA.w	$4327
	STA.w	$4337
	STA.w	$4347
	;******* BGSCROLL de BG0 en H-DMA[2]
	LDA.b	#$0D
	STA.w	$4321
	LDY.w	#!HDMA_TABLE_$7E787E
	STY.w	$4322
	;******* BGSCROLL de BG1 en H-DMA[3]
	LDA.b	#$0F
	STA.w	$4331
	LDY.w	#!HDMA_TABLE_$7E7885
	STY.w	$4332
	;******* BGSCROLL de BG2 en H-DMA[4]
	LDA.b	#$11
	STA.w	$4341
	LDY.w	#!HDMA_TABLE_$7E788C
	STY.w	$4342
	LDA.b	#$1C
	TSB.b	$31
	PLB
	RTS



HDMA_TABLE_$7E787E
	.dcb	(128+100)
	.dcw	$3D00
	.dcb	(128+123)
	.dcw	$3E90
	.dcb	$00


HDMA_TABLE_$7E7885
	.dcb	(128+100)
	.dcw	$4080
	.dcb	(128+123)
	.dcw	$4210
	.dcb	$00


HDMA_TABLE_$7E788C
	.dcb	(128+100)
	.dcw	$4400
	.dcb	(128+123)
	.dcw	$4590
	.dcb	$00






	;*************************************************************************************************************************
	;******* 						RUTINA $7E/7894							********
	;*************************************************************************************************************************
INITIALIZE_VRAM_FFVI_MAINSCREEN
	;******* descomprimimos el chunk en $D8:F000 y lo dejamos en $7F:0000
	JSR.w	!DECOMPRESS_GRAPHIC_DATA_$D8F000
	;******* TRANSFERENCIA DE $1C00 BYTES DESDE $7F:7930 A $1900 DE VRAM
	;******* puntero de lectura $7F:7930 
	LDY.w	#$7930
	STY.b	$E7
	LDA.b	#$7F
	STA.b	$E9
	;******* nmero de bytes a copiar en VRAM
	LDY.w	#$01C0
	STY.b	$EB
	;******* mscara para grabar los datos en VRAM (mapa)
	LDY.w	#$1400
	STY.b	$ED
	;******* direccin de destino en VRAM $1900
	LDY.w	#$1900
	JSR.w	!COPY_TILEMAP_FROM_$E7_TO_VRAM
	;******* TRANSFERENCIA DE $06B0 BYTES DESDE $7F:7AF0 A $2000 DE VRAM
	LDY.w	#$7AF0
	STY.b	$E7
	LDA.b	#$7F
	STA.b	$E9
	LDY.w	#$06B0
	STY.b	$EB
	STZ.b	$ED
	STZ.b	$EE
	LDY.w	#$2000
	JSR.w	!COPY_TILEMAP_FROM_$E7_TO_VRAM
	;******* TRANSFERENCIA DE $01C0 BYTES DESDE $7F:81A0 A $1100 DE VRAM
	LDY.w	#$81A0
	STY.b	$E7
	LDA.b	#$7F
	STA.b	$E9
	LDY.w	#$01C0
	STY.b	$EB
	LDY.w	#$0080
	STY.b	$ED
	LDY.w	#$1100
	JSR.w	!COPY_TILEMAP_FROM_$E7_TO_VRAM
	;******* TRANSFERENCIA DE $1800 BYTES DESDE $7F:1BC0 A $0000 DE VRAM
	LDY.w	#$1BC0
	STY.b	$E7
	LDA.b	#$7F
	STA.b	$E9
	LDY.w	#$1800
	STY.b	$EB
	STZ.b	$ED
	STZ.b	$EE
	LDY.w	#$0000
	JSR.w	!COPY_TILEMAP_FROM_$E7_TO_VRAM
	;******* TRANSFERENCIA DE $4200 BYTES DESDE $7F:33C0 A $4000 DE VRAM
	LDY.w	#$33C0
	STY.b	$E7
	LDA.b	#$7F
	STA.b	$E9
	LDY.w	#$4200
	STY.b	$EB
	STZ.b	$ED
	STZ.b	$EE
	LDY.w	#$4000
	JSR.w	!COPY_TILEMAP_FROM_$E7_TO_VRAM
	TDC
	TAX
	REP	#$20
	;******* TRANSFERENCIA DE $2000 BYTES DESDE LA POSICIN INDEXADA EN LA TABLA $DF:DAE1 A $3000 DE VRAM
	LDA.l	$DFDAE1,x
	CLC
	ADC.w	#$DB00
	STA.b	$E7
	INX
	INX
	SEP	#$20
	LDA.l	$DFDAE1,x
	ADC.b	#$DF
	STA.b	$E9
	LDY.w	#$2000
	STY.b	$EB
	STZ.b	$ED
	STZ.b	$EE
	LDY.w	#$3000
	JSR.w	!COPY_TILEMAP_FROM_$E7_TO_VRAM
	;******* TRANSFERENCIA DE $0800 BYTES DESDE $7F:8360 A $2800 DE VRAM
	LDY.w	#$8360
	STY.b	$E7
	LDA.b	#$7F
	STA.b	$E9
	LDY.w	#$0800
	STY.b	$EB
	STZ.b	$ED
	STZ.b	$EE
	LDY.w	#$2800
	JSR.w	!COPY_TILEMAP_FROM_$E7_TO_VRAM
	;******* rellenamos la VRAM en las direcciones $0400 y $0C00 con el dato fijo $0787
	JSR.w	!RUTINA_$7E79CD
	;******* TRANSFERENCIA DE $0140 BYTES DESDE $7F:8B60 A $0500 DE VRAM con mscara $0780
	LDY.w	#$8B60
	STY.b	$E7
	LDA.b	#$7F
	STA.b	$E9
	LDY.w	#$0140
	STY.b	$EB
	LDY.w	#$0780
	STY.b	$ED
	LDY.w	#$0500
	JSR.w	!COPY_TILEMAP_FROM_$E7_TO_VRAM
	;******* TRANSFERENCIA DE $0C00 BYTES DESDE $7F:8CE0 A $6800 DE VRAM
	LDY.w	#$8CE0
	STY.b	$E7
	LDA.b	#$7F
	STA.b	$E9
	LDY.w	#$0C00
	STY.b	$EB
	STZ.b	$ED
	STZ.b	$EE
	LDY.w	#$6800
	JSR.w	!COPY_TILEMAP_FROM_$E7_TO_VRAM
	;******* TRANSFERENCIA DE $1160 BYTES DESDE $7F:98E0 A $7000 DE VRAM
	LDY.w	#$98E0
	STY.b	$E7
	LDA.b	#$7F
	STA.b	$E9
	LDY.w	#$1160
	STY.b	$EB
	LDY.w	#$7000
	JSR.w	!COPY_TILEMAP_FROM_$E7_TO_VRAM
	RTS





	;*************************************************************************************************************************
	;******* 						RUTINA $7E/799B							********
	;*************************************************************************************************************************
DECOMPRESS_GRAPHIC_DATA_$D8F000
	;******* origen de los datos comprimidos $D8:F000
	LDY.w	#$F000
	STY.b	$F3
	LDA.b	#$D8
	STA.b	$F5
DECOMPRESS_DATA_TO_$7F0000
	;******* descomprimimos en $7F:0000
	LDY.w	#$0000
	STY.b	$F6
	LDA.b	#$7F
	STA.b	$F8
	JSR.l	GENERIC_GRAPHIC_DECOMPRESSOR
	RTS






	;*************************************************************************************************************************
	;******* 						RUTINA $7E/79B2							********
	;******* Esta rutina copia la cantidad de $EB datos apuntados por [$E7] a la direccin de VRAM en el registro Y.	********
	;******* El dato se enmascara con el valor en $ED antes de copiarse en VRAM, por lo que probablemente se estar	********
	;******* copiando los datos del tilemap.											********
	;*************************************************************************************************************************
COPY_TILEMAP_FROM_$E7_TO_VRAM
	REP	#$20
	;******* en el registro Y tenemos la direccin de destino en VRAM
	TYA
	STA.l	$002116
	;******* borramos el ndice Y
	TDC
	TAY
Tag_$7E79BB
	;******* leemos 16 bits del tilemap con el puntero origen de los datos
	LDA.b	[$E7],y
	;******* aadimos la parte alta del tilemap
	CLC
	ADC.b	$ED
	;******* guardamos en VRAM
	STA.l	$002118
	INY
	INY
	CPY.b	$EB
	BNE	Tag_$7E79BB
	SEP	#$20
	RTS




	;*************************************************************************************************************************
	;******* 						RUTINA $7E/79CD							********
	;*************************************************************************************************************************
RUTINA_$7E79CD
	REP	#$20
	;******* rellenamos la regin de VRAM $0400 - $0800 con el valor $0787
	LDA.w	#$0400
	STA.l	$002116
	JSR.w	!RUTINA_$7E79E6
	;******* rellenamos la regin de VRAM $0C00 - $1000 con el valor $0787
	LDA.w	#$0C00
	STA.l	$002116
	JSR.w	!RUTINA_$7E79E6
	SEP	#$20
	RTS






	;*************************************************************************************************************************
	;******* 						RUTINA $7E/79E6							********
	;******* Esta rutina escribe 1024 veces en VRAM el valor $0787.								********
	;*************************************************************************************************************************
RUTINA_$7E79E6
	TDC
	TAY
	LDA.w	#$0787
Tag_$7E79EB
	STA.l	$002118
	INY
	CPY.w	#$0400
	BNE	Tag_$7E79EB
	RTS





TABLE_$7E79F6
	.dcw	!TABLE_$7E79FC
	.dcb	$FE


TABLE_$7E79F9
	.dcw	!TABLE_$7E7A31
	.dcb	$FE


TABLE_$7E79FC
	.dcb	$0D
	.dcb	$A8, $00, $00, $31
	.dcb	$88, $20, $04, $31
	.dcb	$A8, $20, $08, $31
	.dcb	$48, $00, $0C, $31
	.dcb	$58, $00, $0E, $31
	.dcb	$48, $20, $2C, $31
	.dcb	$48, $10, $2E, $31
	.dcb	$00, $40, $40, $31
	.dcb	$10, $40, $42, $31
	.dcb	$20, $40, $44, $31
	.dcb	$30, $40, $46, $31
	.dcb	$40, $40, $48, $31
	.dcb	$18, $10, $4A, $31

	
TABLE_$7E7A31
	.dcb	$06
	.dcb	$00, $00, $80, $33
	.dcb	$10, $00, $82, $33
	.dcb	$28, $00, $84, $33
	.dcb	$38, $00, $86, $33
	.dcb	$48, $00, $88, $33
	.dcb	$58, $00, $8A, $33






	;*************************************************************************************************************************
	;******* 						RUTINA $7E/7A4A							********
	;*************************************************************************************************************************
INITIALIZE_VRAM_PATH_TO_NARSHE
	;******* descomprimimos los grficos de $D8F000 y los metemos en $7F:0000
	JSR.w	!DECOMPRESS_GRAPHIC_DATA_$D8F000
	;*************************************************************************************************************************
	;******* COPIAMOS $400 BYTES DESDE $7F:0940 A $7F:B000
	LDY.w	#$0940
	STY.b	$E7
	LDA.b	#$7F
	STA.b	$E9
	LDY.w	#$B000
	STY.b	$EB
	LDA.b	#$7F
	STA.b	$ED
	LDY.w	#$0400
	STY.b	$EF
	JSR.w	!COPY_FROM_$E7_TO_$EB
	;*************************************************************************************************************************
	;******* COPIAMOS EL TILEMAP $940 BYTES DESDE $7F:0000 A VRAM $6400 CON UNA MSCARA DE $0000
	LDY.w	#$0000
	STY.b	$E7
	LDA.b	#$7F
	STA.b	$E9
	LDY.w	#$0940
	STY.b	$EB
	STZ.b	$ED
	STZ.b	$EE
	LDY.w	#$6400
	JSR.w	!COPY_TILEMAP_FROM_$E7_TO_VRAM
	;*************************************************************************************************************************
	;******* COPIAMOS EL TILEMAP $2200 BYTES DESDE $7F:53C0 A VRAM $4000 CON UNA MSCARA DE $0000
	LDY.w	#$53C0
	STY.b	$E7
	LDA.b	#$7F
	STA.b	$E9
	LDY.w	#$2200
	STY.b	$EB
	STZ.b	$ED
	STZ.b	$EE
	LDY.w	#$4000
	JSR.w	!COPY_TILEMAP_FROM_$E7_TO_VRAM
	;*************************************************************************************************************************
	;******* COPIAMOS EL TILEMAP $0800 BYTES DESDE $7F:23C0 A VRAM $7C00 CON UNA MSCARA DE $2000
	LDY.w	#$23C0
	STY.b	$E7
	LDA.b	#$7F
	STA.b	$E9
	LDY.w	#$0800
	STY.b	$EB
	LDY.w	#$2000
	STY.b	$ED
	LDY.w	#$7C00
	JSR.w	!COPY_TILEMAP_FROM_$E7_TO_VRAM
	;******* RELLENAMOS CON $3E87 LAS $220 DIRECCIONES DE VRAM $7C00
	JSR.w	!RUTINA_$7E7ACC
	;*************************************************************************************************************************
	;******* COPIAMOS LA FUENTE PARA LOS CRDITOS DE TAMAO $0370 BYTES DESDE $7F:75C0 A VRAM $7008 CON UNA MSCARA DE $0000
	LDY.w	#$75C0
	STY.b	$E7
	LDA.b	#$7F
	STA.b	$E9
	LDY.w	#$0370
	STY.b	$EB
	STZ.b	$ED
	STZ.b	$EE
	LDY.w	#$7008
	JSR.w	!COPY_TILEMAP_FROM_$E7_TO_VRAM
	RTS





	;*************************************************************************************************************************
	;******* 						RUTINA $7E/7ACC							********
	;******* Esta rutina copia $220 veces el dato $3E87 en la direccin de VRAM $7C00.					********
	;*************************************************************************************************************************
RUTINA_$7E7ACC
	REP	#$20
	LDA.w	#$7C00
	STA.l	$002116
	LDX.w	#$0220
	LDA.w	#$3E87
Tag_$7E7ADB
	STA.l	$002118
	DEX
	BNE	Tag_$7E7ADB
	SEP	#$20
	RTS



TABLE_$7E7AE5
	.dcw	$294A, $1448, $104A, $106A, $106C, $084E, $0451, $0453, $0056, $0078, $009A, $7C1F, $7C1F, $7C1F, $7C1F, $0821


TABLE_$7E7B05
	.dcw	$0000, $6F5A, $5AB5, $4610, $39CD, $1CE7, $0453, $66DE, $565B, $45B4, $352E, $0000, $0000, $0000, $0000, $0000

	
TABLE_$7E7B25
	.dcw	$1063, $1063, $1063, $1063, $1063, $1063, $1063, $1063, $1063, $1063, $1063, $1063, $1063, $1063, $1063, $1063


TABLE_$7E7B45
	.dcw	$1063, $6F9F, $575F, $46FF, $367E, $261E, $3219, $21BB, $159B, $1D76, $1136, $10F1, $08B0, $08AD, $088B, $0050


TABLE_$7E7B65
	.dcw	$2108, $1063, $1063, $1063, $0000, $261E, $159B, $10F1, $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000


TABLE_$7E7B85
	.dcw	$2108, $1063, $1063, $1063, $0000, $261E, $159B, $10F1, $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000
	

TABLE_$7E7BA5
	.dcw	$0000, $1CC6, $1CA5, $1C85, $1884, $1464, $1063, $0000, $1063, $0000, $261E, $159B, $10F1, $565B, $45B4, $352E


TABLE_$7E7BC5
	.dcw	$0000, $66DE, $565B, $45B4, $352E, $3108, $2CE8, $28C7, $24A6, $1CA5, $1884, $1464, $1063, $21BB, $1136, $737F


TABLE_$7E7BE5
	.dcw	$0000, $66DE, $565B, $45B4, $352E, $3108, $2CE8, $28C7, $24A6, $1CA5, $1884, $1464, $1063, $737F, $737F, $737F


TABLE_$7E7C05
	.dcw	$0000, $367E, $1136, $0C42, $0841, $45CD, $3D6A, $3528, $2528, $2CE7, $24E6, $20C5, $18C5, $18A3, $1483, $1063
	
.end
